/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: MainToolBar.java,v 1.16.14.2 2005/06/12 12:04:17 christianfoltin Exp $*/

package freemind.controller;

import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.util.logging.Logger;

import javax.swing.JButton;
import javax.swing.JComboBox;

public class MainToolBar extends FreeMindToolBar {
    private JComboBox zoom;	    
    Controller c;
    String userDefinedZoom;
    private static Logger logger= null;
	
    public MainToolBar(final Controller c) {
    	super();/*_I*/_prof.prof.cnt[11398]++;/*I_*//*_I*/_prof.prof.cnt[11399]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11400]++;/*I_*/this.setRollover(true);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11401]++;/*I_*/this.c = c;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11402]++;/*I_*/if(logger == null) {
            /*_I*/{_prof.prof.cnt[11403]++;/*I_*/logger = c.getFrame().getLogger(this.getClass().getName());/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11404]++;/*I_*/userDefinedZoom = c.getResourceString("user_defined_zoom");/*_I*/}/*I_*/
	/*_I*/_prof.prof.cnt[11405]++;/*I_*/JButton button;

	/*_I*/{_prof.prof.cnt[11406]++;/*I_*/button = add(c.navigationPreviousMap);/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[11407]++;/*I_*/button = add(c.navigationNextMap);/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[11408]++;/*I_*/button = add(c.printDirect);/*_I*/}/*I_*/

        /*_I*/{_prof.prof.cnt[11409]++;/*I_*/zoom = new JComboBox(c.getZooms());/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11410]++;/*I_*/zoom.setSelectedItem("100%");/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11411]++;/*I_*/zoom.addItem(userDefinedZoom);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11412]++;/*I_*/add(zoom);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[11413]++;/*I_*/zoom.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {/*_I*/_prof.prof.cnt[11414]++;/*I_*/
				// todo: dialog with user zoom value, if user zoom is chosen.
				// change proposed by dimitri:
				/*_I*/{_prof.prof.cnt[11415]++;/*I_*/if (e.getStateChange() == ItemEvent.SELECTED) {
					/*_I*/{_prof.prof.cnt[11416]++;/*I_*/setZoomByItem(e.getItem());/*_I*/}/*I_*/
				}/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/
	}

    private void setZoomByItem(Object item) {/*_I*/_prof.prof.cnt[11417]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11418]++;/*I_*/if(((String) item).equals(userDefinedZoom))
            /*_I*/{_prof.prof.cnt[11419]++;/*I_*/return;/*_I*/}/*I_*//*_I*/}/*I_*/ // nothing to do...
       //remove '%' sign
      /*_I*/_prof.prof.cnt[11420]++;/*I_*/String dirty = (String)item;
      /*_I*/_prof.prof.cnt[11421]++;/*I_*/String cleaned = dirty.substring(0,dirty.length()-1);
      //change representation ("125" to 1.25)
      /*_I*/{_prof.prof.cnt[11422]++;/*I_*/c.setZoom(Integer.parseInt(cleaned,10)/100F);/*_I*/}/*I_*/ }

    public void zoomOut() {/*_I*/_prof.prof.cnt[11423]++;/*I_*/
       /*_I*/{_prof.prof.cnt[11424]++;/*I_*/if (zoom.getSelectedIndex() > 0) {
          /*_I*/{_prof.prof.cnt[11425]++;/*I_*/setZoomByItem(zoom.getItemAt(zoom.getSelectedIndex() - 1));/*_I*/}/*I_*/
          /*zoom.setSelectedItem(zoom.getItemAt(zoom.getSelectedIndex() - 1));*/ }/*_I*/}/*I_*/}

    public void zoomIn() {/*_I*/_prof.prof.cnt[11426]++;/*I_*/
       /*_I*/{_prof.prof.cnt[11427]++;/*I_*/if (zoom.getSelectedIndex() < zoom.getItemCount() - 1) {
          /*_I*/{_prof.prof.cnt[11428]++;/*I_*/setZoomByItem(zoom.getItemAt(zoom.getSelectedIndex() + 1));/*_I*/}/*I_*/
          /*zoom.setSelectedItem(zoom.getItemAt(zoom.getSelectedIndex() + 1));*/ }/*_I*/}/*I_*/}

    public String getItemForZoom(float f) {/*_I*/_prof.prof.cnt[11429]++;/*I_*/
       /*_I*/{_prof.prof.cnt[11430]++;/*I_*/return (int)(f*100F)+"%";/*_I*/}/*I_*/ }

    public void setZoomComboBox(float f) {/*_I*/_prof.prof.cnt[11431]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11432]++;/*I_*/logger.info("setZoomComboBox is called with "+f+".");/*_I*/}/*I_*/
        /*_I*/_prof.prof.cnt[11433]++;/*I_*/String toBeFound = getItemForZoom(f);
        /*_I*/{_prof.prof.cnt[11434]++;/*I_*/for(int i = 0; i < zoom.getItemCount(); ++i) {
            /*_I*/{_prof.prof.cnt[11435]++;/*I_*/if(toBeFound.equals((String) zoom.getItemAt(i))) {
                // found
                /*_I*/{_prof.prof.cnt[11436]++;/*I_*/zoom.setSelectedItem(toBeFound);/*_I*/}/*I_*/
                /*_I*/{_prof.prof.cnt[11437]++;/*I_*/return;/*_I*/}/*I_*/
            }/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11438]++;/*I_*/zoom.setSelectedItem(userDefinedZoom);/*_I*/}/*I_*/
    }

    public void setAllActions(boolean enabled) {/*_I*/_prof.prof.cnt[11439]++;/*I_*/
	/*_I*/{_prof.prof.cnt[11440]++;/*I_*/if (zoom != null) {
           /*_I*/{_prof.prof.cnt[11441]++;/*I_*/zoom.setEnabled(enabled);/*_I*/}/*I_*/ }/*_I*/}/*I_*/}

}
