/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2004  Joerg Mueller, Daniel Polansky, Christian Foltin and others.
 *
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Created on 02.05.2004
 */
/*$Id: AbstractXmlAction.java,v 1.1.4.2 2005/05/12 21:31:15 christianfoltin Exp $*/

package freemind.controller.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.Icon;
import javax.xml.bind.JAXBException;

import freemind.modes.ModeController;

/**
 * @author foltin
 *
 */
public abstract class AbstractXmlAction extends FreemindAction {

	private ActorXml actor;

	private ModeController controller;


	protected AbstractXmlAction(String name, Icon icon, ModeController controller) {
		super(name, icon, controller);/*_I*/_prof.prof.cnt[11873]++;/*I_*//*_I*/_prof.prof.cnt[11874]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11875]++;/*I_*/this.controller = controller;/*_I*/}/*I_*/
	}

	/* (non-Javadoc)
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	final public void actionPerformed(ActionEvent arg0) {/*_I*/_prof.prof.cnt[11876]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11877]++;/*I_*/getActionFactory().startTransaction((String) getValue(Action.SHORT_DESCRIPTION));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[11878]++;/*I_*/try {
			/*_I*/{_prof.prof.cnt[11879]++;/*I_*/xmlActionPerformed(arg0);/*_I*/}/*I_*/
		} catch (JAXBException e) {
			// TODO Auto-generated catch block
			/*_I*/{_prof.prof.cnt[11880]++;/*I_*/e.printStackTrace();/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[11881]++;/*I_*/getActionFactory().endTransaction((String) getValue(Action.SHORT_DESCRIPTION));/*_I*/}/*I_*/
	}

	/**
	 * @param arg0
	 */
	protected abstract void xmlActionPerformed(ActionEvent arg0)  throws JAXBException;

	/**
	 * 
	 */
	private ActionFactory getActionFactory() {/*_I*/_prof.prof.cnt[11882]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11883]++;/*I_*/return getModeController().getActionFactory();/*_I*/}/*I_*/
	}

	/**
	 * @return
	 */
	public ModeController getModeController() {/*_I*/_prof.prof.cnt[11884]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11885]++;/*I_*/return controller;/*_I*/}/*I_*/
	}

	public void addActor(ActorXml actor) {/*_I*/_prof.prof.cnt[11886]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11887]++;/*I_*/this.actor = actor;/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[11888]++;/*I_*/if (actor != null) {
			// registration:
			/*_I*/{_prof.prof.cnt[11889]++;/*I_*/getActionFactory().registerActor(actor, actor.getDoActionClass());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/			
	}

	/**
	 * @return
	 */
	public ActorXml getActor() {/*_I*/_prof.prof.cnt[11890]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11891]++;/*I_*/return actor;/*_I*/}/*I_*/
	}

}
