/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2004  Joerg Mueller, Daniel Polansky, Christian Foltin and others.
 *
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Created on 19.07.2004
 */
/*$Id: FreemindAction.java,v 1.1.4.3 2005/05/12 21:31:15 christianfoltin Exp $*/

package freemind.controller.actions;

import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;

import freemind.controller.Controller;
import freemind.main.FreeMind;
import freemind.modes.ModeController;
import freemind.preferences.FreemindPropertyListener;

/**
 * @author foltin
 *
 */
/**
 * @author foltin
 *
 */
public abstract class FreemindAction extends AbstractAction {

    private Icon actionIcon;
    private static Icon enabledIcon;
    private static final String ENABLED_ICON_PATH = "images/icons/button_ok.png";
    private final ModeController modeController;

    /**
     * @param title is a fixed title (no translation is done via resources)
     * @param icon
     * @param modeController
     */
    public FreemindAction(String title, Icon icon,  ModeController modeController) {
        super(title, icon);/*_I*/_prof.prof.cnt[11808]++;/*I_*//*_I*/_prof.prof.cnt[11809]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11810]++;/*I_*/this.actionIcon = icon;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11811]++;/*I_*/this.modeController = modeController;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11812]++;/*I_*/if(enabledIcon == null){
            /*_I*/{_prof.prof.cnt[11813]++;/*I_*/enabledIcon = new ImageIcon(modeController.getFrame().getResource(ENABLED_ICON_PATH));/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        
    }

    /**
     * @param title Title is a resource.
     * @param iconPath is a path to an icon.
     * @param modeController
     */
    public FreemindAction(String title, String iconPath, final ModeController modeController) {
        this(modeController.getController().getResourceString(title), 
            (iconPath==null)?null: new ImageIcon(modeController.getController().getResource(iconPath)), 
                modeController);/*_I*/_prof.prof.cnt[11814]++;/*I_*//*_I*/_prof.prof.cnt[11815]++;/*I_*/
    }
    
    protected void setSelected(JMenuItem menuItem, boolean state) {/*_I*/_prof.prof.cnt[11816]++;/*I_*/
    		// prevents that icons set after the construction is forgotten to
    		// recover.
    		/*_I*/{_prof.prof.cnt[11817]++;/*I_*/if(actionIcon == null && menuItem.getIcon() != enabledIcon) {
    			/*_I*/{_prof.prof.cnt[11818]++;/*I_*/actionIcon = menuItem.getIcon();/*_I*/}/*I_*/
    		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[11819]++;/*I_*/if(state) {
		    /*_I*/{_prof.prof.cnt[11820]++;/*I_*/menuItem.setIcon(enabledIcon);/*_I*/}/*I_*/
		} else {
		    /*_I*/{_prof.prof.cnt[11821]++;/*I_*/menuItem.setIcon(actionIcon);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
    }
    
    public void addActor(ActorXml actor) {/*_I*/_prof.prof.cnt[11822]++;/*I_*/
//      registration:
		/*_I*/{_prof.prof.cnt[11823]++;/*I_*/modeController.getActionFactory().registerActor(actor, actor.getDoActionClass());/*_I*/}/*I_*/
    }
    public ModeController getModeController() {/*_I*/_prof.prof.cnt[11824]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11825]++;/*I_*/return modeController;/*_I*/}/*I_*/
    }
}
