/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: NodeHookAdapter.java,v 1.1.4.3 2005/04/12 21:12:14 christianfoltin Exp $*/
package freemind.extensions;

import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import freemind.modes.MindMap;
import freemind.modes.MindMapNode;

/**
 * @author christianfoltin
 *
 * @file NodeHookAdapter.java 
 * @package freemind.modes
 * */
public abstract class NodeHookAdapter extends HookAdapter implements NodeHook {

	private boolean selfUpdateExpected;

	private MindMap map;

	private MindMapNode node;

	/**
	 * 
	 */
	public NodeHookAdapter() {
		super();/*_I*/_prof.prof.cnt[13054]++;/*I_*//*_I*/_prof.prof.cnt[13055]++;/*I_*/
	}

	/* (non-Javadoc)
	 * @see freemind.modes.NodeHook#invoke()
	 */
	public void invoke(MindMapNode node) {/*_I*/_prof.prof.cnt[13056]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13057]++;/*I_*/logger.finest("invoke(node) called.");/*_I*/}/*I_*/
	}

	/**
	 * @return
	 */
	protected MindMapNode getNode() {/*_I*/_prof.prof.cnt[13058]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13059]++;/*I_*/return node;/*_I*/}/*I_*/
	}

	/**
	 * @param node
	 */
	public void setNode(MindMapNode node) {/*_I*/_prof.prof.cnt[13060]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13061]++;/*I_*/this.node = node;/*_I*/}/*I_*/
	}

	/**
	 * @return
	 */
	protected MindMap getMap() {/*_I*/_prof.prof.cnt[13062]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13063]++;/*I_*/return map;/*_I*/}/*I_*/
	}

	/**
	 * @param node
	 */
	protected void nodeChanged(MindMapNode node) {/*_I*/_prof.prof.cnt[13064]++;/*I_*/
//		if(node == getNode()) {
//			setSelfUpdate(true);
//		}
		// fc, 29.2.2004 (yes, this day exists!)
		// this is not nice. The node should know itself, if it is updateable, but...
		/*_I*/{_prof.prof.cnt[13065]++;/*I_*/if(node.getViewer() != null)
			/*_I*/{_prof.prof.cnt[13066]++;/*I_*/getController().nodeChanged(node);/*_I*/}/*I_*//*_I*/}/*I_*/
//		setSelfUpdate(false);
	}

	/**
	 * @param value
	 */
	protected void setToolTip(String key, String value) {/*_I*/_prof.prof.cnt[13067]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13068]++;/*I_*/setToolTip(getNode(), key, value);/*_I*/}/*I_*/
	}
	protected void setToolTip(MindMapNode node, String key, String value) {/*_I*/_prof.prof.cnt[13069]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13070]++;/*I_*/getController().setToolTip(node, key, value);/*_I*/}/*I_*/
	}

	

	/**
	 * @param map
	 */
	public void setMap(MindMap map) {/*_I*/_prof.prof.cnt[13071]++;/*I_*/
		/*_I*/{_prof.prof.cnt[13072]++;/*I_*/this.map = map;/*_I*/}/*I_*/
	}

}
