/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: FreeMindApplet.java,v 1.18.14.12 2005/08/19 20:11:29 christianfoltin Exp $*/

package freemind.main;

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.EventQueue;
import java.io.File;
import java.io.InputStream;
import java.lang.reflect.InvocationTargetException;
import java.net.URL;
import java.util.Enumeration;
import java.util.Properties;
import java.util.PropertyResourceBundle;
import java.util.ResourceBundle;

import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JScrollPane;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import freemind.controller.Controller;
import freemind.controller.MenuBar;
import freemind.extensions.HookFactory;
import freemind.view.mindmapview.MapView;

public class FreeMindApplet extends JApplet implements FreeMindMain {

    private HookFactory nodeHookFactory;
	public static final String version = "0.8.0";
    //    public static final String defaultPropsURL;
    public URL defaultPropsURL;
    public static Properties defaultProps;
    public static Properties userProps;
    private JScrollPane scrollPane = new JScrollPane();
    private MenuBar menuBar;
    private PropertyResourceBundle resources;
    private JLabel status = new JLabel();
    Controller c;//the one and only controller


    public FreeMindApplet() {/*_I*/_prof.prof.cnt[1240]++;/*I_*/
    }//Constructor

    public boolean isApplet() {/*_I*/_prof.prof.cnt[1241]++;/*I_*/
       /*_I*/{_prof.prof.cnt[1242]++;/*I_*/return true;/*_I*/}/*I_*/ }

    public File getPatternsFile() {/*_I*/_prof.prof.cnt[1243]++;/*I_*/
       /*_I*/{_prof.prof.cnt[1244]++;/*I_*/return null;/*_I*/}/*I_*/ }

    public Controller getController() {/*_I*/_prof.prof.cnt[1245]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1246]++;/*I_*/return c;/*_I*/}/*I_*/
    }

    public MapView getView() {/*_I*/_prof.prof.cnt[1247]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1248]++;/*I_*/return c.getView();/*_I*/}/*I_*/
    }

    public void setView(MapView view) {/*_I*/_prof.prof.cnt[1249]++;/*I_*/
 	/*_I*/{_prof.prof.cnt[1250]++;/*I_*/scrollPane.setViewportView(view);/*_I*/}/*I_*/
    }

    public MenuBar getFreeMindMenuBar() {/*_I*/_prof.prof.cnt[1251]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1252]++;/*I_*/return menuBar;/*_I*/}/*I_*/
    }

    public Container getViewport() {/*_I*/_prof.prof.cnt[1253]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1254]++;/*I_*/return scrollPane.getViewport();/*_I*/}/*I_*/
    }

    public String getFreemindVersion() {/*_I*/_prof.prof.cnt[1255]++;/*I_*/
        /*_I*/{_prof.prof.cnt[1256]++;/*I_*/return version;/*_I*/}/*I_*/
    }

    // "dummy" implementation of the interface (PN)
    public int getWinHeight() {/*_I*/_prof.prof.cnt[1257]++;/*I_*/
      /*_I*/{_prof.prof.cnt[1258]++;/*I_*/return getRootPane().getHeight();/*_I*/}/*I_*/
    }
    public int getWinWidth() {/*_I*/_prof.prof.cnt[1259]++;/*I_*/
      /*_I*/{_prof.prof.cnt[1260]++;/*I_*/return getRootPane().getWidth();/*_I*/}/*I_*/
    }
    public int getWinState() {/*_I*/_prof.prof.cnt[1261]++;/*I_*/
      /*_I*/{_prof.prof.cnt[1262]++;/*I_*/return 6;/*_I*/}/*I_*/  
    }

    /**
     * Returns the ResourceBundle with the current language
     */
    public ResourceBundle getResources() {/*_I*/_prof.prof.cnt[1263]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1264]++;/*I_*/if (resources==null) {
	    /*_I*/_prof.prof.cnt[1265]++;/*I_*/String lang = userProps.getProperty("language");
	    /*_I*/{_prof.prof.cnt[1266]++;/*I_*/try {
		/*_I*/_prof.prof.cnt[1267]++;/*I_*/URL myurl = getResource("Resources_"+lang.trim()+".properties");
		/*_I*/_prof.prof.cnt[1268]++;/*I_*/InputStream in = myurl.openStream();
		/*_I*/{_prof.prof.cnt[1269]++;/*I_*/resources = new PropertyResourceBundle(in);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[1270]++;/*I_*/in.close();/*_I*/}/*I_*/
	    } catch (Exception ex) {
		/*_I*/{_prof.prof.cnt[1271]++;/*I_*/System.err.println("Error loading Resources");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[1272]++;/*I_*/return null;/*_I*/}/*I_*/
	    }/*_I*/}/*I_*/
	}/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[1273]++;/*I_*/return resources;/*_I*/}/*I_*/
    }

    public String getResourceString(String resource) {/*_I*/_prof.prof.cnt[1274]++;/*I_*/
        /*_I*/{_prof.prof.cnt[1275]++;/*I_*/try {
            /*_I*/{_prof.prof.cnt[1276]++;/*I_*/return getResources().getString(resource);/*_I*/}/*I_*/
        } catch (Exception ex) {
            /*_I*/{_prof.prof.cnt[1277]++;/*I_*/System.err.println("Warning - resource string not found:"
                    + resource);/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[1278]++;/*I_*/return resource;/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
    }

    public String getProperty(String key) {/*_I*/_prof.prof.cnt[1279]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1280]++;/*I_*/return userProps.getProperty(key);/*_I*/}/*I_*/
    }
    
	public int getIntProperty(String key, int defaultValue){/*_I*/_prof.prof.cnt[1281]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1282]++;/*I_*/try{
			/*_I*/{_prof.prof.cnt[1283]++;/*I_*/return Integer.parseInt(getProperty(key));/*_I*/}/*I_*/
		}
		catch(NumberFormatException nfe){
			/*_I*/{_prof.prof.cnt[1284]++;/*I_*/return defaultValue;/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	}

 
	public Properties getProperties() {/*_I*/_prof.prof.cnt[1285]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1286]++;/*I_*/return userProps;/*_I*/}/*I_*/
	}
   
    public void setProperty(String key, String value) {/*_I*/_prof.prof.cnt[1287]++;/*I_*/
    }

    public String getFreemindDirectory() {/*_I*/_prof.prof.cnt[1288]++;/*I_*//*_I*/{_prof.prof.cnt[1289]++;/*I_*/return null;/*_I*/}/*I_*/};

    static int iMaxNodeWidth = 0;
	
    static public int getMaxNodeWidth(){/*_I*/_prof.prof.cnt[1290]++;/*I_*/
       /*_I*/{_prof.prof.cnt[1291]++;/*I_*/if (iMaxNodeWidth == 0){
          /*_I*/{_prof.prof.cnt[1292]++;/*I_*/try{
             /*_I*/{_prof.prof.cnt[1293]++;/*I_*/iMaxNodeWidth = Integer.parseInt(userProps.getProperty("max_node_width"));/*_I*/}/*I_*/	
          }
          catch (NumberFormatException nfe) {
             /*_I*/{_prof.prof.cnt[1294]++;/*I_*/iMaxNodeWidth = Integer.parseInt(userProps.getProperty("el__max_default_window_width"));/*_I*/}/*I_*/
          }/*_I*/}/*I_*/
       }/*_I*/}/*I_*/
       /*_I*/{_prof.prof.cnt[1295]++;/*I_*/return iMaxNodeWidth;/*_I*/}/*I_*/
    }

    public void saveProperties() {/*_I*/_prof.prof.cnt[1296]++;/*I_*/
    }

    public void setTitle(String title) {/*_I*/_prof.prof.cnt[1297]++;/*I_*/
    }

    public void out (String msg) {/*_I*/_prof.prof.cnt[1298]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1299]++;/*I_*/status.setText(msg);/*_I*/}/*I_*/
    }

    public void err (String msg) {/*_I*/_prof.prof.cnt[1300]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1301]++;/*I_*/status.setText("ERROR: "+msg);/*_I*/}/*I_*/
    }

    public void openDocument(URL doc) throws Exception {/*_I*/_prof.prof.cnt[1302]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1303]++;/*I_*/getAppletContext().showDocument(doc,"_blank");/*_I*/}/*I_*/
    }

    public void start() {/*_I*/_prof.prof.cnt[1304]++;/*I_*/
       // Make sure the map is centered at the very beginning.
       /*_I*/{_prof.prof.cnt[1305]++;/*I_*/try {
          /*_I*/{_prof.prof.cnt[1306]++;/*I_*/if (getView() != null) {
             /*_I*/{_prof.prof.cnt[1307]++;/*I_*/getView().moveToRoot();/*_I*/}/*I_*/ }
          else {
             /*_I*/{_prof.prof.cnt[1308]++;/*I_*/System.err.println("View is null.");/*_I*/}/*I_*/ }/*_I*/}/*I_*/}
       catch (Exception e) { /*_I*/{_prof.prof.cnt[1309]++;/*I_*/e.printStackTrace();/*_I*/}/*I_*/ }/*_I*/}/*I_*/
    }

   /*
    public void stop() {
    }

    public void destroy() {
    }
    */

    public void setWaitingCursor(boolean waiting) {/*_I*/_prof.prof.cnt[1310]++;/*I_*/
       /*_I*/{_prof.prof.cnt[1311]++;/*I_*/if (waiting) {
          /*_I*/{_prof.prof.cnt[1312]++;/*I_*/getRootPane().getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));/*_I*/}/*I_*/
          /*_I*/{_prof.prof.cnt[1313]++;/*I_*/getRootPane().getGlassPane().setVisible(true);/*_I*/}/*I_*/ }
       else {
          /*_I*/{_prof.prof.cnt[1314]++;/*I_*/getRootPane().getGlassPane().setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));/*_I*/}/*I_*/
          /*_I*/{_prof.prof.cnt[1315]++;/*I_*/getRootPane().getGlassPane().setVisible(false);/*_I*/}/*I_*/ }/*_I*/}/*I_*/}

    public URL getResource(String name) {/*_I*/_prof.prof.cnt[1316]++;/*I_*/
	/*_I*/{_prof.prof.cnt[1317]++;/*I_*/return this.getClass().getResource("/"+name);/*_I*/}/*I_*/
    }

    public java.util.logging.Logger getLogger(String forClass) {/*_I*/_prof.prof.cnt[1318]++;/*I_*/
        /* Applet logging is anonymous due to security reasons. (Calling a named logger is answered with a security exception).*/
        /*_I*/{_prof.prof.cnt[1319]++;/*I_*/return java.util.logging.Logger.getAnonymousLogger();/*_I*/}/*I_*/
    }

    public void init() {/*_I*/_prof.prof.cnt[1320]++;/*I_*/
	/*_I*/_prof.prof.cnt[1321]++;/*I_*/JRootPane rootPane = createRootPane();
 	//load properties
	/*_I*/{_prof.prof.cnt[1322]++;/*I_*/defaultPropsURL = getResource("freemind.properties");/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[1323]++;/*I_*/try {
	    //load properties
	    /*_I*/{_prof.prof.cnt[1324]++;/*I_*/defaultProps = new Properties();/*_I*/}/*I_*/
	    /*_I*/_prof.prof.cnt[1325]++;/*I_*/InputStream in = defaultPropsURL.openStream();
	    /*_I*/{_prof.prof.cnt[1326]++;/*I_*/defaultProps.load(in);/*_I*/}/*I_*/
 	    /*_I*/{_prof.prof.cnt[1327]++;/*I_*/in.close();/*_I*/}/*I_*/
	    /*_I*/{_prof.prof.cnt[1328]++;/*I_*/userProps = defaultProps;/*_I*/}/*I_*/
 	} catch (Exception ex) {
           /*_I*/{_prof.prof.cnt[1329]++;/*I_*/System.err.println("Could not load properties.");/*_I*/}/*I_*/
 	}/*_I*/}/*I_*/

        //try to overload some properties with given command-line (html tag) Arguments
        /*_I*/_prof.prof.cnt[1330]++;/*I_*/Enumeration allKeys = userProps.propertyNames();
        /*_I*/{_prof.prof.cnt[1331]++;/*I_*/while (allKeys.hasMoreElements()) {
           /*_I*/_prof.prof.cnt[1332]++;/*I_*/String key = (String)allKeys.nextElement();
           /*_I*/_prof.prof.cnt[1333]++;/*I_*/String val = getParameter(key);
           //	    System.out.println("Got prop:"+key+":"+val);
           /*_I*/{_prof.prof.cnt[1334]++;/*I_*/if (val != null  &&  val != "") {
              /*_I*/{_prof.prof.cnt[1335]++;/*I_*/userProps.setProperty(key,val);/*_I*/}/*I_*/
           }/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
            
        //set Look&Feel
        /*_I*/_prof.prof.cnt[1336]++;/*I_*/String lookAndFeel = "";
        /*_I*/{_prof.prof.cnt[1337]++;/*I_*/try {
           /*_I*/{_prof.prof.cnt[1338]++;/*I_*/lookAndFeel = userProps.getProperty("lookandfeel");/*_I*/}/*I_*/
           /*_I*/{_prof.prof.cnt[1339]++;/*I_*/if (lookAndFeel.equals("windows")) {
              /*_I*/{_prof.prof.cnt[1340]++;/*I_*/UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[1341]++;/*I_*/if (lookAndFeel.equals("motif")) {
              /*_I*/{_prof.prof.cnt[1342]++;/*I_*/UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[1343]++;/*I_*/if (lookAndFeel.equals("mac")) {
              //Only available on macOS
              /*_I*/{_prof.prof.cnt[1344]++;/*I_*/UIManager.setLookAndFeel("javax.swing.plaf.mac.MacLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[1345]++;/*I_*/if (lookAndFeel.equals("metal")) {
              /*_I*/{_prof.prof.cnt[1346]++;/*I_*/UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");/*_I*/}/*I_*/
           } else /*_I*/{_prof.prof.cnt[1347]++;/*I_*/if (lookAndFeel.equals("gtk")) {
	   	        /*_I*/{_prof.prof.cnt[1348]++;/*I_*/UIManager
	                    .setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");/*_I*/}/*I_*/
	        } else /*_I*/{_prof.prof.cnt[1349]++;/*I_*/if (lookAndFeel.equals("nothing")) {
	        } else /*_I*/{_prof.prof.cnt[1350]++;/*I_*/if (lookAndFeel.indexOf('.') != -1) { // string contains a
	            // dot
	            /*_I*/{_prof.prof.cnt[1351]++;/*I_*/UIManager.setLookAndFeel(lookAndFeel);/*_I*/}/*I_*/
	            //	         we assume class name
	        } else {
               // default.
               /*_I*/{_prof.prof.cnt[1352]++;/*I_*/UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());/*_I*/}/*I_*/
           }/*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*/
        } catch (Exception ex) {
           /*_I*/{_prof.prof.cnt[1353]++;/*I_*/System.err.println("Error while setting Look&Feel"+lookAndFeel);/*_I*/}/*I_*/
        }/*_I*/}/*I_*/

 	//Layout everything
 	/*_I*/{_prof.prof.cnt[1354]++;/*I_*/getContentPane().setLayout( new BorderLayout() );/*_I*/}/*I_*/

	/*_I*/{_prof.prof.cnt[1355]++;/*I_*/c = new Controller(this);/*_I*/}/*I_*/

	/*_I*/{_prof.prof.cnt[1356]++;/*I_*/if (Tools.safeEquals(getProperty("antialiasEdges"), "true")) {
           /*_I*/{_prof.prof.cnt[1357]++;/*I_*/c.setAntialiasEdges(true);/*_I*/}/*I_*/ }/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[1358]++;/*I_*/if (Tools.safeEquals(getProperty("antialiasAll"), "true")) {
           /*_I*/{_prof.prof.cnt[1359]++;/*I_*/c.setAntialiasAll(true);/*_I*/}/*I_*/ }/*_I*/}/*I_*/

 	//Create the MenuBar
	/*_I*/{_prof.prof.cnt[1360]++;/*I_*/menuBar = new MenuBar(c);/*_I*/}/*I_*/ //new MenuBar(c);
 	/*_I*/{_prof.prof.cnt[1361]++;/*I_*/setJMenuBar(menuBar);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[1362]++;/*I_*/c.setToolbarVisible(false);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[1363]++;/*I_*/c.setMenubarVisible(false);/*_I*/}/*I_*/

	//Create the scroll pane.
		
	/*_I*/{_prof.prof.cnt[1364]++;/*I_*/getContentPane().add( scrollPane, BorderLayout.CENTER );/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[1365]++;/*I_*/getContentPane().add( status, BorderLayout.SOUTH );/*_I*/}/*I_*/

        /*_I*/{_prof.prof.cnt[1366]++;/*I_*/SwingUtilities.updateComponentTreeUI(this);/*_I*/}/*I_*/ // Propagate LookAndFeel to JComponents

       	// wait until AWT thread starts
		/*_I*/{_prof.prof.cnt[1367]++;/*I_*/if (! EventQueue.isDispatchThread()){
			/*_I*/{_prof.prof.cnt[1368]++;/*I_*/try {
                /*_I*/{_prof.prof.cnt[1369]++;/*I_*/EventQueue.invokeAndWait(new Runnable() {public void run(){/*_I*/_prof.prof.cnt[1370]++;/*I_*/};});/*_I*/}/*I_*/
            } catch (InterruptedException e) {
                /*_I*/{_prof.prof.cnt[1371]++;/*I_*/e.printStackTrace();/*_I*/}/*I_*/
            } catch (InvocationTargetException e) {
                /*_I*/{_prof.prof.cnt[1372]++;/*I_*/e.printStackTrace();/*_I*/}/*I_*/
            }/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	/*_I*/{_prof.prof.cnt[1373]++;/*I_*/c.changeToMode(getProperty("initial_mode"));/*_I*/}/*I_*/
    }
	/* (non-Javadoc)
	 * @see freemind.main.FreeMindMain#getHookFactory()
	 */
	public HookFactory getHookFactory() {/*_I*/_prof.prof.cnt[1374]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1375]++;/*I_*/if(nodeHookFactory == null) {
			/*_I*/{_prof.prof.cnt[1376]++;/*I_*/nodeHookFactory = new HookFactory(this);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[1377]++;/*I_*/return nodeHookFactory;/*_I*/}/*I_*/
	}

	/* (non-Javadoc)
	 * @see freemind.main.FreeMindMain#getSouthPanel()
	 */
	public JPanel getSouthPanel() {/*_I*/_prof.prof.cnt[1378]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1379]++;/*I_*/return null;/*_I*/}/*I_*/
	}

	/* (non-Javadoc)
	 * @see freemind.main.FreeMindMain#getJFrame()
	 */
	public JFrame getJFrame() {/*_I*/_prof.prof.cnt[1380]++;/*I_*/
		/*_I*/{_prof.prof.cnt[1381]++;/*I_*/throw new IllegalArgumentException("The applet has no frames");/*_I*/}/*I_*/
	}

}
