/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: ArrowLinkAdapter.java,v 1.4.18.5 2005/01/10 07:41:27 christianfoltin Exp $*/

package freemind.modes;
import freemind.modes.LinkAdapter;
import freemind.main.FreeMindMain;
import freemind.main.Tools;
import freemind.main.XMLElement;

import java.awt.Point;

public abstract class ArrowLinkAdapter extends LinkAdapter implements MindMapArrowLink {

    /** the zero is the start point of the line;*/
    protected Point startInclination; 
    /** the zero is the start point of the line;*/
    protected Point endInclination; 
    protected String startArrow; 
    protected String endArrow;
    protected boolean showControlPointsFlag;


    public ArrowLinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame)  {
        super(source, target, frame, "standardlinkcolor", "standardlinkstyle");/*_I*/_prof.prof.cnt[11132]++;/*I_*//*_I*/_prof.prof.cnt[11133]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11134]++;/*I_*/startArrow = "None";/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11135]++;/*I_*/endArrow = "Default";/*_I*/}/*I_*/
    }

    public Point getStartInclination() {/*_I*/_prof.prof.cnt[11136]++;/*I_*/
        /*_I*/{_prof.prof.cnt[11137]++;/*I_*/if(startInclination == null) 
            /*_I*/{_prof.prof.cnt[11138]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11139]++;/*I_*/return new Point(startInclination);/*_I*/}/*I_*/ 
    }
    public Point getEndInclination() {/*_I*/_prof.prof.cnt[11140]++;/*I_*/ 
        /*_I*/{_prof.prof.cnt[11141]++;/*I_*/if(endInclination == null) 
            /*_I*/{_prof.prof.cnt[11142]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11143]++;/*I_*/return new Point(endInclination);/*_I*/}/*I_*/ 
    } 
    public String getStartArrow() {/*_I*/_prof.prof.cnt[11144]++;/*I_*/ /*_I*/{_prof.prof.cnt[11145]++;/*I_*/return startArrow;/*_I*/}/*I_*/ } 
    public String getEndArrow() {/*_I*/_prof.prof.cnt[11146]++;/*I_*/ /*_I*/{_prof.prof.cnt[11147]++;/*I_*/return endArrow;/*_I*/}/*I_*/ }

    public void  setStartInclination(Point startInclination) {/*_I*/_prof.prof.cnt[11148]++;/*I_*/  /*_I*/{_prof.prof.cnt[11149]++;/*I_*/this.startInclination=startInclination;/*_I*/}/*I_*/ }
    public void  setEndInclination(Point endInclination) {/*_I*/_prof.prof.cnt[11150]++;/*I_*/  /*_I*/{_prof.prof.cnt[11151]++;/*I_*/this.endInclination=endInclination;/*_I*/}/*I_*/ } 
    public void  setStartArrow(String startArrow) {/*_I*/_prof.prof.cnt[11152]++;/*I_*/  
        /*_I*/{_prof.prof.cnt[11153]++;/*I_*/if(startArrow == null || startArrow.toUpperCase().equals("NONE")) {
            /*_I*/{_prof.prof.cnt[11154]++;/*I_*/this.startArrow = "None";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[11155]++;/*I_*/return;/*_I*/}/*I_*/
        } else /*_I*/{_prof.prof.cnt[11156]++;/*I_*/if(startArrow.toUpperCase().equals("DEFAULT")) {
            /*_I*/{_prof.prof.cnt[11157]++;/*I_*/this.startArrow = "Default";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[11158]++;/*I_*/return;/*_I*/}/*I_*/
        }/*_I*/}/*I_*//*_I*/}/*I_*/
        // dont change:
        /*_I*/{_prof.prof.cnt[11159]++;/*I_*/System.err.println("Cannot set the start arrow type to " + startArrow);/*_I*/}/*I_*/
    } 
    public void  setEndArrow(String endArrow) {/*_I*/_prof.prof.cnt[11160]++;/*I_*/  
        /*_I*/{_prof.prof.cnt[11161]++;/*I_*/if(endArrow == null || endArrow.toUpperCase().equals("NONE")) {
            /*_I*/{_prof.prof.cnt[11162]++;/*I_*/this.endArrow = "None";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[11163]++;/*I_*/return;/*_I*/}/*I_*/
        } else /*_I*/{_prof.prof.cnt[11164]++;/*I_*/if(endArrow.toUpperCase().equals("DEFAULT")) {
            /*_I*/{_prof.prof.cnt[11165]++;/*I_*/this.endArrow = "Default";/*_I*/}/*I_*/
            /*_I*/{_prof.prof.cnt[11166]++;/*I_*/return;/*_I*/}/*I_*/
        }/*_I*/}/*I_*//*_I*/}/*I_*/
        // dont change:
        /*_I*/{_prof.prof.cnt[11167]++;/*I_*/System.err.println("Cannot set the end arrow type to " + endArrow);/*_I*/}/*I_*/
    }

    public Object clone() {/*_I*/_prof.prof.cnt[11168]++;/*I_*/
        /*_I*/_prof.prof.cnt[11169]++;/*I_*/ArrowLinkAdapter arrowLink = (ArrowLinkAdapter) super.clone();
        // now replace the points:
        /*_I*/{_prof.prof.cnt[11170]++;/*I_*/arrowLink.startInclination = (startInclination==null)?null:new Point(startInclination.x, startInclination.y);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11171]++;/*I_*/arrowLink.endInclination = (endInclination==null)?null:new Point(endInclination.x, endInclination.y);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11172]++;/*I_*/arrowLink.startArrow = (startArrow==null)?null:new String(startArrow);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11173]++;/*I_*/arrowLink.endArrow = (endArrow==null)?null:new String(endArrow);/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11174]++;/*I_*/return arrowLink;/*_I*/}/*I_*/
    }
    
	public void showControlPoints(boolean bShowControlPointsFlag){/*_I*/_prof.prof.cnt[11175]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11176]++;/*I_*/showControlPointsFlag = bShowControlPointsFlag;/*_I*/}/*I_*/
	}
	
	public boolean getShowControlPointsFlag(){/*_I*/_prof.prof.cnt[11177]++;/*I_*/
		/*_I*/{_prof.prof.cnt[11178]++;/*I_*/return showControlPointsFlag;/*_I*/}/*I_*/
	}

    public XMLElement save() {/*_I*/_prof.prof.cnt[11179]++;/*I_*/
        /*_I*/_prof.prof.cnt[11180]++;/*I_*/XMLElement arrowLink = new XMLElement();
        /*_I*/{_prof.prof.cnt[11181]++;/*I_*/arrowLink.setName("arrowlink");/*_I*/}/*I_*/
    
        /*_I*/{_prof.prof.cnt[11182]++;/*I_*/if (style != null) {
            /*_I*/{_prof.prof.cnt[11183]++;/*I_*/arrowLink.setAttribute("STYLE",style);/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11184]++;/*I_*/if (getUniqueID() != null) {
            /*_I*/{_prof.prof.cnt[11185]++;/*I_*/arrowLink.setAttribute("ID",getUniqueID());/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11186]++;/*I_*/if (color != null) {
            /*_I*/{_prof.prof.cnt[11187]++;/*I_*/arrowLink.setAttribute("COLOR",Tools.colorToXml(color));/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11188]++;/*I_*/if(getDestinationLabel() != null) {
            /*_I*/{_prof.prof.cnt[11189]++;/*I_*/arrowLink.setAttribute("DESTINATION",getDestinationLabel());/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11190]++;/*I_*/if(getReferenceText() != null) {
            /*_I*/{_prof.prof.cnt[11191]++;/*I_*/arrowLink.setAttribute("REFERENCETEXT",getReferenceText());/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11192]++;/*I_*/if(getStartInclination() != null) {
            /*_I*/{_prof.prof.cnt[11193]++;/*I_*/arrowLink.setAttribute("STARTINCLINATION",Tools.PointToXml(getStartInclination()));/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11194]++;/*I_*/if(getEndInclination() != null) {
            /*_I*/{_prof.prof.cnt[11195]++;/*I_*/arrowLink.setAttribute("ENDINCLINATION",Tools.PointToXml(getEndInclination()));/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11196]++;/*I_*/if(getStartArrow() != null)
            /*_I*/{_prof.prof.cnt[11197]++;/*I_*/arrowLink.setAttribute("STARTARROW",(getStartArrow()));/*_I*/}/*I_*//*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11198]++;/*I_*/if(getEndArrow() != null)
            /*_I*/{_prof.prof.cnt[11199]++;/*I_*/arrowLink.setAttribute("ENDARROW",(getEndArrow()));/*_I*/}/*I_*//*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[11200]++;/*I_*/return arrowLink;/*_I*/}/*I_*/
    }

}
