/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2001  Joerg Mueller <joergmueller@bigfoot.com>
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/*$Id: LinkAdapter.java,v 1.3.18.2 2005/06/14 20:38:07 christianfoltin Exp $*/

package freemind.modes;
import java.awt.Color;

import freemind.controller.Controller;
import freemind.modes.LineAdapter;
import freemind.modes.LineAdapter.LineAdapterListener;
import freemind.main.FreeMind;
import freemind.main.FreeMindMain;

public abstract class LinkAdapter extends LineAdapter implements MindMapLink {

    private static Color standardColor = null;
    private static String standardStyle = null;
    private static LineAdapterListener listener = null;

    String destinationLabel;
    String referenceText;
    MindMapNode source;
    private String uniqueID;

    public LinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame)  {
        this(source,target, frame, FreeMind.RESOURCES_LINK_COLOR, "standardlinkstyle");/*_I*/_prof.prof.cnt[9774]++;/*I_*//*_I*/_prof.prof.cnt[9775]++;/*I_*/
    }

    /** For derived classes.*/
    protected  LinkAdapter(MindMapNode source,MindMapNode target,FreeMindMain frame, String standardColorPropertyString, String standardStylePropertyString)  {
        super(target, frame, standardColorPropertyString, standardStylePropertyString);/*_I*/_prof.prof.cnt[9776]++;/*I_*//*_I*/_prof.prof.cnt[9777]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9778]++;/*I_*/this.source=source;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[9779]++;/*I_*/destinationLabel = null;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[9780]++;/*I_*/referenceText = null;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[9781]++;/*I_*/if(listener == null) {
            /*_I*/{_prof.prof.cnt[9782]++;/*I_*/listener = new LineAdapterListener();/*_I*/}/*I_*/ 
            /*_I*/{_prof.prof.cnt[9783]++;/*I_*/Controller.addPropertyChangeListener(listener);/*_I*/}/*I_*/
        }/*_I*/}/*I_*/
    }

    public String getDestinationLabel() {/*_I*/_prof.prof.cnt[9784]++;/*I_*/ /*_I*/{_prof.prof.cnt[9785]++;/*I_*/return destinationLabel;/*_I*/}/*I_*/ }
    public String getReferenceText(){/*_I*/_prof.prof.cnt[9786]++;/*I_*/ /*_I*/{_prof.prof.cnt[9787]++;/*I_*/return referenceText;/*_I*/}/*I_*/ }
    public MindMapNode getSource() {/*_I*/_prof.prof.cnt[9788]++;/*I_*/ /*_I*/{_prof.prof.cnt[9789]++;/*I_*/return source;/*_I*/}/*I_*/}
    
    public void setSource(MindMapNode source) {/*_I*/_prof.prof.cnt[9790]++;/*I_*//*_I*/{_prof.prof.cnt[9791]++;/*I_*/this.source=source;/*_I*/}/*I_*/}
    public void setDestinationLabel(String destinationLabel) {/*_I*/_prof.prof.cnt[9792]++;/*I_*/ /*_I*/{_prof.prof.cnt[9793]++;/*I_*/this.destinationLabel = destinationLabel;/*_I*/}/*I_*/ }
    public void setReferenceText(String referenceText) {/*_I*/_prof.prof.cnt[9794]++;/*I_*/ /*_I*/{_prof.prof.cnt[9795]++;/*I_*/this.referenceText = referenceText;/*_I*/}/*I_*/ }

//     public Object clone() {
//         try {
//             return super.clone();
//         } catch(java.lang.CloneNotSupportedException e) {
//             return null;
//         }
//     }


    /**
     * @return Returns the uniqueID.
     */
    public String getUniqueID() {/*_I*/_prof.prof.cnt[9796]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9797]++;/*I_*/return uniqueID;/*_I*/}/*I_*/
    }
    /**
     * @param uniqueID The uniqueID to set.
     */
    public void setUniqueID(String uniqueID) {/*_I*/_prof.prof.cnt[9798]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9799]++;/*I_*/this.uniqueID = uniqueID;/*_I*/}/*I_*/
    }
    protected Color getStandardColor() {/*_I*/_prof.prof.cnt[9800]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9801]++;/*I_*/return standardColor;/*_I*/}/*I_*/
    }
    protected void setStandardColor(Color standardColor) {/*_I*/_prof.prof.cnt[9802]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9803]++;/*I_*/LinkAdapter.standardColor = standardColor;/*_I*/}/*I_*/
    }
    protected String getStandardStyle() {/*_I*/_prof.prof.cnt[9804]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9805]++;/*I_*/return standardStyle;/*_I*/}/*I_*/
    }
    protected void setStandardStyle(String standardStyle) {/*_I*/_prof.prof.cnt[9806]++;/*I_*/
        /*_I*/{_prof.prof.cnt[9807]++;/*I_*/LinkAdapter.standardStyle = standardStyle;/*_I*/}/*I_*/
    }
}
