/*
 * FreeMind - A Program for creating and viewing Mindmaps Copyright (C)
 * 2000-2001 Joerg Mueller <joergmueller@bigfoot.com> See COPYING for Details
 * 
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 2 of the License, or (at your option) any later
 * version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 59 Temple
 * Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/*
 * $Id: MindMapPopupMenu.java,v 1.12.18.2 2005/01/04 10:39:41 christianfoltin
 * Exp $
 */

package freemind.modes.mindmapmode;

import java.util.HashSet;
import java.util.Iterator;
import java.util.logging.Logger;

import javax.swing.JPopupMenu;
import javax.swing.event.MenuListener;

import freemind.controller.StructuredMenuHolder;

public class MindMapPopupMenu extends JPopupMenu implements
		StructuredMenuHolder.MenuEventSupplier {

	private HashSet listeners = new HashSet();
	
	private static final String MINDMAPMODE_POPUP = "mindmapmode_popup/";

	private static Logger logger = null;

	private MindMapController c;

	public MindMapPopupMenu(MindMapController c) {/*_I*/_prof.prof.cnt[9644]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9645]++;/*I_*/this.c = c;/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9646]++;/*I_*/if (logger == null) {
			/*_I*/{_prof.prof.cnt[9647]++;/*I_*/logger = c.getFrame().getLogger(this.getClass().getName());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	}

	/**
	 * @param holder
	 */
	public void update(StructuredMenuHolder holder) {/*_I*/_prof.prof.cnt[9648]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9649]++;/*I_*/this.removeAll();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9650]++;/*I_*/c.createPatternSubMenu(holder, MINDMAPMODE_POPUP);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9651]++;/*I_*/c.addIconsToMenu(holder, MINDMAPMODE_POPUP+"icons/");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9652]++;/*I_*/holder.updateMenus(this, MINDMAPMODE_POPUP);/*_I*/}/*I_*/
		
	}

	protected void firePopupMenuWillBecomeVisible() {/*_I*/_prof.prof.cnt[9653]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9654]++;/*I_*/super.firePopupMenuWillBecomeVisible();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9655]++;/*I_*/logger.info("Popup firePopupMenuWillBecomeVisible called.");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9656]++;/*I_*/for (Iterator i = listeners.iterator(); i.hasNext();) {
			/*_I*/_prof.prof.cnt[9657]++;/*I_*/MenuListener listener = (MenuListener) i.next();
			/*_I*/{_prof.prof.cnt[9658]++;/*I_*/listener.menuSelected(null);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	}

	public void addMenuListener(MenuListener listener) {/*_I*/_prof.prof.cnt[9659]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9660]++;/*I_*/listeners.add(listener);/*_I*/}/*I_*/
	}

	public void removeMenuListener(MenuListener listener) {/*_I*/_prof.prof.cnt[9661]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9662]++;/*I_*/listeners.remove(listener);/*_I*/}/*I_*/
	}
	protected void firePopupMenuCanceled() {/*_I*/_prof.prof.cnt[9663]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9664]++;/*I_*/super.firePopupMenuCanceled();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9665]++;/*I_*/logger.info("Popup firePopupMenuCanceled called.");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9666]++;/*I_*/for (Iterator i = listeners.iterator(); i.hasNext();) {
			/*_I*/_prof.prof.cnt[9667]++;/*I_*/MenuListener listener = (MenuListener) i.next();
			/*_I*/{_prof.prof.cnt[9668]++;/*I_*/listener.menuCanceled(null);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	}
	protected void firePopupMenuWillBecomeInvisible() {/*_I*/_prof.prof.cnt[9669]++;/*I_*/
		/*_I*/{_prof.prof.cnt[9670]++;/*I_*/super.firePopupMenuWillBecomeInvisible();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9671]++;/*I_*/logger.info("Popup firePopupMenuWillBecomeInvisible called.");/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[9672]++;/*I_*/for (Iterator i = listeners.iterator(); i.hasNext();) {
			/*_I*/_prof.prof.cnt[9673]++;/*I_*/MenuListener listener = (MenuListener) i.next();
			/*_I*/{_prof.prof.cnt[9674]++;/*I_*/listener.menuDeselected(null);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
	}
}