/*
 * GrabKeyDialog.java - Grabs keys from the keyboard
 * :tabSize=8:indentSize=8:noTabs=false:
 * :folding=explicit:collapseFolds=1:
 *
 * Copyright (C) 2001, 2002 Slava Pestov
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

package freemind.preferences.layout;

//{{{ Imports
import java.awt.AWTEvent;
import java.awt.Dialog;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.lang.reflect.Field;
import java.nio.Buffer;
import java.util.Enumeration;
import java.util.Vector;

import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;

import freemind.main.FreeMindMain;
//import org.gjt.sp.util.Log;
//}}}

/**
 * A dialog for getting shortcut keys.
 */
public class GrabKeyDialog extends JDialog
{
	private final FreeMindMain fmMain;

    private static class Buffer {

		/**
		 * @return
		 */
		public int getLength() {/*_I*/_prof.prof.cnt[147]++;/*I_*/
			// TODO Auto-generated method stub
			/*_I*/{_prof.prof.cnt[148]++;/*I_*/return 0;/*_I*/}/*I_*/
		}

		/**
		 * @param length
		 * @param string
		 */
		public void insert(int length, String string) {/*_I*/_prof.prof.cnt[149]++;/*I_*/
			// TODO Auto-generated method stub
			
		}
		
	}
	//{{{ toString() method
	public static String toString(KeyEvent evt)
	{/*_I*/_prof.prof.cnt[150]++;/*I_*/
		/*_I*/_prof.prof.cnt[151]++;/*I_*/String id;
		/*_I*/{_prof.prof.cnt[152]++;/*I_*/switch(evt.getID())
		{
		case KeyEvent.KEY_PRESSED:
			/*_I*/{_prof.prof.cnt[153]++;/*I_*/id = "KEY_PRESSED";/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[154]++;/*I_*/break;/*_I*/}/*I_*/
		case KeyEvent.KEY_RELEASED:
			/*_I*/{_prof.prof.cnt[155]++;/*I_*/id = "KEY_RELEASED";/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[156]++;/*I_*/break;/*_I*/}/*I_*/
		case KeyEvent.KEY_TYPED:
			/*_I*/{_prof.prof.cnt[157]++;/*I_*/id = "KEY_TYPED";/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[158]++;/*I_*/break;/*_I*/}/*I_*/
		default:
			/*_I*/{_prof.prof.cnt[159]++;/*I_*/id = "unknown type";/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[160]++;/*I_*/break;/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[161]++;/*I_*/return id + ",keyCode=0x"
			+ Integer.toString(evt.getKeyCode(),16)
			+ ",keyChar=0x"
			+ Integer.toString(evt.getKeyChar(),16)
			+ ",modifiers=0x"
			+ Integer.toString(evt.getModifiers(),16);/*_I*/}/*I_*/
	} //}}}

	//{{{ GrabKeyDialog constructor
	/**
	 * Create and show a new modal dialog.
	 *
	 * @param  parent  center dialog on this component.
	 * @param  binding  the action/macro that should get a binding.
	 * @param  allBindings  all other key bindings.
	 * @param  debugBuffer  debug info will be dumped to this buffer
	 * (may be null)
	 * @since jEdit 4.1pre7
	 */
//	private GrabKeyDialog(Dialog parent, KeyBinding binding,
//		Vector allBindings, Buffer debugBuffer)
//	{
//		super(parent,(getText(""grab-key.title")),true);
//
//		init(binding,allBindings,debugBuffer);
//	} //}}}

	//{{{ GrabKeyDialog constructor
	/**
	 * Create and show a new modal dialog.
	 * @param fmMain
	 *
	 * @param  parent  center dialog on this component.
	 * @param  binding  the action/macro that should get a binding.
	 * @param  allBindings  all other key bindings.
	 * @param  debugBuffer  debug info will be dumped to this buffer
	 * (may be null)
	 * @since jEdit 4.1pre7
	 */
	public GrabKeyDialog(FreeMindMain fmMain, Dialog parent, KeyBinding binding,
		Vector allBindings, Buffer debugBuffer)
	{
		super(parent,(/*FIXME: getText*/("grab-key.title")),true);/*_I*/_prof.prof.cnt[162]++;/*I_*//*_I*/_prof.prof.cnt[163]++;/*I_*/
        /*_I*/{_prof.prof.cnt[164]++;/*I_*/this.fmMain = fmMain;/*_I*/}/*I_*/
        /*_I*/{_prof.prof.cnt[165]++;/*I_*/setTitle(getText("grab-key.title"));/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[166]++;/*I_*/init(binding,allBindings,debugBuffer);/*_I*/}/*I_*/
	} //}}}

	//{{{ getShortcut() method
	/**
	 * Returns the shortcut, or null if the current shortcut should be
	 * removed or the dialog either has been cancelled. Use isOK()
	 * to determine if the latter is true.
	 */
	public String getShortcut()
	{/*_I*/_prof.prof.cnt[167]++;/*I_*/
		/*_I*/{_prof.prof.cnt[168]++;/*I_*/if(isOK)
			/*_I*/{_prof.prof.cnt[169]++;/*I_*/return shortcut.getText();/*_I*/}/*I_*/
		else
			/*_I*/{_prof.prof.cnt[170]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/
	} //}}}

	//{{{ isOK() method
	/**
	 * Returns true, if the dialog has not been cancelled.
	 * @since jEdit 3.2pre9
	 */
	public boolean isOK()
	{/*_I*/_prof.prof.cnt[171]++;/*I_*/
		/*_I*/{_prof.prof.cnt[172]++;/*I_*/return isOK;/*_I*/}/*I_*/
	} //}}}

	//{{{ isManagingFocus() method
	/**
	 * Returns if this component can be traversed by pressing the
	 * Tab key. This returns false.
	 */
	public boolean isManagingFocus()
	{/*_I*/_prof.prof.cnt[173]++;/*I_*/
		/*_I*/{_prof.prof.cnt[174]++;/*I_*/return false;/*_I*/}/*I_*/
	} //}}}

	//{{{ getFocusTraversalKeysEnabled() method
	/**
	 * Makes the tab key work in Java 1.4.
	 * @since jEdit 3.2pre4
	 */
	public boolean getFocusTraversalKeysEnabled()
	{/*_I*/_prof.prof.cnt[175]++;/*I_*/
		/*_I*/{_prof.prof.cnt[176]++;/*I_*/return false;/*_I*/}/*I_*/
	} //}}}

	//{{{ processKeyEvent() method
	protected void processKeyEvent(KeyEvent evt)
	{/*_I*/_prof.prof.cnt[177]++;/*I_*/
		/*_I*/{_prof.prof.cnt[178]++;/*I_*/shortcut.processKeyEvent(evt);/*_I*/}/*I_*/
	} //}}}

	//{{{ Private members

	//{{{ Instance variables
	private InputPane shortcut; // this is a bad hack
	private JLabel assignedTo;
	private JButton ok;
	private JButton remove;
	private JButton cancel;
	private JButton clear;
	private boolean isOK;
	private KeyBinding binding;
	private Vector allBindings;
	private Buffer debugBuffer;
	//}}}
	public final static String MODIFIER_SEPARATOR = " ";

	//{{{ init() method
	private void init(KeyBinding binding, Vector allBindings, Buffer debugBuffer)
	{/*_I*/_prof.prof.cnt[179]++;/*I_*/
		/*_I*/{_prof.prof.cnt[180]++;/*I_*/this.binding = binding;/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[181]++;/*I_*/this.allBindings = allBindings;/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[182]++;/*I_*/this.debugBuffer = debugBuffer;/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[183]++;/*I_*/enableEvents(AWTEvent.KEY_EVENT_MASK);/*_I*/}/*I_*/

		// create a panel with a BoxLayout. Can't use Box here
		// because Box doesn't have setBorder().
		/*_I*/_prof.prof.cnt[184]++;/*I_*/JPanel content = new JPanel(new GridLayout(0,1,0,6))
		{
			/**
			 * Returns if this component can be traversed by pressing the
			 * Tab key. This returns false.
			 */
			public boolean isManagingFocus()
			{/*_I*/_prof.prof.cnt[185]++;/*I_*/
				/*_I*/{_prof.prof.cnt[186]++;/*I_*/return false;/*_I*/}/*I_*/
			}

			/**
			 * Makes the tab key work in Java 1.4.
			 * @since jEdit 3.2pre4
			 */
			public boolean getFocusTraversalKeysEnabled()
			{/*_I*/_prof.prof.cnt[187]++;/*I_*/
				/*_I*/{_prof.prof.cnt[188]++;/*I_*/return false;/*_I*/}/*I_*/
			}
		};
		/*_I*/{_prof.prof.cnt[189]++;/*I_*/content.setBorder(new EmptyBorder(12,12,12,12));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[190]++;/*I_*/setContentPane(content);/*_I*/}/*I_*/

		/*_I*/_prof.prof.cnt[191]++;/*I_*/JLabel label = new JLabel(
			debugBuffer == null ? (
			getText("grab-key.caption")+ " " + binding.label) 
//FIXME:			getText("grab-key.caption")+new String[] { binding.label })
			: (getText("grab-key.keyboard-test")));

		/*_I*/_prof.prof.cnt[192]++;/*I_*/Box input = Box.createHorizontalBox();

		/*_I*/{_prof.prof.cnt[193]++;/*I_*/shortcut = new InputPane();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[194]++;/*I_*/input.add(shortcut);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[195]++;/*I_*/input.add(Box.createHorizontalStrut(12));/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[196]++;/*I_*/clear = new JButton((getText("grab-key.clear")));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[197]++;/*I_*/clear.addActionListener(new ActionHandler());/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[198]++;/*I_*/input.add(clear);/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[199]++;/*I_*/assignedTo = new JLabel();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[200]++;/*I_*/if(debugBuffer == null)
			/*_I*/{_prof.prof.cnt[201]++;/*I_*/updateAssignedTo(null);/*_I*/}/*I_*//*_I*/}/*I_*/

		/*_I*/_prof.prof.cnt[202]++;/*I_*/Box buttons = Box.createHorizontalBox();
		/*_I*/{_prof.prof.cnt[203]++;/*I_*/buttons.add(Box.createGlue());/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[204]++;/*I_*/if(debugBuffer == null)
		{
			/*_I*/{_prof.prof.cnt[205]++;/*I_*/ok = new JButton(getText("common.ok"));/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[206]++;/*I_*/ok.addActionListener(new ActionHandler());/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[207]++;/*I_*/buttons.add(ok);/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[208]++;/*I_*/buttons.add(Box.createHorizontalStrut(12));/*_I*/}/*I_*/

			/*_I*/{_prof.prof.cnt[209]++;/*I_*/if(binding.isAssigned()) {
				// show "remove" button
				/*_I*/{_prof.prof.cnt[210]++;/*I_*/remove = new JButton((getText("grab-key.remove")));/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[211]++;/*I_*/remove.addActionListener(new ActionHandler());/*_I*/}/*I_*/
				//FIXME: REACTIVATE buttons.add(remove);
				/*_I*/{_prof.prof.cnt[212]++;/*I_*/buttons.add(Box.createHorizontalStrut(12));/*_I*/}/*I_*/
			}/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[213]++;/*I_*/cancel = new JButton(getText("common.cancel"));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[214]++;/*I_*/cancel.addActionListener(new ActionHandler());/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[215]++;/*I_*/buttons.add(cancel);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[216]++;/*I_*/buttons.add(Box.createGlue());/*_I*/}/*I_*/

//FIXME: REACTIVATE		content.add(label);
		/*_I*/{_prof.prof.cnt[217]++;/*I_*/content.add(input);/*_I*/}/*I_*/
//		if(debugBuffer == null)
//FIXME: REACTIVATE					content.add(assignedTo);
		/*_I*/{_prof.prof.cnt[218]++;/*I_*/content.add(buttons);/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[219]++;/*I_*/setDefaultCloseOperation(DISPOSE_ON_CLOSE);/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[220]++;/*I_*/pack();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[221]++;/*I_*/setLocationRelativeTo(getParent());/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[222]++;/*I_*/setResizable(false);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[223]++;/*I_*/setVisible(true);/*_I*/}/*I_*/
	} //}}}

	//{{{ getSymbolicName() method
	private String getSymbolicName(int keyCode)
	{/*_I*/_prof.prof.cnt[224]++;/*I_*/
		/*_I*/{_prof.prof.cnt[225]++;/*I_*/if(keyCode == KeyEvent.VK_UNDEFINED)
			/*_I*/{_prof.prof.cnt[226]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/
		/* else if(keyCode == KeyEvent.VK_OPEN_BRACKET)
			return "[";
		else if(keyCode == KeyEvent.VK_CLOSE_BRACKET)
			return "]"; */

		/*_I*/{_prof.prof.cnt[227]++;/*I_*/if(keyCode >= KeyEvent.VK_A && keyCode <= KeyEvent.VK_Z) {
			/*_I*/{_prof.prof.cnt[228]++;/*I_*/return String.valueOf(Character.toLowerCase((char)keyCode));/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[229]++;/*I_*/try
		{
			/*_I*/_prof.prof.cnt[230]++;/*I_*/Field[] fields = KeyEvent.class.getFields();
			/*_I*/{_prof.prof.cnt[231]++;/*I_*/for(int i = 0; i < fields.length; i++)
			{
				/*_I*/_prof.prof.cnt[232]++;/*I_*/Field field = fields[i];
				/*_I*/_prof.prof.cnt[233]++;/*I_*/String name = field.getName();
				/*_I*/{_prof.prof.cnt[234]++;/*I_*/if(name.startsWith("VK_")
					&& field.getInt(null) == keyCode)
				{
					/*_I*/{_prof.prof.cnt[235]++;/*I_*/return name.substring(3);/*_I*/}/*I_*/
				}/*_I*/}/*I_*/
			}/*_I*/}/*I_*/
		}
		catch(Exception e)
		{
//			Log.log(Log.ERROR,this,e);
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[236]++;/*I_*/return null;/*_I*/}/*I_*/
	} //}}}

	//{{{ updateAssignedTo() method
	private void updateAssignedTo(String shortcut)
	{/*_I*/_prof.prof.cnt[237]++;/*I_*/
		/*_I*/_prof.prof.cnt[238]++;/*I_*/String text = (getText("grab-key.assigned-to.none"));
		/*_I*/_prof.prof.cnt[239]++;/*I_*/KeyBinding kb = getKeyBinding(shortcut);

		/*_I*/{_prof.prof.cnt[240]++;/*I_*/if(kb != null)
			/*_I*/{_prof.prof.cnt[241]++;/*I_*/if(kb.isPrefix)
				/*_I*/{_prof.prof.cnt[242]++;/*I_*/text = 
					getText("grab-key.assigned-to.prefix")+
					 " " + shortcut ;/*_I*/}/*I_*/
//FIXME:					getText("grab-key.assigned-to.prefix")+
//					new String[] { shortcut };
			else
				/*_I*/{_prof.prof.cnt[243]++;/*I_*/text = kb.label;/*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[244]++;/*I_*/if(ok != null)
			/*_I*/{_prof.prof.cnt[245]++;/*I_*/ok.setEnabled(kb == null || !kb.isPrefix);/*_I*/}/*I_*//*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[246]++;/*I_*/assignedTo.setText(
			(getText("grab-key.assigned-to")+
				" " + text ));/*_I*/}/*I_*/
//FIXME:		assignedTo.setText(
//			(getText("grab-key.assigned-to")+
//				new String[] { text }));
	} //}}}

	//{{{ getKeyBinding() method
	private KeyBinding getKeyBinding(String shortcut)
	{/*_I*/_prof.prof.cnt[247]++;/*I_*/
		/*_I*/{_prof.prof.cnt[248]++;/*I_*/if(shortcut == null || shortcut.length() == 0)
			/*_I*/{_prof.prof.cnt[249]++;/*I_*/return null;/*_I*/}/*I_*//*_I*/}/*I_*/

		/*_I*/_prof.prof.cnt[250]++;/*I_*/String spacedShortcut = shortcut + " ";
		/*_I*/_prof.prof.cnt[251]++;/*I_*/Enumeration e = allBindings.elements();

		/*_I*/{_prof.prof.cnt[252]++;/*I_*/while(e.hasMoreElements())
		{
			/*_I*/_prof.prof.cnt[253]++;/*I_*/KeyBinding kb = (KeyBinding)e.nextElement();

			/*_I*/{_prof.prof.cnt[254]++;/*I_*/if(!kb.isAssigned())
				/*_I*/{_prof.prof.cnt[255]++;/*I_*/continue;/*_I*/}/*I_*//*_I*/}/*I_*/

			/*_I*/_prof.prof.cnt[256]++;/*I_*/String spacedKbShortcut = kb.shortcut + " ";

			// eg, trying to bind C+n C+p if C+n already bound
			/*_I*/{_prof.prof.cnt[257]++;/*I_*/if(spacedShortcut.startsWith(spacedKbShortcut))
				/*_I*/{_prof.prof.cnt[258]++;/*I_*/return kb;/*_I*/}/*I_*//*_I*/}/*I_*/

			// eg, trying to bind C+e if C+e is a prefix
			/*_I*/{_prof.prof.cnt[259]++;/*I_*/if(spacedKbShortcut.startsWith(spacedShortcut))
			{
				// create a temporary (synthetic) prefix
				// KeyBinding, that won't be saved
				/*_I*/{_prof.prof.cnt[260]++;/*I_*/return new KeyBinding(kb.name,kb.label,
					shortcut,true);/*_I*/}/*I_*/
			}/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[261]++;/*I_*/return null;/*_I*/}/*I_*/
	} //}}}

	//}}}

	//{{{ KeyBinding class
	/**
	 * A jEdit action or macro with its two possible shortcuts.
	 * @since jEdit 3.2pre8
	 */
	public static class KeyBinding
	{
		public KeyBinding(String name, String label,
			String shortcut, boolean isPrefix)
		{/*_I*/_prof.prof.cnt[262]++;/*I_*/
			/*_I*/{_prof.prof.cnt[263]++;/*I_*/this.name = name;/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[264]++;/*I_*/this.label = label;/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[265]++;/*I_*/this.shortcut = shortcut;/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[266]++;/*I_*/this.isPrefix = isPrefix;/*_I*/}/*I_*/
		}

		public String name;
		public String label;
		public String shortcut;
		public boolean isPrefix;

		public boolean isAssigned()
		{/*_I*/_prof.prof.cnt[267]++;/*I_*/
			/*_I*/{_prof.prof.cnt[268]++;/*I_*/return shortcut != null && shortcut.length() > 0;/*_I*/}/*I_*/
		}
	} //}}}

	//{{{ InputPane class
	class InputPane extends JTextField
	{
		//{{{ getFocusTraversalKeysEnabled() method
		/**
		 * Makes the tab key work in Java 1.4.
		 * @since jEdit 3.2pre4
		 */
		public boolean getFocusTraversalKeysEnabled()
		{/*_I*/_prof.prof.cnt[269]++;/*I_*/
			/*_I*/{_prof.prof.cnt[270]++;/*I_*/return false;/*_I*/}/*I_*/
		} //}}}

		//{{{ processKeyEvent() method
		protected void processKeyEvent(KeyEvent _evt)
		{/*_I*/_prof.prof.cnt[271]++;/*I_*/
			/*_I*/_prof.prof.cnt[272]++;/*I_*/KeyEvent evt = KeyEventWorkaround.processKeyEvent(_evt);
			/*_I*/{_prof.prof.cnt[273]++;/*I_*/if(debugBuffer != null)
			{
				/*_I*/{_prof.prof.cnt[274]++;/*I_*/debugBuffer.insert(debugBuffer.getLength(),
					"Event " + GrabKeyDialog.toString(_evt)
					+ (evt == null ? " filtered\n"
					: " passed\n"));/*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			/*_I*/{_prof.prof.cnt[275]++;/*I_*/if(evt == null)
				/*_I*/{_prof.prof.cnt[276]++;/*I_*/return;/*_I*/}/*I_*//*_I*/}/*I_*/

			/*_I*/{_prof.prof.cnt[277]++;/*I_*/evt.consume();/*_I*/}/*I_*/

			/*_I*/_prof.prof.cnt[278]++;/*I_*/KeyEventTranslator.Key key = KeyEventTranslator
				.translateKeyEvent(evt);
			/*_I*/{_prof.prof.cnt[279]++;/*I_*/if(key == null)
				/*_I*/{_prof.prof.cnt[280]++;/*I_*/return;/*_I*/}/*I_*//*_I*/}/*I_*/

			/*_I*/{_prof.prof.cnt[281]++;/*I_*/if(debugBuffer != null)
			{
				/*_I*/{_prof.prof.cnt[282]++;/*I_*/debugBuffer.insert(debugBuffer.getLength(),
					"==> Translated to " + key + "\n");/*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			/*_I*/_prof.prof.cnt[283]++;/*I_*/StringBuffer keyString = new StringBuffer(/*getText()*/);

//			if(getDocument().getLength() != 0)
//				keyString.append(' ');

			/*_I*/{_prof.prof.cnt[284]++;/*I_*/if(key.modifiers != null)
				/*_I*/{_prof.prof.cnt[285]++;/*I_*/keyString.append(key.modifiers).append(' ');/*_I*/}/*I_*//*_I*/}/*I_*/ // TODO: plus ?? .append('+');

			/*_I*/{_prof.prof.cnt[286]++;/*I_*/if(key.input == ' ')
				/*_I*/{_prof.prof.cnt[287]++;/*I_*/keyString.append("SPACE");/*_I*/}/*I_*/
			else /*_I*/{_prof.prof.cnt[288]++;/*I_*/if(key.input != '\0')
				/*_I*/{_prof.prof.cnt[289]++;/*I_*/keyString.append(key.input);/*_I*/}/*I_*/
			else
			{
				/*_I*/_prof.prof.cnt[290]++;/*I_*/String symbolicName = getSymbolicName(key.key);

				/*_I*/{_prof.prof.cnt[291]++;/*I_*/if(symbolicName == null)
					/*_I*/{_prof.prof.cnt[292]++;/*I_*/return;/*_I*/}/*I_*//*_I*/}/*I_*/

				/*_I*/{_prof.prof.cnt[293]++;/*I_*/keyString.append(symbolicName);/*_I*/}/*I_*/
			}/*_I*/}/*I_*//*_I*/}/*I_*/

			/*_I*/{_prof.prof.cnt[294]++;/*I_*/setText(keyString.toString());/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[295]++;/*I_*/if(debugBuffer == null)
				/*_I*/{_prof.prof.cnt[296]++;/*I_*/updateAssignedTo(keyString.toString());/*_I*/}/*I_*//*_I*/}/*I_*/
		} //}}}
	} //}}}

	//{{{ ActionHandler class
	class ActionHandler implements ActionListener
	{
		//{{{ actionPerformed() method
		public void actionPerformed(ActionEvent evt)
		{/*_I*/_prof.prof.cnt[297]++;/*I_*/
			/*_I*/{_prof.prof.cnt[298]++;/*I_*/if(evt.getSource() == ok)
			{
				/*_I*/{_prof.prof.cnt[299]++;/*I_*/if(canClose())
					/*_I*/{_prof.prof.cnt[300]++;/*I_*/dispose();/*_I*/}/*I_*//*_I*/}/*I_*/
			}
			else /*_I*/{_prof.prof.cnt[301]++;/*I_*/if(evt.getSource() == remove)
			{
				/*_I*/{_prof.prof.cnt[302]++;/*I_*/shortcut.setText(null);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[303]++;/*I_*/isOK = true;/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[304]++;/*I_*/dispose();/*_I*/}/*I_*/
			}
			else /*_I*/{_prof.prof.cnt[305]++;/*I_*/if(evt.getSource() == cancel)
				/*_I*/{_prof.prof.cnt[306]++;/*I_*/dispose();/*_I*/}/*I_*/
			else /*_I*/{_prof.prof.cnt[307]++;/*I_*/if(evt.getSource() == clear)
			{
				/*_I*/{_prof.prof.cnt[308]++;/*I_*/shortcut.setText(null);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[309]++;/*I_*/if(debugBuffer == null)
					/*_I*/{_prof.prof.cnt[310]++;/*I_*/updateAssignedTo(null);/*_I*/}/*I_*//*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[311]++;/*I_*/shortcut.requestFocus();/*_I*/}/*I_*/
			}/*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*//*_I*/}/*I_*/
		} //}}}

		//{{{ canClose() method
		private boolean canClose()
		{/*_I*/_prof.prof.cnt[312]++;/*I_*/
			/*_I*/_prof.prof.cnt[313]++;/*I_*/String shortcutString = shortcut.getText();
			/*_I*/{_prof.prof.cnt[314]++;/*I_*/if(shortcutString.length() == 0
				&& binding.isAssigned())
			{
				// ask whether to remove the old shortcut
				/*_I*/_prof.prof.cnt[315]++;/*I_*/int answer = JOptionPane.showConfirmDialog(
					GrabKeyDialog.this,
					getText("grab-key.remove-ask"),
					null,
					JOptionPane.YES_NO_OPTION,
					JOptionPane.QUESTION_MESSAGE);
				/*_I*/{_prof.prof.cnt[316]++;/*I_*/if(answer == JOptionPane.YES_OPTION)
				{
					/*_I*/{_prof.prof.cnt[317]++;/*I_*/shortcut.setText(null);/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[318]++;/*I_*/isOK = true;/*_I*/}/*I_*/
				}
				else
					/*_I*/{_prof.prof.cnt[319]++;/*I_*/return false;/*_I*/}/*I_*//*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			// check whether this shortcut already exists
			/*_I*/_prof.prof.cnt[320]++;/*I_*/KeyBinding other = getKeyBinding(shortcutString);
			/*_I*/{_prof.prof.cnt[321]++;/*I_*/if(other == null || other == binding)
			{
				/*_I*/{_prof.prof.cnt[322]++;/*I_*/isOK = true;/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[323]++;/*I_*/return true;/*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			// check whether the other shortcut is the alt. shortcut
			/*_I*/{_prof.prof.cnt[324]++;/*I_*/if(other.name == binding.name)
			{
				// we don't need two identical shortcuts
				/*_I*/{_prof.prof.cnt[325]++;/*I_*/JOptionPane.showMessageDialog(GrabKeyDialog.this,
					getText("grab-key.duplicate-alt-shortcut"));/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[326]++;/*I_*/return false;/*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			// check whether shortcut is a prefix to others
			/*_I*/{_prof.prof.cnt[327]++;/*I_*/if(other.isPrefix)
			{
				// can't override prefix shortcuts
				/*_I*/{_prof.prof.cnt[328]++;/*I_*/JOptionPane.showMessageDialog(GrabKeyDialog.this,
					getText("grab-key.prefix-shortcut")
					);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[329]++;/*I_*/return false;/*_I*/}/*I_*/
			}/*_I*/}/*I_*/

			// ask whether to override that other shortcut
			/*_I*/_prof.prof.cnt[330]++;/*I_*/int answer = JOptionPane.showConfirmDialog(GrabKeyDialog.this,
				getText("grab-key.duplicate-shortcut")+
				new Object[] { other.label },null,
				JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE);
			/*_I*/{_prof.prof.cnt[331]++;/*I_*/if(answer == JOptionPane.YES_OPTION)
			{
				/*_I*/{_prof.prof.cnt[332]++;/*I_*/if(other.shortcut != null
					&& shortcutString.startsWith(other.shortcut))
				{
					/*_I*/{_prof.prof.cnt[333]++;/*I_*/other.shortcut = null;/*_I*/}/*I_*/
				}/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[334]++;/*I_*/isOK = true;/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[335]++;/*I_*/return true;/*_I*/}/*I_*/
			}
			else
				/*_I*/{_prof.prof.cnt[336]++;/*I_*/return false;/*_I*/}/*I_*//*_I*/}/*I_*/
		} //}}}

	} //}}}
	/**
	 * @param string
	 * @return
	 */
	private String getText(String resourceString) {/*_I*/_prof.prof.cnt[337]++;/*I_*/
		/*_I*/{_prof.prof.cnt[338]++;/*I_*/return fmMain.getResourceString("GrabKeyDialog."+resourceString);/*_I*/}/*I_*/
	}

	/**FIXME: make method here.
	 * @return
	 */
	public static boolean isMacOS() {/*_I*/_prof.prof.cnt[339]++;/*I_*/
		/*_I*/{_prof.prof.cnt[340]++;/*I_*/return false;/*_I*/}/*I_*/
	}
}