/*FreeMind - A Program for creating and viewing Mindmaps
 *Copyright (C) 2000-2004  Joerg Mueller, Daniel Polansky, Christian Foltin and others.
 *
 *See COPYING for Details
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * Created on 02.05.2004
 */
/*$Id: EditNodeDialog.java,v 1.1.4.1 2004/10/17 23:00:13 dpolivaev Exp $*/

package freemind.view.mindmapview;

import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

import freemind.main.Tools;
import freemind.modes.ModeController;

/**
 * @author foltin
 *
 */
public class EditNodeDialog extends EditNodeBase {


	private KeyEvent firstEvent;

	/** Private variable to hold the last value of the "Enter confirms" state.*/
	private static Tools.BooleanHolder booleanHolderForConfirmState;

	public EditNodeDialog(
		final NodeView node,
		final String text,
		final KeyEvent firstEvent,
		ModeController controller,
		EditControl editControl) {
			super(node, text, controller, editControl);/*_I*/_prof.prof.cnt[3260]++;/*I_*//*_I*/_prof.prof.cnt[3261]++;/*I_*/
			/*_I*/{_prof.prof.cnt[3262]++;/*I_*/this.firstEvent = firstEvent;/*_I*/}/*I_*/

	}
	public void show() {/*_I*/_prof.prof.cnt[3263]++;/*I_*/
		/*_I*/_prof.prof.cnt[3264]++;/*I_*/final JDialog dialog =
			new JDialog(
				(JFrame) getFrame(),
				getText("edit_long_node"),
		/*modal=*/
		true);

		/*_I*/_prof.prof.cnt[3265]++;/*I_*/final JTextArea textArea = new JTextArea(getText());
		/*_I*/{_prof.prof.cnt[3266]++;/*I_*/textArea.setLineWrap(true);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3267]++;/*I_*/textArea.setWrapStyleWord(true);/*_I*/}/*I_*/
		// wrap around words rather than characters
		/*_I*/{_prof.prof.cnt[3268]++;/*I_*/if (firstEvent != null) {
			/*_I*/{_prof.prof.cnt[3269]++;/*I_*/switch (firstEvent.getKeyCode()) {
				case KeyEvent.VK_HOME :
					/*_I*/{_prof.prof.cnt[3270]++;/*I_*/textArea.setCaretPosition(0);/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[3271]++;/*I_*/break;/*_I*/}/*I_*/

				default :
					/*_I*/{_prof.prof.cnt[3272]++;/*I_*/textArea.setCaretPosition(getText().length());/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[3273]++;/*I_*/break;/*_I*/}/*I_*/
			}/*_I*/}/*I_*/
		} else {
			/*_I*/{_prof.prof.cnt[3274]++;/*I_*/textArea.setCaretPosition(getText().length());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/_prof.prof.cnt[3275]++;/*I_*/final JScrollPane editorScrollPane = new JScrollPane(textArea);
		/*_I*/{_prof.prof.cnt[3276]++;/*I_*/editorScrollPane.setVerticalScrollBarPolicy(
			JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);/*_I*/}/*I_*/

		//int preferredHeight = new Integer(getFrame().getProperty("el__default_window_height")).intValue();
		/*_I*/_prof.prof.cnt[3277]++;/*I_*/int preferredHeight = getNode().getHeight();
		/*_I*/{_prof.prof.cnt[3278]++;/*I_*/preferredHeight =
			Math.max(
				preferredHeight,
				Integer.parseInt(
					getFrame().getProperty("el__min_default_window_height")));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3279]++;/*I_*/preferredHeight =
			Math.min(
				preferredHeight,
				Integer.parseInt(
					getFrame().getProperty("el__max_default_window_height")));/*_I*/}/*I_*/

		/*_I*/_prof.prof.cnt[3280]++;/*I_*/int preferredWidth = getNode().getWidth();
		/*_I*/{_prof.prof.cnt[3281]++;/*I_*/preferredWidth =
			Math.max(
				preferredWidth,
				Integer.parseInt(
					getFrame().getProperty("el__min_default_window_width")));/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3282]++;/*I_*/preferredWidth =
			Math.min(
				preferredWidth,
				Integer.parseInt(
					getFrame().getProperty("el__max_default_window_width")));/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3283]++;/*I_*/editorScrollPane.setPreferredSize(
			new Dimension(preferredWidth, preferredHeight));/*_I*/}/*I_*/
		//textArea.setPreferredSize(new Dimension(500, 160));

		/*_I*/_prof.prof.cnt[3284]++;/*I_*/final JPanel panel = new JPanel();

		//String performedAction;
		/*_I*/_prof.prof.cnt[3285]++;/*I_*/final Tools.IntHolder eventSource = new Tools.IntHolder();
		/*_I*/_prof.prof.cnt[3286]++;/*I_*/final JButton okButton = new JButton("OK");
		/*_I*/_prof.prof.cnt[3287]++;/*I_*/final JButton cancelButton = new JButton(getText("cancel"));
		/*_I*/_prof.prof.cnt[3288]++;/*I_*/final JButton splitButton = new JButton(getText("split"));
		/*_I*/_prof.prof.cnt[3289]++;/*I_*/final JCheckBox enterConfirms =
			new JCheckBox(
				getText("enter_confirms"),
				binOptionIsTrue("el__enter_confirms_by_default"));

		/*_I*/{_prof.prof.cnt[3290]++;/*I_*/if (booleanHolderForConfirmState == null) {
			/*_I*/{_prof.prof.cnt[3291]++;/*I_*/booleanHolderForConfirmState = new Tools.BooleanHolder();/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[3292]++;/*I_*/booleanHolderForConfirmState.setValue(enterConfirms.isSelected());/*_I*/}/*I_*/
		} else {
			/*_I*/{_prof.prof.cnt[3293]++;/*I_*/enterConfirms.setSelected(booleanHolderForConfirmState.getValue());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3294]++;/*I_*/okButton.setMnemonic(KeyEvent.VK_O);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3295]++;/*I_*/enterConfirms.setMnemonic(KeyEvent.VK_E);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3296]++;/*I_*/splitButton.setMnemonic(KeyEvent.VK_S);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3297]++;/*I_*/cancelButton.setMnemonic(KeyEvent.VK_C);/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3298]++;/*I_*/okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3299]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3300]++;/*I_*/eventSource.setValue(BUTTON_OK);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[3301]++;/*I_*/dialog.dispose();/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3302]++;/*I_*/cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3303]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3304]++;/*I_*/eventSource.setValue(BUTTON_CANCEL);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[3305]++;/*I_*/dialog.dispose();/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3306]++;/*I_*/splitButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3307]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3308]++;/*I_*/eventSource.setValue(BUTTON_SPLIT);/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[3309]++;/*I_*/dialog.dispose();/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3310]++;/*I_*/enterConfirms.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {/*_I*/_prof.prof.cnt[3311]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3312]++;/*I_*/textArea.requestFocus();/*_I*/}/*I_*/
				/*_I*/{_prof.prof.cnt[3313]++;/*I_*/booleanHolderForConfirmState.setValue(
					enterConfirms.isSelected());/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/

		// On Enter act as if OK button was pressed

		/*_I*/{_prof.prof.cnt[3314]++;/*I_*/textArea.addKeyListener(new KeyListener() {
			public void keyPressed(KeyEvent e) {/*_I*/_prof.prof.cnt[3315]++;/*I_*/
				// escape key in long text editor (PN)
				/*_I*/{_prof.prof.cnt[3316]++;/*I_*/if (e.getKeyCode() == KeyEvent.VK_ESCAPE) {
					/*_I*/{_prof.prof.cnt[3317]++;/*I_*/e.consume();/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[3318]++;/*I_*/eventSource.setValue(BUTTON_CANCEL);/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[3319]++;/*I_*/dialog.dispose();/*_I*/}/*I_*/
				} else /*_I*/{_prof.prof.cnt[3320]++;/*I_*/if (e.getKeyCode() == KeyEvent.VK_ENTER) {
					/*_I*/{_prof.prof.cnt[3321]++;/*I_*/if (enterConfirms.isSelected()
						== ((e.getModifiers() & KeyEvent.CTRL_MASK) == 0)) {
						/*_I*/{_prof.prof.cnt[3322]++;/*I_*/e.consume();/*_I*/}/*I_*/
						/*_I*/{_prof.prof.cnt[3323]++;/*I_*/eventSource.setValue(BUTTON_OK);/*_I*/}/*I_*/
						/*_I*/{_prof.prof.cnt[3324]++;/*I_*/dialog.dispose();/*_I*/}/*I_*/
					} else /*_I*/{_prof.prof.cnt[3325]++;/*I_*/if (
						enterConfirms.isSelected()
							&& (e.getModifiers() & KeyEvent.CTRL_MASK) != 0) {
						/*_I*/{_prof.prof.cnt[3326]++;/*I_*/e.consume();/*_I*/}/*I_*/
						/*_I*/{_prof.prof.cnt[3327]++;/*I_*/textArea.insert("\n", textArea.getCaretPosition());/*_I*/}/*I_*/
					}/*_I*/}/*I_*//*_I*/}/*I_*/
				}/*_I*/}/*I_*//*_I*/}/*I_*/ 
			}

			/*
			// Daniel: I tried to make editor resizable. It worked somehow, but not
			// quite. When I increased the size and then decreased again to the original
			// size, it stopped working. The main idea here is to change the preferred
			// size. I also tried to change the size but it did not do anything sensible.
			//
			// One possibility would be to disable decreasing the size.
			//
			// Another thing which was far from nice was that it flickered.
			//
			// If someone wants to find a solution, let it be.
			
			else if (e.getKeyCode() == KeyEvent.VK_DOWN &&
					  (e.getModifiers() & KeyEvent.CTRL_MASK) != 0) {
			
				changeComponentHeight(editorScrollPane, 60, 180);
				dialog.doLayout();
				dialog.pack();
				e.consume();
			}
			else if (e.getKeyCode() == KeyEvent.VK_UP &&
					  (e.getModifiers() & KeyEvent.CTRL_MASK) != 0) {
				changeComponentHeight(editorScrollPane, -60, 180);
				dialog.doLayout();
				dialog.pack();
				e.consume(); }} */
			public void keyTyped(KeyEvent e) {/*_I*/_prof.prof.cnt[3328]++;/*I_*/
			}
			public void keyReleased(KeyEvent e) {/*_I*/_prof.prof.cnt[3329]++;/*I_*/
			}
		});/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3330]++;/*I_*/textArea.addMouseListener(new MouseListener() {
			public void mouseClicked(MouseEvent e) {/*_I*/_prof.prof.cnt[3331]++;/*I_*/
			}
			public void mouseEntered(MouseEvent e) {/*_I*/_prof.prof.cnt[3332]++;/*I_*/
			}
			public void mouseExited(MouseEvent e) {/*_I*/_prof.prof.cnt[3333]++;/*I_*/
			}

			public void mousePressed(MouseEvent e) {/*_I*/_prof.prof.cnt[3334]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3335]++;/*I_*/conditionallyShowPopup(e);/*_I*/}/*I_*/
			}

			public void mouseReleased(MouseEvent e) {/*_I*/_prof.prof.cnt[3336]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3337]++;/*I_*/conditionallyShowPopup(e);/*_I*/}/*I_*/
			}

			private void conditionallyShowPopup(MouseEvent e) {/*_I*/_prof.prof.cnt[3338]++;/*I_*/
				/*_I*/{_prof.prof.cnt[3339]++;/*I_*/if (e.isPopupTrigger()) {
					/*_I*/_prof.prof.cnt[3340]++;/*I_*/JPopupMenu popupMenu = new EditPopupMenu(textArea);
					/*_I*/{_prof.prof.cnt[3341]++;/*I_*/popupMenu.show(e.getComponent(), e.getX(), e.getY());/*_I*/}/*I_*/
					/*_I*/{_prof.prof.cnt[3342]++;/*I_*/e.consume();/*_I*/}/*I_*/
				}/*_I*/}/*I_*/
			}
		});/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3343]++;/*I_*/textArea.setFont(getNode().getFont());/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3344]++;/*I_*/textArea.setForeground(getNode().getForeground());/*_I*/}/*I_*/

		//panel.setPreferredSize(new Dimension(500, 160));
		//editorScrollPane.setPreferredSize(new Dimension(500, 160));

		/*_I*/_prof.prof.cnt[3345]++;/*I_*/JPanel buttonPane = new JPanel();
		/*_I*/{_prof.prof.cnt[3346]++;/*I_*/buttonPane.add(enterConfirms);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3347]++;/*I_*/buttonPane.add(okButton);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3348]++;/*I_*/buttonPane.add(cancelButton);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3349]++;/*I_*/buttonPane.add(splitButton);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3350]++;/*I_*/buttonPane.setMaximumSize(new Dimension(1000, 20));/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3351]++;/*I_*/if (getFrame().getProperty("el__buttons_position").equals("above")) {
			/*_I*/{_prof.prof.cnt[3352]++;/*I_*/panel.add(buttonPane);/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[3353]++;/*I_*/panel.add(editorScrollPane);/*_I*/}/*I_*/
		} else {
			/*_I*/{_prof.prof.cnt[3354]++;/*I_*/panel.add(editorScrollPane);/*_I*/}/*I_*/
			/*_I*/{_prof.prof.cnt[3355]++;/*I_*/panel.add(buttonPane);/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3356]++;/*I_*/panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3357]++;/*I_*/dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3358]++;/*I_*/dialog.setContentPane(panel);/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3359]++;/*I_*/dialog.pack();/*_I*/}/*I_*/ // calculate the size

		// set position
		/*_I*/{_prof.prof.cnt[3360]++;/*I_*/getView().scrollNodeToVisible(getNode(), 0);/*_I*/}/*I_*/
		/*_I*/_prof.prof.cnt[3361]++;/*I_*/Point frameScreenLocation =
			getFrame().getLayeredPane().getLocationOnScreen();
		/*_I*/_prof.prof.cnt[3362]++;/*I_*/double posX =
			getNode().getLocationOnScreen().getX() - frameScreenLocation.getX();
		/*_I*/_prof.prof.cnt[3363]++;/*I_*/double posY =
			getNode().getLocationOnScreen().getY()
				- frameScreenLocation.getY()
				+ (binOptionIsTrue("el__position_window_below_node")
					? getNode().getHeight()
					: 0);
		/*_I*/{_prof.prof.cnt[3364]++;/*I_*/if (posX + dialog.getWidth()
			> getFrame().getLayeredPane().getWidth()) {
			/*_I*/{_prof.prof.cnt[3365]++;/*I_*/posX = getFrame().getLayeredPane().getWidth() - dialog.getWidth();/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3366]++;/*I_*/if (posY + dialog.getHeight()
			> getFrame().getLayeredPane().getHeight()) {
			/*_I*/{_prof.prof.cnt[3367]++;/*I_*/posY = getFrame().getLayeredPane().getHeight() - dialog.getHeight();/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3368]++;/*I_*/posX = ((posX < 0) ? 0 : posX) + frameScreenLocation.getX();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3369]++;/*I_*/posY = ((posY < 0) ? 0 : posY) + frameScreenLocation.getY();/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3370]++;/*I_*/dialog.setLocation(
			new Double(posX).intValue(),
			new Double(posY).intValue());/*_I*/}/*I_*/

		/*_I*/{_prof.prof.cnt[3371]++;/*I_*/textArea.requestFocusInWindow();/*_I*/}/*I_*/
		// make the text area focused when the dialog comes
		/*_I*/{_prof.prof.cnt[3372]++;/*I_*/dialog.show();/*_I*/}/*I_*/
		//dialog.setVisible(true);

		/*_I*/{_prof.prof.cnt[3373]++;/*I_*/if (eventSource.getValue() == BUTTON_OK) {
			/*_I*/{_prof.prof.cnt[3374]++;/*I_*/getEditControl().ok(textArea.getText());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3375]++;/*I_*/if (eventSource.getValue() == BUTTON_SPLIT) {
			/*_I*/{_prof.prof.cnt[3376]++;/*I_*/getEditControl().split(textArea.getText(), textArea.getCaretPosition());/*_I*/}/*I_*/
		}/*_I*/}/*I_*/
		/*_I*/{_prof.prof.cnt[3377]++;/*I_*/if (eventSource.getValue() == BUTTON_CANCEL) {
			/*_I*/{_prof.prof.cnt[3378]++;/*I_*/getEditControl().cancel();/*_I*/}/*I_*/
		}/*_I*/}/*I_*/

	}


    /**
     * @return
     */
    protected KeyEvent getFirstEvent() {/*_I*/_prof.prof.cnt[3379]++;/*I_*/
        /*_I*/{_prof.prof.cnt[3380]++;/*I_*/return firstEvent;/*_I*/}/*I_*/
    }


}
