// This is mutant program.
// Author : ysma

package freemind.controller;


import java.util.*;
import java.awt.Component;
import java.awt.Color;
import java.awt.event.KeyEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.*;


public class MenuBar extends JMenuBar
{

    private static java.util.logging.Logger logger;

    public static final java.lang.String MENU_BAR_PREFIX = "menu_bar/";

    public static final java.lang.String GENERAL_POPUP_PREFIX = "popup/";

    public static final java.lang.String POPUP_MENU = GENERAL_POPUP_PREFIX + "popup/";

    public static final java.lang.String INSERT_MENU = MENU_BAR_PREFIX + "insert/";

    public static final java.lang.String NAVIGATE_MENU = MENU_BAR_PREFIX + "navigate/";

    public static final java.lang.String VIEW_MENU = MENU_BAR_PREFIX + "view/";

    public static final java.lang.String HELP_MENU = MENU_BAR_PREFIX + "help/";

    public static final java.lang.String MODES_MENU = MENU_BAR_PREFIX + "modes/";

    public static final java.lang.String MINDMAP_MENU = MENU_BAR_PREFIX + "mindmaps/";

    public static final java.lang.String EDIT_MENU = MENU_BAR_PREFIX + "edit/";

    public static final java.lang.String FILE_MENU = MENU_BAR_PREFIX + "file/";

    public static final java.lang.String FORMAT_MENU = MENU_BAR_PREFIX + "format/";

    public static final java.lang.String EXTRAS_MENU = MENU_BAR_PREFIX + "extras/";

    private freemind.controller.StructuredMenuHolder menuHolder;

    javax.swing.JPopupMenu mapsPopupMenu;

    private javax.swing.JMenu filemenu;

    private javax.swing.JMenu editmenu;

    private javax.swing.JMenu mapsmenu;

    freemind.controller.Controller c;

    java.awt.event.ActionListener mapsMenuActionListener = new freemind.controller.MenuBar.MapsMenuActionListener();

    java.awt.event.ActionListener lastOpenedActionListener = new freemind.controller.MenuBar.LastOpenedActionListener();

    private javax.swing.JMenu formatmenu;

    public MenuBar( freemind.controller.Controller controller )
    {
        this.c = controller;
        if (logger == null) {
            logger = controller.getFrame().getLogger( this.getClass().getName() );
        }
    }

    public void updateMenus()
    {
        this.removeAll();
        menuHolder = new freemind.controller.StructuredMenuHolder();
        filemenu = menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "file" ) ), FILE_MENU + "." );
        filemenu.setMnemonic( KeyEvent.VK_F );
        menuHolder.addCategory( FILE_MENU + "open" );
        menuHolder.addCategory( FILE_MENU + "close" );
        menuHolder.addSeparator( FILE_MENU );
        menuHolder.addCategory( FILE_MENU + "export" );
        menuHolder.addSeparator( FILE_MENU );
        menuHolder.addCategory( FILE_MENU + "import" );
        menuHolder.addSeparator( FILE_MENU );
        menuHolder.addCategory( FILE_MENU + "print" );
        menuHolder.addSeparator( FILE_MENU );
        menuHolder.addCategory( FILE_MENU + "last" );
        menuHolder.addSeparator( FILE_MENU );
        menuHolder.addCategory( FILE_MENU + "quit" );
        editmenu = menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "edit" ) ), EDIT_MENU + "." );
        menuHolder.addCategory( EDIT_MENU + "undo" );
        menuHolder.addSeparator( EDIT_MENU );
        menuHolder.addCategory( EDIT_MENU + "select" );
        menuHolder.addSeparator( EDIT_MENU );
        menuHolder.addCategory( EDIT_MENU + "paste" );
        menuHolder.addSeparator( EDIT_MENU );
        menuHolder.addCategory( EDIT_MENU + "edit" );
        menuHolder.addSeparator( EDIT_MENU );
        menuHolder.addCategory( EDIT_MENU + "find" );
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "menu_view" ) ), VIEW_MENU + "." );
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "menu_insert" ) ), INSERT_MENU + "." );
        menuHolder.addCategory( INSERT_MENU + "nodes" );
        menuHolder.addSeparator( INSERT_MENU );
        menuHolder.addCategory( INSERT_MENU + "icons" );
        menuHolder.addSeparator( INSERT_MENU );
        formatmenu = menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "menu_format" ) ), FORMAT_MENU + "." );
        menuHolder.addCategory( FORMAT_MENU + "patterns" );
        menuHolder.addSeparator( FORMAT_MENU );
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "menu_navigate" ) ), NAVIGATE_MENU + "." );
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "menu_extras" ) ), EXTRAS_MENU + "." );
        menuHolder.addCategory( EXTRAS_MENU + "first" );
        menuHolder.addSeparator( EXTRAS_MENU );
        menuHolder.addCategory( EXTRAS_MENU + "last" );
        mapsmenu = menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "mindmaps" ) ), MINDMAP_MENU + "." );
        mapsmenu.setMnemonic( KeyEvent.VK_M );
        menuHolder.addCategory( MINDMAP_MENU + "navigate" );
        menuHolder.addSeparator( MINDMAP_MENU );
        mapsPopupMenu = new javax.swing.JPopupMenu( c.getResourceString( "mindmaps" ) );
        menuHolder.addCategory( POPUP_MENU + "navigate" );
        javax.swing.JMenu modesmenu = menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "modes" ) ), MODES_MENU + "." );
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "help" ) ), HELP_MENU + "." );
        menuHolder.addAction( c.documentation, HELP_MENU + "doc/documentation" );
        menuHolder.addAction( c.faq, HELP_MENU + "doc/faq" );
        menuHolder.addSeparator( HELP_MENU );
        menuHolder.addAction( c.license, HELP_MENU + "about/license" );
        menuHolder.addAction( c.about, HELP_MENU + "about/about" );
        updateFileMenu();
        updateEditMenu();
        updateModeMenu();
        updateMapsMenu( menuHolder, MINDMAP_MENU );
        updateMapsMenu( menuHolder, POPUP_MENU );
        addAdditionalPopupActions();
        if (c.getMode() != null) {
            c.getMode().getModeController().updateMenus( menuHolder );
        }
        menuHolder.updateMenus( this, MENU_BAR_PREFIX );
        menuHolder.updateMenus( mapsPopupMenu, GENERAL_POPUP_PREFIX );
    }

    private void updateModeMenu()
    {
        javax.swing.ButtonGroup group = new javax.swing.ButtonGroup();
        java.awt.event.ActionListener modesMenuActionListener = new freemind.controller.MenuBar.ModesMenuActionListener();
        java.util.List keys = new java.util.LinkedList( c.getModes() );
        for (java.util.ListIterator i = keys.listIterator(); i.hasNext();) {
            java.lang.String key = (java.lang.String) i.next();
            javax.swing.JRadioButtonMenuItem newItem = (javax.swing.JRadioButtonMenuItem) menuHolder.addMenuItem( new javax.swing.JRadioButtonMenuItem( key ), MODES_MENU + key );
            group.add( newItem );
            if (c.getMode() != null) {
                newItem.setSelected( c.getMode().toString().equals( key ) );
            } else {
                newItem.setSelected( false );
            }
            java.lang.String keystroke = c.getFrame().getProperty( "keystroke_mode_" + key );
            if (keystroke != null) {
                newItem.setAccelerator( KeyStroke.getKeyStroke( keystroke ) );
            }
            newItem.addActionListener( modesMenuActionListener );
        }
    }

    private void addAdditionalPopupActions()
    {
        menuHolder.addSeparator( POPUP_MENU );
        javax.swing.JMenuItem newPopupItem;
        newPopupItem = new javax.swing.JMenuItem( c.toggleMenubar );
        newPopupItem.setForeground( new java.awt.Color( 100, 80, 80 ) );
        newPopupItem.setEnabled( c.getFrame().isApplet() );
        menuHolder.addMenuItem( newPopupItem, POPUP_MENU + "toggleMenubar" );
        newPopupItem = new javax.swing.JMenuItem( c.toggleToolbar );
        newPopupItem.setForeground( new java.awt.Color( 100, 80, 80 ) );
        menuHolder.addMenuItem( newPopupItem, POPUP_MENU + "toggleToolbar" );
        newPopupItem = new javax.swing.JMenuItem( c.toggleLeftToolbar );
        newPopupItem.setForeground( new java.awt.Color( 100, 80, 80 ) );
        menuHolder.addMenuItem( newPopupItem, POPUP_MENU + "toggleLeftToolbar" );
    }

    private void updateMapsMenu( freemind.controller.StructuredMenuHolder holder, java.lang.String basicKey )
    {
        if (c.getMapModuleManager().getMapModules() == null) {
            return;
        }
        java.util.List keys = new java.util.LinkedList( c.getMapModuleManager().getMapModules().keySet() );
        Collections.sort( keys );
        javax.swing.ButtonGroup group = new javax.swing.ButtonGroup();
        for (java.util.ListIterator i = keys.listIterator(); i.hasNext();) {
            java.lang.String key = (java.lang.String) i.next();
            javax.swing.JRadioButtonMenuItem newItem = new javax.swing.JRadioButtonMenuItem( key );
            newItem.setSelected( false );
            group.add( newItem );
            newItem.addActionListener( mapsMenuActionListener );
            newItem.setMnemonic( key.charAt( 0 ) );
            if (c.getMapModuleManager().getMapModule() != null) {
                if (key.equals( c.getMapModuleManager().getMapModule().toString() )) {
                    newItem.setSelected( true );
                }
            }
            holder.addMenuItem( newItem, basicKey + key );
        }
    }

    private void updateFileMenu()
    {
        menuHolder.addAction( c.page, FILE_MENU + "print/pageSetup" );
        javax.swing.JMenuItem print = menuHolder.addAction( c.print, FILE_MENU + "print/print" );
        print.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_print" ) ) );
        javax.swing.JMenuItem close = menuHolder.addAction( c.close, FILE_MENU + "close/close" );
        close.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_close" ) ) );
        javax.swing.JMenuItem quit = menuHolder.addAction( c.quit, FILE_MENU + "quit/quit" );
        quit.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_quit" ) ) );
        updateLastOpenedList();
    }

    private void updateLastOpenedList()
    {
        menuHolder.addMenu( new javax.swing.JMenu( c.getResourceString( "most_recent_files" ) ), FILE_MENU + "last/." );
        boolean firstElement = true;
        freemind.controller.LastOpenedList lst = c.getLastOpenedList();
        for (java.util.ListIterator it = lst.listIterator(); it.hasNext();) {
            java.lang.String key = (java.lang.String) it.next();
            javax.swing.JMenuItem item = new javax.swing.JMenuItem( key );
            if (firstElement) {
                firstElement = false;
                item.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_open_first_in_history" ) ) );
            }
            item.addActionListener( lastOpenedActionListener );
            menuHolder.addMenuItem( item, FILE_MENU + "last/" + key.replace( '/', '_' ) );
        }
    }

    private void updateEditMenu()
    {
        javax.swing.JMenuItem toggleToolbar = menuHolder.addAction( c.toggleToolbar, VIEW_MENU + "toolbars/toggleToolbar" );
        javax.swing.JMenuItem toggleLeftToolbar = menuHolder.addAction( c.toggleLeftToolbar, VIEW_MENU + "toolbars/toggleLeftToolbar" );
        menuHolder.addSeparator( VIEW_MENU );
        javax.swing.JMenuItem zoomIn = menuHolder.addAction( c.zoomIn, VIEW_MENU + "zoom/zoomIn" );
        zoomIn.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_zoom_in" ) ) );
        javax.swing.JMenuItem zoomOut = menuHolder.addAction( c.zoomOut, VIEW_MENU + "zoom/zoomOut" );
        zoomOut.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_zoom_out" ) ) );
        javax.swing.JMenuItem moveToRoot = menuHolder.addAction( c.moveToRoot, NAVIGATE_MENU + "nodes/moveToRoot" );
        moveToRoot.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_moveToRoot" ) ) );
        javax.swing.JMenuItem previousMap = menuHolder.addAction( c.navigationPreviousMap, MINDMAP_MENU + "navigate/navigationPreviousMap" );
        previousMap.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_previousMap" ) ) );
        javax.swing.JMenuItem nextMap = menuHolder.addAction( c.navigationNextMap, MINDMAP_MENU + "navigate/navigationNextMap" );
        nextMap.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_nextMap" ) ) );
        javax.swing.JMenuItem prefDialog = menuHolder.addAction( c.propertyAction, EXTRAS_MENU + "last/option_dialog" );
        prefDialog.setAccelerator( KeyStroke.getKeyStroke( c.getFrame().getProperty( "keystroke_option_dialog" ) ) );
    }

    private void addOptionSet( javax.swing.Action action, java.lang.String[] textIDs, javax.swing.JMenu menu, java.lang.String selectedTextID )
    {
        javax.swing.ButtonGroup group = new javax.swing.ButtonGroup();
        for (int optionIdx = 0; optionIdx < textIDs.length; optionIdx++) {
            javax.swing.JRadioButtonMenuItem item = new javax.swing.JRadioButtonMenuItem( action );
            item.setText( c.getResourceString( textIDs[optionIdx] ) );
            item.setActionCommand( textIDs[optionIdx] );
            group.add( item );
            menu.add( item );
            if (selectedTextID != null) {
                item.setSelected( selectedTextID.equals( textIDs[optionIdx] ) );
            }
            java.lang.String keystroke = c.getFrame().getProperty( "keystroke_" + textIDs[optionIdx] );
            if (keystroke != null) {
                item.setAccelerator( KeyStroke.getKeyStroke( keystroke ) );
            }
        }
    }

    javax.swing.JPopupMenu getMapsPopupMenu()
    {
        return mapsPopupMenu;
    }

    private void copyMenuItems( javax.swing.JMenu source, javax.swing.JMenu dest )
    {
        java.awt.Component[] items = source.getMenuComponents();
        for (int i = 0; i < items.length; i++) {
            dest.add( items[i] );
        }
    }

    private class MapsMenuActionListener implements java.awt.event.ActionListener
    {

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            c.getMapModuleManager().changeToMapModule( e.getActionCommand() );
        }

    }

    private class LastOpenedActionListener implements java.awt.event.ActionListener
    {

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            c.getLastOpenedList().open( e.getActionCommand() );
        }

    }

    private class ModesMenuActionListener implements java.awt.event.ActionListener
    {

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            c.changeToMode( e.getActionCommand() );
        }

    }

    public freemind.controller.StructuredMenuHolder getMenuHolder()
    {
        return menuHolder;
    }

}
