// This is mutant program.
// Author : ysma

package freemind.extensions;


import java.io.File;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.swing.KeyStroke;
import javax.xml.bind.Unmarshaller;
import freemind.common.JaxbTools;
import freemind.controller.actions.generated.instance.Plugin;
import freemind.controller.actions.generated.instance.PluginActionType;
import freemind.controller.actions.generated.instance.PluginClasspathType;
import freemind.controller.actions.generated.instance.PluginModeType;
import freemind.controller.actions.generated.instance.PluginRegistrationType;
import freemind.main.FreeMindMain;
import freemind.modes.MindMapNode;


public class HookFactory
{

    private static final java.lang.String pluginPrefixRegEx = "(accessories\\.|)plugins\\.[^.]*";

    private freemind.main.FreeMindMain frame;

    private java.util.logging.Logger logger;

    private java.util.HashMap pluginInfo;

    private java.util.Vector allPlugins;

    private java.util.HashMap allRegistrations;

    private java.util.HashMap allRegistrationInstances;

    private freemind.extensions.ImportWizard importWizard;

    public HookFactory( freemind.main.FreeMindMain frame )
    {
        this.frame = frame;
        logger = frame.getLogger( this.getClass().getName() );
        allRegistrationInstances = new java.util.HashMap();
    }

    public java.util.Vector getPossibleNodeHooks( java.lang.Class mode )
    {
        return searchFor( freemind.extensions.NodeHook.class, mode );
    }

    public java.util.Vector getPossibleModeControllerHooks( java.lang.Class mode )
    {
        return searchFor( freemind.extensions.ModeControllerHook.class, mode );
    }

    private java.util.Vector searchFor( java.lang.Class baseClass, java.lang.Class mode )
    {
        actualizePlugins();
        java.util.Vector returnValue = new java.util.Vector();
        for (java.util.Iterator i = allPlugins.iterator(); i.hasNext();) {
            java.lang.String label = (java.lang.String) i.next();
            freemind.extensions.HookDescriptor descriptor = getHookDescriptor( label );
            try {
                logger.finest( "Loading: " + label );
                if (baseClass.isAssignableFrom( Class.forName( descriptor.getBaseClass() ) )) {
                    for (java.util.Iterator j = descriptor.getModes().iterator(); j.hasNext();) {
                        java.lang.String pmode = (java.lang.String) j.next();
                        if (pmode.equals( mode.getPackage().getName() )) {
                            returnValue.add( label );
                        }
                    }
                }
            } catch ( java.lang.ClassNotFoundException e ) {
                logger.severe( "Class not found." );
                e.printStackTrace();
            }
        }
        return returnValue;
    }

    private void actualizePlugins()
    {
        if (importWizard == null) {
            importWizard = new freemind.extensions.ImportWizard();
            importWizard.CLASS_LIST.clear();
            importWizard.buildClassList();
        }
        pluginInfo = new java.util.HashMap();
        allPlugins = new java.util.Vector();
        allRegistrations = new java.util.HashMap();
        javax.xml.bind.Unmarshaller unmarshaller = JaxbTools.getInstance().createUnmarshaller();
        for (java.util.Iterator i = importWizard.CLASS_LIST.iterator(); i.hasNext();) {
            java.lang.String xmlPluginFile = (java.lang.String) i.next();
            if (xmlPluginFile.matches( pluginPrefixRegEx )) {
                xmlPluginFile = xmlPluginFile.replace( '.', '/' ) + importWizard.lookFor;
                java.net.URL pluginURL = getClassLoader( Collections.EMPTY_LIST ).getResource( xmlPluginFile );
                freemind.controller.actions.generated.instance.Plugin plugin = null;
                try {
                    logger.finest( "Reading: " + xmlPluginFile + " from " + pluginURL );
                    java.io.InputStream in = pluginURL.openStream();
                    unmarshaller.setValidating( true );
                    plugin = (freemind.controller.actions.generated.instance.Plugin) unmarshaller.unmarshal( in );
                } catch ( java.lang.Exception e ) {
                    logger.severe( e.getLocalizedMessage() );
                    e.printStackTrace();
                    continue;
                }
                for (java.util.Iterator j = plugin.getPluginAction().iterator(); j.hasNext();) {
                    freemind.controller.actions.generated.instance.PluginActionType action = (freemind.controller.actions.generated.instance.PluginActionType) j.next();
                    pluginInfo.put( action.getLabel(), new freemind.extensions.HookDescriptor( frame, action, plugin ) );
                    allPlugins.add( action.getLabel() );
                }
                for (java.util.Iterator k = plugin.getPluginRegistration().iterator(); k.hasNext();) {
                    freemind.controller.actions.generated.instance.PluginRegistrationType registration = (freemind.controller.actions.generated.instance.PluginRegistrationType) k.next();
                    allRegistrations.put( registration, plugin );
                }
            }
        }
    }

    public freemind.extensions.ModeControllerHook createModeControllerHook( java.lang.String hookName )
    {
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return (freemind.extensions.ModeControllerHook) createJavaHook( hookName, descriptor );
    }

    private freemind.extensions.MindMapHook createJavaHook( java.lang.String hookName, freemind.extensions.HookDescriptor descriptor )
    {
        try {
            java.util.List pluginClasspathList = descriptor.getPluginBase().getPluginClasspath();
            java.lang.ClassLoader loader = getClassLoader( pluginClasspathList );
            java.lang.Class hookClass = Class.forName( descriptor.getClassName(), true, loader );
            freemind.extensions.MindMapHook hook = (freemind.extensions.MindMapHook) hookClass.newInstance();
            decorateHook( hookName, descriptor, hook );
            return hook;
        } catch ( java.lang.Exception e ) {
            logger.severe( "Error occurred loading hook: " + descriptor.getClassName() + "\nException:" + e.toString() );
            return null;
        }
    }

    private java.util.HashMap classLoaderCache = new java.util.HashMap();

    private java.lang.ClassLoader getClassLoader( java.util.List pluginClasspathList )
    {
        java.lang.String key = createPluginClasspathString( pluginClasspathList );
        if (classLoaderCache.containsKey( key )) {
            return (java.lang.ClassLoader) classLoaderCache.get( key );
        }
        try {
            java.net.URL[] urls = new java.net.URL[pluginClasspathList.size() + 1];
            int j = 0;
            urls[j++] = (new java.io.File( getFreemindBaseDir() )).toURL();
            for (java.util.Iterator i = pluginClasspathList.iterator(); i.hasNext();) {
                freemind.controller.actions.generated.instance.PluginClasspathType classPath = (freemind.controller.actions.generated.instance.PluginClasspathType) i.next();
                java.io.File file = new java.io.File( classPath.getJar() );
                if (!file.isAbsolute()) {
                    file = new java.io.File( getFreemindBaseDir(), classPath.getJar() );
                }
                logger.info( "file " + file.toString() + " exists = " + file.exists() );
                urls[j++] = file.toURL();
            }
            java.lang.ClassLoader loader = new java.net.URLClassLoader( urls, this.getClass().getClassLoader() );
            classLoaderCache.put( key, loader );
            return loader;
        } catch ( java.net.MalformedURLException e ) {
            logger.severe( e.getMessage() );
            return this.getClass().getClassLoader();
        }
    }

    private java.lang.String createPluginClasspathString( java.util.List pluginClasspathList )
    {
        java.lang.String result = "";
        for (java.util.Iterator i = pluginClasspathList.iterator(); i.hasNext();) {
            freemind.controller.actions.generated.instance.PluginClasspathType type = (freemind.controller.actions.generated.instance.PluginClasspathType) i.next();
            result += type.getJar() + ",";
        }
        return result;
    }

    public static java.lang.String getFreemindBaseDir()
    {
        return System.getProperty( "freemind.base.dir", "." );
    }

    public freemind.extensions.NodeHook createNodeHook( java.lang.String hookName )
    {
        logger.finest( "CreateNodeHook: " + hookName );
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return (freemind.extensions.NodeHook) createJavaHook( hookName, descriptor );
    }

    public freemind.extensions.PermanentNodeHook getHookInNode( freemind.modes.MindMapNode node, java.lang.String hookName )
    {
        for (java.util.Iterator i = node.getActivatedHooks().iterator(); i.hasNext();) {
            freemind.extensions.PermanentNodeHook otherHook = (freemind.extensions.PermanentNodeHook) i.next();
            if (otherHook.getName().equals( hookName )) {
                return otherHook;
            }
        }
        return null;
    }

    private void decorateHook( java.lang.String hookName, freemind.extensions.HookDescriptor descriptor, freemind.extensions.MindMapHook hook )
    {
        hook.setProperties( descriptor.getProperties() );
        hook.setName( hookName );
        java.lang.Object baseClass = getPluginBaseClass( descriptor );
        hook.setPluginBaseClass( baseClass );
    }

    private java.lang.Object getPluginBaseClass( freemind.extensions.HookDescriptor descriptor )
    {
        java.lang.Object baseClass = null;
        if (allRegistrationInstances.containsKey( descriptor.getPluginBase() )) {
            baseClass = allRegistrationInstances.get( descriptor.getPluginBase() );
        }
        return baseClass;
    }

    protected freemind.main.FreeMindMain getFrame()
    {
        return frame;
    }

    public java.lang.String getProperty( java.lang.String hookName, java.lang.String prop )
    {
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return descriptor.getProperties().getProperty( prop );
    }

    public void decorateAction( java.lang.String hookName, javax.swing.AbstractAction action )
    {
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        java.lang.String name = descriptor.getName();
        if (name != null) {
            action.putValue( AbstractAction.NAME, name );
        } else {
            action.putValue( AbstractAction.NAME, descriptor.getClassName() );
        }
        java.lang.String docu = descriptor.getDocumentation();
        if (docu != null) {
            action.putValue( AbstractAction.SHORT_DESCRIPTION, docu );
            action.putValue( AbstractAction.LONG_DESCRIPTION, docu );
        }
        java.lang.String icon = descriptor.getIconPath();
        if (icon != null) {
            javax.swing.ImageIcon imageIcon = new javax.swing.ImageIcon( getClassLoader( Collections.EMPTY_LIST ).getResource( icon ) );
            action.putValue( AbstractAction.SMALL_ICON, imageIcon );
        }
        java.lang.String key = descriptor.getKeyStroke();
        if (key != null) {
            action.putValue( AbstractAction.ACCELERATOR_KEY, KeyStroke.getKeyStroke( key ) );
        }
    }

    public java.util.List getHookMenuPositions( java.lang.String hookName )
    {
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return descriptor.menuPositions;
    }

    public javax.swing.JMenuItem getHookMenuItem( java.lang.String hookName, javax.swing.AbstractAction hookAction )
    {
        return new javax.swing.JMenuItem( hookAction );
    }

    public freemind.extensions.HookInstanciationMethod getInstanciationMethod( java.lang.String hookName )
    {
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return descriptor.getInstanciationMethod();
    }

    public static class RegistrationContainer
    {

        public java.lang.Class hookRegistrationClass;

        public boolean isPluginBase;

        public freemind.controller.actions.generated.instance.Plugin correspondingPlugin;

        RegistrationContainer()
        {
        }

    }

    public java.util.List getRegistrations( java.lang.Class mode )
    {
        actualizePlugins();
        java.util.Vector returnValue = new java.util.Vector();
        for (java.util.Iterator i = allRegistrations.keySet().iterator(); i.hasNext();) {
            freemind.controller.actions.generated.instance.PluginRegistrationType registration = (freemind.controller.actions.generated.instance.PluginRegistrationType) i.next();
            boolean modeFound = false;
            for (java.util.Iterator j = registration.getPluginMode().iterator(); j.hasNext();) {
                freemind.controller.actions.generated.instance.PluginModeType possibleMode = (freemind.controller.actions.generated.instance.PluginModeType) j.next();
                if (mode.getPackage().getName().equals( possibleMode.getClassName() )) {
                    modeFound = true;
                }
            }
            if (!modeFound) {
                continue;
            }
            try {
                freemind.controller.actions.generated.instance.Plugin plugin = (freemind.controller.actions.generated.instance.Plugin) allRegistrations.get( registration );
                java.lang.ClassLoader loader = getClassLoader( plugin.getPluginClasspath() );
                freemind.extensions.HookFactory.RegistrationContainer container = new freemind.extensions.HookFactory.RegistrationContainer();
                java.lang.Class hookRegistrationClass = Class.forName( registration.getClassName(), true, loader );
                container.hookRegistrationClass = hookRegistrationClass;
                container.correspondingPlugin = plugin;
                container.isPluginBase = registration.isIsPluginBase();
                returnValue.add( container );
            } catch ( java.lang.ClassNotFoundException e ) {
                e.printStackTrace();
            }
        }
        return returnValue;
    }

    public void registerRegistrationContainer( freemind.extensions.HookFactory.RegistrationContainer container, freemind.extensions.HookRegistration instanciatedRegistrationObject )
    {
        if (container.isPluginBase) {
            allRegistrationInstances.put( container.correspondingPlugin, instanciatedRegistrationObject );
        }
    }

    public java.lang.Object getPluginBaseClass( java.lang.String hookName )
    {
        logger.finest( "getPluginBaseClass: " + hookName );
        freemind.extensions.HookDescriptor descriptor = getHookDescriptor( hookName );
        return getPluginBaseClass( descriptor );
    }

    private freemind.extensions.HookDescriptor getHookDescriptor( java.lang.String hookName )
    {
        freemind.extensions.HookDescriptor descriptor = (freemind.extensions.HookDescriptor) pluginInfo.get( hookName );
        if (hookName == null || descriptor == null) {
            throw new java.lang.IllegalArgumentException( "Unknown hook name " + hookName );
        }
        return descriptor;
    }

}
