// This is mutant program.
// Author : ysma

package freemind.modes;


import java.awt.Color;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.Reader;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import freemind.main.Tools;
import freemind.main.XMLElement;


public class StylePattern
{

    private java.lang.String name;

    private boolean recursive;

    private java.lang.String text;

    private boolean folded;

    private boolean appliesToNode = false;

    private java.awt.Color nodeColor;

    private java.awt.Color nodeBackgroundColor;

    private java.lang.String nodeStyle;

    private boolean appliesToNodeFont = false;

    private java.lang.String nodeFontFamily = null;

    private java.lang.Integer nodeFontSize = null;

    private java.lang.Boolean nodeFontBold = null;

    private java.lang.Boolean nodeFontItalic = null;

    private boolean appliesToNodeIcon = false;

    private freemind.modes.MindIcon nodeIcon;

    private boolean appliesToEdge = false;

    private java.awt.Color edgeColor;

    private java.lang.String edgeStyle;

    private int edgeWidth;

    private boolean appliesToChildren = false;

    private freemind.modes.StylePattern ChildrenStylePattern;

    public StylePattern( freemind.main.XMLElement elm, java.util.List justConstructedPatterns )
    {
        loadPattern( elm, justConstructedPatterns );
    }

    public StylePattern( freemind.modes.MindMapNode node )
    {
        appliesToNode = true;
        nodeColor = node.getColor();
        nodeBackgroundColor = node.getBackgroundColor();
        nodeStyle = node.getStyle();
        appliesToNodeFont = true;
        nodeFontBold = new java.lang.Boolean( node.isBold() );
        nodeFontItalic = new java.lang.Boolean( node.isItalic() );
        nodeFontSize = node.getFontSize() == null ? null : Integer.valueOf( node.getFontSize() );
        nodeFontFamily = node.getFontFamilyName();
        appliesToNodeIcon = false;
        appliesToEdge = true;
        edgeColor = node.getEdge().getColor();
        edgeStyle = node.getEdge().getStyle();
        edgeWidth = node.getEdge().getWidth();
    }

    public java.lang.String toString()
    {
        return "node: " + nodeColor + ", " + nodeBackgroundColor + ", " + nodeStyle + ", " + nodeFontFamily + ", " + nodeFontSize + ", " + nodeIcon + ", " + "\nedge: " + edgeColor + ", " + edgeStyle + ", " + edgeWidth;
    }

    public boolean getAppliesToEdge()
    {
        return appliesToEdge;
    }

    public boolean getAppliesToNode()
    {
        return appliesToNode;
    }

    public boolean getAppliesToNodeFont()
    {
        return appliesToNodeFont;
    }

    public boolean getAppliesToNodeIcon()
    {
        return appliesToNodeIcon;
    }

    public boolean getAppliesToChildren()
    {
        return appliesToChildren;
    }

    public java.lang.String getName()
    {
        return name;
    }

    public void setName( java.lang.String v )
    {
        this.name = v;
    }

    public boolean getRecursive()
    {
        return recursive;
    }

    public void setRecursive( boolean v )
    {
        this.recursive = v;
    }

    public boolean getFolded()
    {
        return folded;
    }

    public void setFolded( boolean v )
    {
        this.folded = v;
    }

    public java.lang.String getText()
    {
        return text;
    }

    public void setText( java.lang.String v )
    {
        this.text = v;
    }

    public java.awt.Color getNodeColor()
    {
        return nodeColor;
    }

    public void setNodeColor( java.awt.Color v )
    {
        this.nodeColor = v;
    }

    public java.awt.Color getNodeBackgroundColor()
    {
        return nodeBackgroundColor;
    }

    public void setNodeBackgroundColor( java.awt.Color nodeBackgroundColor )
    {
        this.nodeBackgroundColor = nodeBackgroundColor;
    }

    public java.lang.String getNodeStyle()
    {
        return nodeStyle;
    }

    public void setNodeStyle( java.lang.String nodeStyle )
    {
        this.nodeStyle = nodeStyle;
    }

    public java.lang.String getNodeFontFamily()
    {
        return nodeFontFamily;
    }

    public void setNodeFontFamily( java.lang.String nodeFontFamily )
    {
        this.nodeFontFamily = nodeFontFamily;
    }

    public java.lang.Integer getNodeFontSize()
    {
        return nodeFontSize;
    }

    public void setNodeFontSize( java.lang.Integer nodeFontSize )
    {
        this.nodeFontSize = nodeFontSize;
    }

    public freemind.modes.MindIcon getNodeIcon()
    {
        return nodeIcon;
    }

    public void setNodeIcon( freemind.modes.MindIcon nodeIcon )
    {
        this.nodeIcon = nodeIcon;
    }

    public java.awt.Color getEdgeColor()
    {
        return edgeColor;
    }

    public void setEdgeColor( java.awt.Color edgeColor )
    {
        this.edgeColor = edgeColor;
    }

    public java.lang.String getEdgeStyle()
    {
        return edgeStyle;
    }

    public void setEdgeStyle( java.lang.String edgeStyle )
    {
        this.edgeStyle = edgeStyle;
    }

    public int getEdgeWidth()
    {
        return edgeWidth;
    }

    public void setEdgeWidth( int edgeWidth )
    {
        this.edgeWidth = edgeWidth;
    }

    public freemind.modes.StylePattern getChildrenStylePattern()
    {
        return ChildrenStylePattern;
    }

    public void setChildrenStylePattern( freemind.modes.StylePattern ChildrenStylePattern )
    {
        this.ChildrenStylePattern = ChildrenStylePattern;
    }

    public static java.util.List loadPatterns( java.io.File file )
        throws java.lang.Exception
    {
        return loadPatterns( new java.io.BufferedReader( new java.io.FileReader( file ) ) );
    }

    public static java.util.List loadPatterns( java.io.Reader reader )
        throws java.lang.Exception
    {
        java.util.List list = new java.util.LinkedList();
        freemind.main.XMLElement parser = new freemind.main.XMLElement();
        parser.parseFromReader( reader );
        for (java.util.Enumeration e = parser.enumerateChildren(); e.hasMoreElements();) {
            list.add( new freemind.modes.StylePattern( (freemind.main.XMLElement) e.nextElement(), list ) );
        }
        return list;
    }

    protected void loadPattern( freemind.main.XMLElement pattern, java.util.List justConstructedPatterns )
    {
        if (pattern.getStringAttribute( "name" ) != null) {
            setName( pattern.getStringAttribute( "name" ) );
        }
        if (Tools.safeEquals( pattern.getStringAttribute( "recursive" ), "true" )) {
            setRecursive( true );
        }
        for (java.util.Iterator i = pattern.getChildren().iterator(); i.hasNext();) {
            freemind.main.XMLElement child = (freemind.main.XMLElement) i.next();
            if (child.getName().equals( "node" )) {
                appliesToNode = true;
                if (child.getStringAttribute( "color" ) != null && child.getStringAttribute( "color" ).length() == 7) {
                    setNodeColor( Tools.xmlToColor( child.getStringAttribute( "color" ) ) );
                }
                if (child.getStringAttribute( "background_color" ) != null && child.getStringAttribute( "background_color" ).length() == 7) {
                    setNodeBackgroundColor( Tools.xmlToColor( child.getStringAttribute( "background_color" ) ) );
                }
                if (child.getStringAttribute( "style" ) != null) {
                    setNodeStyle( child.getStringAttribute( "style" ) );
                }
                if (child.getStringAttribute( "icon" ) != null) {
                    appliesToNodeIcon = true;
                    setNodeIcon( child.getStringAttribute( "icon" ).equals( "none" ) ? null : MindIcon.factory( child.getStringAttribute( "icon" ) ) );
                }
                setText( child.getStringAttribute( "text" ) );
                for (java.util.Iterator j = child.getChildren().iterator(); j.hasNext();) {
                    freemind.main.XMLElement nodeChild = (freemind.main.XMLElement) j.next();
                    if (nodeChild.getName().equals( "font" )) {
                        appliesToNodeFont = true;
                        if (nodeChild.getStringAttribute( "name" ) != null) {
                            setNodeFontFamily( nodeChild.getStringAttribute( "name" ) );
                        }
                        if (Tools.safeEquals( nodeChild.getStringAttribute( "bold" ), "true" )) {
                            setNodeFontBold( Boolean.TRUE );
                        }
                        if (Tools.safeEquals( nodeChild.getStringAttribute( "italic" ), "true" )) {
                            setNodeFontItalic( Boolean.TRUE );
                        }
                        if (nodeChild.getStringAttribute( "size" ) != null) {
                            setNodeFontSize( Integer.valueOf( nodeChild.getStringAttribute( "size" ) ) );
                        }
                    }
                }
            }
            if (child.getName().equals( "edge" )) {
                appliesToEdge = true;
                if (child.getStringAttribute( "style" ) != null) {
                    setEdgeStyle( child.getStringAttribute( "style" ) );
                }
                if (child.getStringAttribute( "color" ) != null) {
                    setEdgeColor( Tools.xmlToColor( child.getStringAttribute( "color" ) ) );
                }
                if (child.getStringAttribute( "width" ) != null) {
                    if (child.getStringAttribute( "width" ).equals( "thin" )) {
                        setEdgeWidth( freemind.modes.EdgeAdapter.WIDTH_THIN );
                    } else {
                        setEdgeWidth( Integer.parseInt( child.getStringAttribute( "width" ) ) );
                    }
                }
            }
            if (child.getName().equals( "child" )) {
                appliesToChildren = true;
                if (child.getStringAttribute( "pattern" ) != null) {
                    java.lang.String searchName = child.getStringAttribute( "pattern" );
                    boolean anythingFound = false;
                    for (java.util.ListIterator e = justConstructedPatterns.listIterator(); e.hasNext();) {
                        freemind.modes.StylePattern patternFound = (freemind.modes.StylePattern) e.next();
                        if (patternFound.getName().equals( searchName )) {
                            setChildrenStylePattern( patternFound );
                            anythingFound = true;
                            break;
                        }
                    }
                    if (getName().equals( searchName )) {
                        setChildrenStylePattern( this );
                        anythingFound = true;
                    }
                    if (anythingFound == false) {
                        System.err.println( "Cannot find the children " + searchName + " to the pattern " + getName() );
                    }
                }
            }
        }
    }

    public java.lang.Boolean getNodeFontBold()
    {
        return nodeFontBold;
    }

    public void setNodeFontBold( java.lang.Boolean nodeFontBold )
    {
        this.nodeFontBold = nodeFontBold;
    }

    public java.lang.Boolean getNodeFontItalic()
    {
        return nodeFontItalic;
    }

    public void setNodeFontItalic( java.lang.Boolean nodeFontItalic )
    {
        this.nodeFontItalic = nodeFontItalic;
    }

}
