// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.Color;
import java.awt.event.ActionEvent;
import java.util.ListIterator;
import javax.swing.Action;
import javax.swing.JMenuItem;
import javax.xml.bind.JAXBException;
import freemind.controller.Controller;
import freemind.controller.MenuItemEnabledListener;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.FreemindAction;
import freemind.controller.actions.generated.instance.CloudColorXmlAction;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.main.Tools;
import freemind.modes.LineAdapter;
import freemind.modes.MindMapNode;
import freemind.modes.ModeController;
import freemind.modes.mindmapmode.MindMapNodeModel;


public class CloudColorAction extends freemind.controller.actions.FreemindAction implements freemind.controller.actions.ActorXml, freemind.controller.MenuItemEnabledListener
{

    private final freemind.modes.ModeController controller;

    public CloudColorAction( freemind.modes.ModeController controller )
    {
        super( "cloud_color", "images/Colors24.gif", controller );
        this.controller = controller;
        controller.getActionFactory().registerActor( this, getDoActionClass() );
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        java.awt.Color selectedColor = null;
        if (controller.getSelected().getCloud() != null) {
            selectedColor = controller.getSelected().getCloud().getColor();
        }
        java.awt.Color color = Controller.showCommonJColorChooserDialog( controller.getView().getSelected(), controller.getText( "choose_cloud_color" ), selectedColor );
        if (color == null) {
            return;
        }
        for (java.util.ListIterator it = controller.getSelecteds().listIterator(); it.hasNext();) {
            freemind.modes.mindmapmode.MindMapNodeModel selected = (freemind.modes.mindmapmode.MindMapNodeModel) it.next();
            setCloudColor( selected, color );
        }
    }

    public void setCloudColor( freemind.modes.MindMapNode node, java.awt.Color color )
    {
        try {
            freemind.controller.actions.generated.instance.CloudColorXmlAction doAction = createCloudColorXmlAction( node, color );
            freemind.controller.actions.generated.instance.CloudColorXmlAction undoAction = createCloudColorXmlAction( node, node.getCloud() == null ? null : node.getCloud().getColor() );
            controller.getActionFactory().startTransaction( this.getClass().getName() );
            controller.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
            controller.getActionFactory().endTransaction( this.getClass().getName() );
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
    }

    public freemind.controller.actions.generated.instance.CloudColorXmlAction createCloudColorXmlAction( freemind.modes.MindMapNode node, java.awt.Color color )
        throws javax.xml.bind.JAXBException
    {
        freemind.controller.actions.generated.instance.CloudColorXmlAction nodeAction = controller.getActionXmlFactory().createCloudColorXmlAction();
        nodeAction.setNode( node.getObjectId( controller ) );
        nodeAction.setColor( Tools.colorToXml( color ) );
        return nodeAction;
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        if (action instanceof freemind.controller.actions.generated.instance.CloudColorXmlAction) {
            freemind.controller.actions.generated.instance.CloudColorXmlAction nodeColorAction = (freemind.controller.actions.generated.instance.CloudColorXmlAction) action;
            java.awt.Color color = Tools.xmlToColor( nodeColorAction.getColor() );
            freemind.modes.MindMapNode node = controller.getNodeFromID( nodeColorAction.getNode() );
            if (node.getCloud() == null) {
                controller.setCloud( node, true );
            }
            java.awt.Color selectedColor = null;
            if (node.getCloud() != null) {
                selectedColor = node.getCloud().getColor();
            }
            if (!Tools.safeEquals( color, selectedColor )) {
                ((freemind.modes.LineAdapter) node.getCloud()).setColor( color );
                controller.nodeChanged( node );
            }
        }
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.CloudColorXmlAction.class;
    }

    public boolean isEnabled( javax.swing.JMenuItem item, javax.swing.Action action )
    {
        return controller != null && controller.getSelected() != null && controller.getSelected().getCloud() != null;
    }

}
