// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.ListIterator;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import freemind.modes.MindMapNode;
import freemind.modes.ModeController;


public class FindAction extends AbstractAction
{

    private final freemind.modes.ModeController controller;

    private java.util.ArrayList findNodesUnfoldedByLastFind;

    private freemind.modes.MindMapNode findFromNode;

    private java.lang.String findWhat;

    public java.lang.String getFindWhat()
    {
        return findWhat;
    }

    public java.lang.String getFindFromText()
    {
        return findFromNode.toString();
    }

    private boolean findCaseSensitive;

    private java.util.LinkedList findNodeQueue;

    public FindAction( freemind.modes.ModeController controller )
    {
        super( controller.getText( "find" ), new javax.swing.ImageIcon( controller.getController().getResource( "images/filefind.png" ) ) );
        this.controller = controller;
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        java.lang.String what = JOptionPane.showInputDialog( controller.getView().getSelected(), controller.getText( "find_what" ) );
        if (what == null || what.equals( "" )) {
            return;
        }
        boolean found = find( controller.getSelected(), what, false );
        controller.getView().repaint();
        if (!found) {
            controller.getController().informationMessage( controller.getText( "no_found_from" ).replaceAll( "\\$1", what ).replaceAll( "\\$2", getFindFromText() ), controller.getView().getSelected() );
        }
    }

    public static class FindNextAction extends javax.swing.AbstractAction
    {

        private final freemind.modes.ModeController controller;

        private final freemind.modes.actions.FindAction find;

        public FindNextAction( freemind.modes.ModeController controller, freemind.modes.actions.FindAction find )
        {
            super( controller.getText( "find_next" ) );
            this.controller = controller;
            this.find = find;
        }

        public void actionPerformed( java.awt.event.ActionEvent e )
        {
            java.lang.String what = find.getFindWhat();
            if (what == null) {
                controller.getController().informationMessage( controller.getText( "no_previous_find" ), controller.getView().getSelected() );
                return;
            }
            boolean found = find.findNext();
            controller.getView().repaint();
            if (!found) {
                controller.getController().informationMessage( controller.getText( "no_more_found_from" ).replaceAll( "\\$1", what ).replaceAll( "\\$2", find.getFindFromText() ), controller.getView().getSelected() );
            }
        }

    }

    public boolean find( freemind.modes.MindMapNode node, java.lang.String what, boolean caseSensitive )
    {
        findNodesUnfoldedByLastFind = new java.util.ArrayList();
        java.util.LinkedList nodes = new java.util.LinkedList();
        nodes.addFirst( node );
        findFromNode = node;
        if (!caseSensitive) {
            what = what.toLowerCase();
        }
        return find( nodes, what, caseSensitive );
    }

    private boolean find( java.util.LinkedList nodes, java.lang.String what, boolean caseSensitive )
    {
        boolean thereWereNodesToBeFolded = !findNodesUnfoldedByLastFind.isEmpty();
        if (!findNodesUnfoldedByLastFind.isEmpty()) {
            java.util.ListIterator i = findNodesUnfoldedByLastFind.listIterator( findNodesUnfoldedByLastFind.size() );
            while (i.hasPrevious()) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) i.previous();
                try {
                    controller.setFolded( node, true );
                } catch ( java.lang.Exception e ) {
                }
            }
            findNodesUnfoldedByLastFind = new java.util.ArrayList();
        }
        while (!nodes.isEmpty()) {
            freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) nodes.removeFirst();
            for (java.util.ListIterator i = node.childrenUnfolded(); i.hasNext();) {
                nodes.addLast( i.next() );
            }
            java.lang.String nodeText = caseSensitive ? node.toString() : node.toString().toLowerCase();
            if (nodeText.indexOf( what ) >= 0) {
                displayNode( node, findNodesUnfoldedByLastFind );
                centerNode( node );
                findWhat = what;
                findCaseSensitive = caseSensitive;
                findNodeQueue = nodes;
                return true;
            }
        }
        centerNode( findFromNode );
        return false;
    }

    public void displayNode( freemind.modes.MindMapNode node, java.util.ArrayList nodesUnfoldedByDisplay )
    {
        java.lang.Object[] path = controller.getMap().getPathToRoot( node );
        for (int i = 0; i < path.length - 1; i++) {
            freemind.modes.MindMapNode nodeOnPath = (freemind.modes.MindMapNode) path[i];
            if (nodeOnPath.isFolded()) {
                if (nodesUnfoldedByDisplay != null) {
                    nodesUnfoldedByDisplay.add( nodeOnPath );
                }
                controller.setFolded( nodeOnPath, false );
            }
        }
    }

    public boolean findNext()
    {
        if (findWhat != null) {
            return find( findNodeQueue, findWhat, findCaseSensitive );
        }
        return false;
    }

    private void centerNode( freemind.modes.MindMapNode node )
    {
        controller.centerNode( node );
    }

}
