// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import freemind.main.Tools;
import freemind.modes.MindMapNode;
import freemind.modes.ModeController;


public class ImportExplorerFavoritesAction extends AbstractAction
{

    private final freemind.modes.ModeController controller;

    public ImportExplorerFavoritesAction( freemind.modes.ModeController controller )
    {
        super( controller.getText( "import_explorer_favorites" ) );
        this.controller = controller;
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        java.io.File ioDir = new java.io.File( "input_files" );
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser( ioDir );
        chooser.setFileSelectionMode( JFileChooser.DIRECTORIES_ONLY );
        chooser.setDialogTitle( controller.getText( "select_favorites_folder" ) );
        int returnVal = chooser.showOpenDialog( controller.getFrame().getContentPane() );
        if (returnVal == JFileChooser.APPROVE_OPTION) {
            java.io.File folder = chooser.getSelectedFile();
            controller.getFrame().out( "Importing Favorites ..." );
            importExplorerFavorites( folder, controller.getSelected(), true );
            controller.getFrame().out( "Favorites imported." );
        }
    }

    public boolean importExplorerFavorites( java.io.File folder, freemind.modes.MindMapNode target, boolean redisplay )
    {
        boolean favoritesFound = false;
        if (folder.isDirectory()) {
            java.io.File[] list = folder.listFiles();
            for (int i = 0; i < list.length; i++) {
                if (list[i].isDirectory()) {
                    java.lang.String nodeContent = list[i].getName();
                    freemind.modes.MindMapNode node = addNode( target, nodeContent );
                    boolean favoritesFoundInSubfolder = importExplorerFavorites( list[i], node, false );
                    if (favoritesFoundInSubfolder) {
                        favoritesFound = true;
                    } else {
                        controller.deleteNode( node );
                    }
                }
            }
            for (int i = 0; i < list.length; i++) {
                if (!list[i].isDirectory() && Tools.getExtension( list[i] ).equals( "url" )) {
                    favoritesFound = true;
                    try {
                        freemind.modes.MindMapNode node = addNode( target, Tools.removeExtension( list[i].getName() ) );
                        java.io.BufferedReader in = new java.io.BufferedReader( new java.io.FileReader( list[i] ) );
                        while (in.ready()) {
                            java.lang.String line = in.readLine();
                            if (line.startsWith( "URL=" )) {
                                node.setLink( line.substring( 4 ) );
                                break;
                            }
                        }
                    } catch ( java.lang.Exception e ) {
                        e.printStackTrace();
                    }
                }
            }
        }
        if (redisplay) {
            controller.nodeChanged( target );
        }
        return favoritesFound;
    }

    private freemind.modes.MindMapNode addNode( freemind.modes.MindMapNode target, java.lang.String nodeContent )
    {
        freemind.modes.MindMapNode node = controller.addNewNode( target, target.getChildCount(), target.isLeft() );
        controller.setNodeText( node, nodeContent );
        return node;
    }

}
