// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.util.Date;
import java.util.Iterator;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.xml.bind.JAXBException;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.generated.instance.DeleteNodeAction;
import freemind.controller.actions.generated.instance.NewNodeAction;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.extensions.PermanentNodeHook;
import freemind.modes.ControllerAdapter;
import freemind.modes.MindMapNode;
import freemind.modes.NodeAdapter;
import freemind.modes.MindMapLinkRegistry.ID_Registered;


public class NewChildAction extends AbstractAction implements freemind.controller.actions.ActorXml
{

    private final freemind.modes.ControllerAdapter c;

    private static java.util.logging.Logger logger = null;

    public NewChildAction( freemind.modes.ControllerAdapter modeController )
    {
        super( modeController.getText( "new_child" ), new javax.swing.ImageIcon( modeController.getResource( "images/idea.png" ) ) );
        this.c = modeController;
        this.c.getActionFactory().registerActor( this, getDoActionClass() );
        if (logger == null) {
            logger = c.getFrame().getLogger( (freemind.modes.actions.NewChildAction.class).getName() );
        }
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        this.c.addNew( c.getSelected(), ControllerAdapter.NEW_CHILD, null );
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        freemind.controller.actions.generated.instance.NewNodeAction addNodeAction = (freemind.controller.actions.generated.instance.NewNodeAction) action;
        freemind.modes.NodeAdapter parent = this.c.getNodeFromID( addNodeAction.getNode() );
        int index = addNodeAction.getIndex();
        freemind.modes.MindMapNode newNode = c.newNode( "" );
        java.lang.String newId = addNodeAction.getNewId();
        freemind.modes.MindMapLinkRegistry.ID_Registered reg = c.getModel().getLinkRegistry().registerLinkTarget( newNode, newId );
        if (!reg.getID().equals( newId )) {
            throw new java.lang.IllegalArgumentException( "Designated id '" + newId + "' was not given to the node. It received '" + reg.getID() + "'." );
        }
        if (addNodeAction.getPosition() != null) {
            newNode.setLeft( addNodeAction.getPosition().equals( "left" ) );
        }
        c.getModel().insertNodeInto( newNode, parent, index );
        for (java.util.Iterator i = parent.getActivatedHooks().iterator(); i.hasNext();) {
            freemind.extensions.PermanentNodeHook hook = (freemind.extensions.PermanentNodeHook) i.next();
            hook.onNewChild( newNode );
        }
        c.getFrame().repaint();
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.NewNodeAction.class;
    }

    public freemind.modes.MindMapNode addNew( final freemind.modes.MindMapNode target, final int newNodeMode, final java.awt.event.KeyEvent e )
    {
        final freemind.modes.MindMapNode targetNode = target;
        freemind.modes.MindMapNode newNode = null;
        boolean targetIsLeft = true;
        switch (newNodeMode) {
        case ControllerAdapter.NEW_SIBLING_BEFORE :
        case ControllerAdapter.NEW_SIBLING_BEHIND :
            if (targetNode.isRoot()) {
                c.getController().errorMessage( c.getText( "new_node_as_sibling_not_possible_for_the_root" ) );
                c.setBlocked( false );
                return null;
            }
            freemind.modes.MindMapNode parent = targetNode.getParentNode();
            int childPosition = parent.getChildPosition( targetNode );
            if (newNodeMode == ControllerAdapter.NEW_SIBLING_BEHIND) {
                childPosition++;
            }
            newNode = addNewNode( parent, childPosition, target.isLeft() );
            c.select( newNode.getViewer() );
            c.edit.editLater( newNode.getViewer(), target.getViewer(), e, true, false, false );
            break;

        case ControllerAdapter.NEW_CHILD :
        case ControllerAdapter.NEW_CHILD_WITHOUT_FOCUS :
            final boolean parentFolded = targetNode.isFolded();
            if (parentFolded) {
                c.setFolded( targetNode, false );
            }
            int position = c.getFrame().getProperty( "placenewbranches" ).equals( "last" ) ? targetNode.getChildCount() : 0;
            newNode = addNewNode( targetNode, position, null );
            if (newNodeMode == ControllerAdapter.NEW_CHILD) {
                c.select( newNode.getViewer() );
            }
            c.edit.editLater( newNode.getViewer(), target.getViewer(), e, true, parentFolded, false );
            break;

        }
        return newNode;
    }

    public freemind.modes.MindMapNode addNewNode( freemind.modes.MindMapNode parent, int index, freemind.main.Tools.BooleanHolder newNodeIsLeft )
    {
        try {
            c.getModel().getLinkRegistry().registerLinkTarget( parent );
            java.lang.String newId = c.getModel().getLinkRegistry().generateUniqueID( "_" );
            c.getActionFactory().startTransaction( c.getText( "new_child" ) );
            freemind.controller.actions.generated.instance.NewNodeAction newNodeAction = getAddNodeAction( parent, index, newId, newNodeIsLeft );
            freemind.controller.actions.generated.instance.DeleteNodeAction deleteAction = c.deleteChild.getDeleteNodeAction( newId );
            c.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( newNodeAction, deleteAction ) );
            c.getActionFactory().endTransaction( c.getText( "new_child" ) );
            return (freemind.modes.MindMapNode) parent.getChildAt( index );
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        return null;
    }

    public freemind.controller.actions.generated.instance.NewNodeAction getAddNodeAction( freemind.modes.MindMapNode parent, int index, java.lang.String newId, freemind.main.Tools.BooleanHolder newNodeIsLeft )
        throws javax.xml.bind.JAXBException
    {
        java.lang.String pos = null;
        if (newNodeIsLeft != null) {
            pos = newNodeIsLeft.getValue() ? "left" : "right";
        }
        freemind.controller.actions.generated.instance.NewNodeAction newNodeAction = c.getActionXmlFactory().createNewNodeAction();
        newNodeAction.setNode( c.getNodeID( parent ) );
        newNodeAction.setPosition( pos );
        newNodeAction.setIndex( index );
        newNodeAction.setNewId( newId );
        return newNodeAction;
    }

}
