// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.Color;
import java.awt.event.ActionEvent;
import java.util.ListIterator;
import javax.xml.bind.JAXBException;
import freemind.controller.Controller;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.FreemindAction;
import freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.main.Tools;
import freemind.modes.MindMapNode;
import freemind.modes.ModeController;
import freemind.modes.mindmapmode.MindMapMapModel;
import freemind.modes.mindmapmode.MindMapNodeModel;


public class NodeBackgroundColorAction extends freemind.controller.actions.FreemindAction implements freemind.controller.actions.ActorXml
{

    private final freemind.modes.ModeController controller;

    public NodeBackgroundColorAction( freemind.modes.ModeController controller )
    {
        super( "node_background_color", (java.lang.String) null, controller );
        this.controller = controller;
        addActor( this );
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        java.awt.Color color = Controller.showCommonJColorChooserDialog( controller.getView().getSelected(), controller.getText( "choose_node_background_color" ), controller.getSelected().getBackgroundColor() );
        if (color == null) {
            return;
        }
        for (java.util.ListIterator it = controller.getSelecteds().listIterator(); it.hasNext();) {
            freemind.modes.mindmapmode.MindMapNodeModel selected = (freemind.modes.mindmapmode.MindMapNodeModel) it.next();
            setNodeBackgroundColor( selected, color );
        }
    }

    public static class RemoveNodeBackgroundColorAction extends freemind.modes.actions.NodeGeneralAction
    {

        private final freemind.modes.ModeController controller;

        public RemoveNodeBackgroundColorAction( final freemind.modes.ModeController controller )
        {
            super( controller, "remove_node_background_color", (java.lang.String) null );
            this.controller = controller;
            setSingleNodeOperation( new freemind.modes.actions.SingleNodeOperation(){
                public void apply( freemind.modes.mindmapmode.MindMapMapModel map, freemind.modes.mindmapmode.MindMapNodeModel node )
                {
                    controller.setNodeBackgroundColor( node, null );
                }
            } );
        }

    }

    public void setNodeBackgroundColor( freemind.modes.MindMapNode node, java.awt.Color color )
    {
        try {
            freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction doAction = createNodeBackgroundColorFormatAction( node, color );
            freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction undoAction = createNodeBackgroundColorFormatAction( node, node.getBackgroundColor() );
            controller.getActionFactory().startTransaction( this.getClass().getName() );
            controller.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
            controller.getActionFactory().endTransaction( this.getClass().getName() );
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
    }

    public freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction createNodeBackgroundColorFormatAction( freemind.modes.MindMapNode node, java.awt.Color color )
        throws javax.xml.bind.JAXBException
    {
        freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction nodeAction = controller.getActionXmlFactory().createNodeBackgroundColorFormatAction();
        nodeAction.setNode( node.getObjectId( controller ) );
        nodeAction.setColor( Tools.colorToXml( color ) );
        return nodeAction;
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        if (action instanceof freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction) {
            freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction nodeColorAction = (freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction) action;
            java.awt.Color color = Tools.xmlToColor( nodeColorAction.getColor() );
            freemind.modes.MindMapNode node = controller.getNodeFromID( nodeColorAction.getNode() );
            java.awt.Color oldColor = node.getBackgroundColor();
            if (!Tools.safeEquals( color, oldColor )) {
                node.setBackgroundColor( color );
                controller.nodeChanged( node );
            }
        }
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.NodeBackgroundColorFormatAction.class;
    }

}
