// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;
import java.util.logging.Logger;
import javax.swing.Action;
import javax.swing.ImageIcon;
import javax.swing.JMenuItem;
import javax.xml.bind.JAXBException;
import freemind.controller.MenuItemEnabledListener;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.FreemindAction;
import freemind.controller.actions.generated.instance.HookNodeAction;
import freemind.controller.actions.generated.instance.NodeListMember;
import freemind.controller.actions.generated.instance.NodeListMemberType;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.extensions.HookFactory;
import freemind.extensions.HookInstanciationMethod;
import freemind.extensions.NodeHook;
import freemind.extensions.PermanentNodeHook;
import freemind.modes.MindMapNode;
import freemind.modes.ModeController;


public class NodeHookAction extends freemind.controller.actions.FreemindAction implements freemind.controller.actions.ActorXml, freemind.controller.MenuItemEnabledListener
{

    java.lang.String _hookName;

    freemind.modes.ModeController controller;

    public freemind.modes.ModeController getController()
    {
        return controller;
    }

    private static java.util.logging.Logger logger;

    public NodeHookAction( java.lang.String hookName, freemind.modes.ModeController controller )
    {
        super( hookName, (javax.swing.ImageIcon) null, null );
        this._hookName = hookName;
        this.controller = controller;
        if (logger == null) {
            logger = controller.getFrame().getLogger( this.getClass().getName() );
        }
        controller.getActionFactory().registerActor( this, getDoActionClass() );
    }

    public void actionPerformed( java.awt.event.ActionEvent arg0 )
    {
        controller.getFrame().setWaitingCursor( true );
        invoke( controller.getSelected(), controller.getSelecteds() );
        controller.getFrame().setWaitingCursor( false );
    }

    public void addHook( freemind.modes.MindMapNode focussed, java.util.List selecteds, java.lang.String hookName )
    {
        freemind.controller.actions.generated.instance.HookNodeAction doAction = createHookNodeAction( focussed, selecteds, hookName );
        freemind.controller.actions.generated.instance.XmlAction undoAction = null;
        try {
            undoAction = controller.getActionXmlFactory().createCompoundAction();
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        if (getInstanciationMethod( hookName ).isPermanent()) {
            undoAction = createHookNodeAction( focussed, selecteds, hookName );
        }
        if (getInstanciationMethod( hookName ).isUndoable()) {
            getController().getActionFactory().startTransaction( (java.lang.String) getValue( NAME ) );
            getController().getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
            getController().getActionFactory().endTransaction( (java.lang.String) getValue( NAME ) );
        } else {
            invoke( focussed, selecteds, hookName );
        }
    }

    public void invoke( freemind.modes.MindMapNode focussed, java.util.List selecteds )
    {
        addHook( focussed, selecteds, _hookName );
    }

    private void invoke( freemind.modes.MindMapNode focussed, java.util.List selecteds, java.lang.String hookName )
    {
        logger.finest( "invoke(selecteds) called." );
        freemind.extensions.HookInstanciationMethod instMethod = getInstanciationMethod( hookName );
        java.util.Collection destinationNodes = instMethod.getDestinationNodes( controller, focussed, selecteds );
        freemind.modes.MindMapNode adaptedFocussedNode = instMethod.getCenterNode( controller, focussed, selecteds );
        if (instMethod.isAlreadyPresent( controller, hookName, adaptedFocussedNode, destinationNodes )) {
            for (java.util.Iterator i = destinationNodes.iterator(); i.hasNext();) {
                freemind.modes.MindMapNode currentDestinationNode = (freemind.modes.MindMapNode) i.next();
                for (java.util.Iterator j = currentDestinationNode.getActivatedHooks().iterator(); j.hasNext();) {
                    freemind.extensions.PermanentNodeHook hook = (freemind.extensions.PermanentNodeHook) j.next();
                    if (hook.getName().equals( hookName )) {
                        currentDestinationNode.removeHook( hook );
                        break;
                    }
                }
            }
        } else {
            for (java.util.Iterator it = destinationNodes.iterator(); it.hasNext();) {
                freemind.modes.MindMapNode currentDestinationNode = (freemind.modes.MindMapNode) it.next();
                freemind.extensions.NodeHook hook = controller.createNodeHook( hookName, currentDestinationNode, controller.getMap() );
                logger.finest( "created hook " + hookName );
                currentDestinationNode.invokeHook( hook );
                if (hook instanceof freemind.extensions.PermanentNodeHook) {
                    freemind.extensions.PermanentNodeHook permHook = (freemind.extensions.PermanentNodeHook) hook;
                    logger.finest( "This is a permanent hook " + hookName );
                    if (currentDestinationNode == adaptedFocussedNode) {
                        permHook.onReceiveFocusHook();
                    }
                    controller.nodeChanged( currentDestinationNode );
                }
            }
            finishInvocation( focussed, selecteds, adaptedFocussedNode, destinationNodes );
        }
    }

    private void finishInvocation( freemind.modes.MindMapNode focussed, java.util.List selecteds, freemind.modes.MindMapNode adaptedFocussedNode, java.util.Collection destinationNodes )
    {
        if (focussed.getViewer() != null) {
            getController().getView().selectAsTheOnlyOneSelected( focussed.getViewer() );
            getController().getView().scrollNodeToVisible( focussed.getViewer() );
            for (java.util.Iterator i = selecteds.iterator(); i.hasNext();) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) i.next();
                if (node.getViewer() != null) {
                    getController().getView().makeTheSelected( node.getViewer() );
                }
            }
        }
    }

    private freemind.extensions.HookInstanciationMethod getInstanciationMethod( java.lang.String hookName )
    {
        freemind.extensions.HookFactory factory = getHookFactory();
        freemind.extensions.HookInstanciationMethod instMethod = factory.getInstanciationMethod( hookName );
        return instMethod;
    }

    private freemind.extensions.HookFactory getHookFactory()
    {
        freemind.extensions.HookFactory factory = controller.getFrame().getHookFactory();
        return factory;
    }

    public boolean isEnabled( javax.swing.JMenuItem item, javax.swing.Action action )
    {
        freemind.extensions.HookFactory factory = getHookFactory();
        java.lang.Object baseClass = factory.getPluginBaseClass( _hookName );
        if (baseClass != null) {
            if (baseClass instanceof freemind.controller.MenuItemEnabledListener) {
                freemind.controller.MenuItemEnabledListener listener = (freemind.controller.MenuItemEnabledListener) baseClass;
                return listener.isEnabled( item, this );
            }
        }
        freemind.modes.MindMapNode focussed = controller.getSelected();
        java.util.List selecteds = controller.getSelecteds();
        freemind.extensions.HookInstanciationMethod instMethod = getInstanciationMethod( _hookName );
        java.util.Collection destinationNodes = instMethod.getDestinationNodes( controller, focussed, selecteds );
        freemind.modes.MindMapNode adaptedFocussedNode = instMethod.getCenterNode( controller, focussed, selecteds );
        boolean isActionSelected = instMethod.isAlreadyPresent( controller, _hookName, adaptedFocussedNode, destinationNodes );
        setSelected( item, isActionSelected );
        return true;
    }

    public freemind.controller.actions.generated.instance.HookNodeAction createHookNodeAction( freemind.modes.MindMapNode focussed, java.util.List selecteds, java.lang.String hookName )
    {
        try {
            freemind.controller.actions.generated.instance.HookNodeAction hookNodeAction = getController().getActionXmlFactory().createHookNodeAction();
            hookNodeAction.setNode( focussed.getObjectId( getController() ) );
            hookNodeAction.setHookName( hookName );
            for (java.util.Iterator i = selecteds.iterator(); i.hasNext();) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) i.next();
                freemind.controller.actions.generated.instance.NodeListMember nodeListMember = getController().getActionXmlFactory().createNodeListMember();
                nodeListMember.setNode( node.getObjectId( getController() ) );
                hookNodeAction.getNodeListMember().add( nodeListMember );
            }
            return hookNodeAction;
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
            return null;
        }
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        if (action instanceof freemind.controller.actions.generated.instance.HookNodeAction) {
            freemind.controller.actions.generated.instance.HookNodeAction hookNodeAction = (freemind.controller.actions.generated.instance.HookNodeAction) action;
            freemind.modes.MindMapNode selected = getController().getNodeFromID( hookNodeAction.getNode() );
            java.util.Vector selecteds = new java.util.Vector();
            for (java.util.Iterator i = hookNodeAction.getNodeListMember().iterator(); i.hasNext();) {
                freemind.controller.actions.generated.instance.NodeListMemberType node = (freemind.controller.actions.generated.instance.NodeListMemberType) i.next();
                selecteds.add( getController().getNodeFromID( node.getNode() ) );
            }
            invoke( selected, selecteds, hookNodeAction.getHookName() );
        }
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.HookNodeAction.class;
    }

    public java.lang.String getHookName()
    {
        return _hookName;
    }

}
