// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.TreeSet;
import java.util.Vector;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.xml.bind.JAXBException;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.generated.instance.CompoundAction;
import freemind.controller.actions.generated.instance.FoldAction;
import freemind.controller.actions.generated.instance.MoveNodesAction;
import freemind.controller.actions.generated.instance.NodeListMember;
import freemind.controller.actions.generated.instance.NodeListMemberType;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.modes.ControllerAdapter;
import freemind.modes.MapAdapter;
import freemind.modes.MindMapNode;


public class NodeUpAction extends AbstractAction implements freemind.controller.actions.ActorXml
{

    private final freemind.modes.ControllerAdapter modeController;

    private static java.util.logging.Logger logger;

    public NodeUpAction( freemind.modes.ControllerAdapter modeController )
    {
        super( modeController.getText( "node_up" ) );
        this.modeController = modeController;
        modeController.getActionFactory().registerActor( this, getDoActionClass() );
        if (logger == null) {
            logger = modeController.getFrame().getLogger( this.getClass().getName() );
        }
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        moveNodes( modeController.getSelected(), modeController.getSelecteds(), -1 );
    }

    public void moveNodes( freemind.modes.MindMapNode selected, java.util.List selecteds, int direction )
    {
        freemind.controller.actions.generated.instance.MoveNodesAction doAction = createMoveNodesAction( selected, selecteds, direction );
        freemind.controller.actions.generated.instance.MoveNodesAction undoAction = createMoveNodesAction( selected, selecteds, -direction );
        modeController.getActionFactory().startTransaction( (java.lang.String) getValue( NAME ) );
        modeController.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
        modeController.getActionFactory().endTransaction( (java.lang.String) getValue( NAME ) );
    }

    public void _moveNodes( freemind.modes.MindMapNode selected, java.util.List selecteds, int direction )
    {
        java.util.Comparator comparator = direction == -1 ? null : new java.util.Comparator(){
            public int compare( java.lang.Object o1, java.lang.Object o2 )
            {
                int i1 = ((java.lang.Integer) o1).intValue();
                int i2 = ((java.lang.Integer) o2).intValue();
                return i2 - i1;
            }
        };
        if (!selected.isRoot()) {
            freemind.modes.MindMapNode parent = selected.getParentNode();
            java.util.Vector sortedChildren = getSortedSiblings( parent );
            java.util.TreeSet range = new java.util.TreeSet( comparator );
            for (java.util.Iterator i = selecteds.iterator(); i.hasNext();) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) i.next();
                if (node.getParent() != parent) {
                    logger.warning( "Not all selected nodes have the same parent." );
                    return;
                }
                range.add( new java.lang.Integer( sortedChildren.indexOf( node ) ) );
            }
            java.lang.Integer last = (java.lang.Integer) range.iterator().next();
            for (java.util.Iterator i = range.iterator(); i.hasNext();) {
                java.lang.Integer newInt = (java.lang.Integer) i.next();
                if (Math.abs( newInt.intValue() - last.intValue() ) > 1) {
                    logger.warning( "Not adjacent nodes. Skipped. " );
                    return;
                }
                last = newInt;
            }
            for (java.util.Iterator i = range.iterator(); i.hasNext();) {
                java.lang.Integer position = (java.lang.Integer) i.next();
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) sortedChildren.get( position.intValue() );
                moveNodeTo( node, parent, direction );
            }
            modeController.getView().selectAsTheOnlyOneSelected( selected.getViewer() );
            modeController.getView().scrollNodeToVisible( selected.getViewer() );
            for (java.util.Iterator i = range.iterator(); i.hasNext();) {
                java.lang.Integer position = (java.lang.Integer) i.next();
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) sortedChildren.get( position.intValue() );
                modeController.getView().makeTheSelected( node.getViewer() );
            }
            modeController.getController().obtainFocusForSelected();
        }
    }

    public int moveNodeTo( freemind.modes.MindMapNode newChild, freemind.modes.MindMapNode parent, int direction )
    {
        freemind.modes.MapAdapter model = modeController.getModel();
        int index = model.getIndexOfChild( parent, newChild );
        int newIndex = index;
        if (newChild.isLeft() != null) {
            int maxIndex = parent.getChildCount();
            java.util.Vector sortedNodesIndices = getSortedSiblings( parent );
            int newPositionInVector = sortedNodesIndices.indexOf( newChild ) + direction;
            if (newPositionInVector < 0) {
                newPositionInVector = maxIndex - 1;
            }
            if (newPositionInVector >= maxIndex) {
                newPositionInVector = 0;
            }
            freemind.modes.MindMapNode destinationNode = (freemind.modes.MindMapNode) sortedNodesIndices.get( newPositionInVector );
            newIndex = model.getIndexOfChild( parent, destinationNode );
            newChild.setLeft( destinationNode.isLeft().getValue() );
            model.removeNodeFromParent( newChild );
            model.insertNodeInto( newChild, parent, newIndex );
            modeController.nodeStructureChanged( parent );
        }
        return newIndex;
    }

    private java.util.Vector getSortedSiblings( freemind.modes.MindMapNode node )
    {
        java.util.Vector nodes = new java.util.Vector();
        for (java.util.Iterator i = node.childrenUnfolded(); i.hasNext();) {
            nodes.add( i.next() );
        }
        Collections.sort( nodes, new java.util.Comparator(){
            public int compare( java.lang.Object o1, java.lang.Object o2 )
            {
                if (o1 instanceof freemind.modes.MindMapNode) {
                    freemind.modes.MindMapNode n1 = (freemind.modes.MindMapNode) o1;
                    if (o2 instanceof freemind.modes.MindMapNode) {
                        freemind.modes.MindMapNode n2 = (freemind.modes.MindMapNode) o2;
                        if (n1.isLeft() != null && n2.isLeft() != null) {
                            int b1 = n1.isLeft().getValue() ? 0 : 1;
                            int b2 = n2.isLeft().getValue() ? 0 : 1;
                            return b1 - b2;
                        }
                    }
                }
                throw new java.lang.IllegalArgumentException( "Elements in LeftRightComparator are not comparable." );
            }
        } );
        return nodes;
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        if (action instanceof freemind.controller.actions.generated.instance.MoveNodesAction) {
            freemind.controller.actions.generated.instance.MoveNodesAction moveAction = (freemind.controller.actions.generated.instance.MoveNodesAction) action;
            freemind.modes.MindMapNode selected = modeController.getNodeFromID( moveAction.getNode() );
            java.util.Vector selecteds = new java.util.Vector();
            for (java.util.Iterator i = moveAction.getNodeListMember().iterator(); i.hasNext();) {
                freemind.controller.actions.generated.instance.NodeListMemberType node = (freemind.controller.actions.generated.instance.NodeListMemberType) i.next();
                selecteds.add( modeController.getNodeFromID( node.getNode() ) );
            }
            _moveNodes( selected, selecteds, moveAction.getDirection() );
        }
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.MoveNodesAction.class;
    }

    private freemind.controller.actions.generated.instance.MoveNodesAction createMoveNodesAction( freemind.modes.MindMapNode selected, java.util.List selecteds, int direction )
    {
        try {
            freemind.controller.actions.generated.instance.MoveNodesAction moveAction = modeController.getActionXmlFactory().createMoveNodesAction();
            moveAction.setDirection( direction );
            moveAction.setNode( selected.getObjectId( modeController ) );
            for (java.util.Iterator i = selecteds.iterator(); i.hasNext();) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) i.next();
                freemind.controller.actions.generated.instance.NodeListMember nodeListMember = modeController.getActionXmlFactory().createNodeListMember();
                nodeListMember.setNode( node.getObjectId( modeController ) );
                moveAction.getNodeListMember().add( nodeListMember );
            }
            return moveAction;
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        return null;
    }

}
