// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.util.ListIterator;
import java.util.Vector;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.xml.bind.JAXBException;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.generated.instance.CompoundAction;
import freemind.controller.actions.generated.instance.FoldAction;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.main.Tools;
import freemind.modes.ControllerAdapter;
import freemind.modes.MindMapNode;


public class ToggleFoldedAction extends AbstractAction implements freemind.controller.actions.ActorXml
{

    private final freemind.modes.ControllerAdapter modeController;

    private java.util.logging.Logger logger;

    public ToggleFoldedAction( freemind.modes.ControllerAdapter controller )
    {
        super( controller.getText( "toggle_folded" ) );
        this.modeController = controller;
        modeController.getActionFactory().registerActor( this, getDoActionClass() );
        logger = modeController.getFrame().getLogger( this.getClass().getName() );
    }

    public void actionPerformed( java.awt.event.ActionEvent e )
    {
        toggleFolded();
    }

    public void toggleFolded()
    {
        toggleFolded( modeController.getSelecteds().listIterator() );
    }

    public void toggleFolded( java.util.ListIterator listIterator )
    {
        boolean fold = getFoldingState( reset( listIterator ) );
        freemind.controller.actions.generated.instance.CompoundAction doAction = createFoldAction( reset( listIterator ), fold, false );
        freemind.controller.actions.generated.instance.CompoundAction undoAction = createFoldAction( reset( listIterator ), !fold, true );
        modeController.getActionFactory().startTransaction( (java.lang.String) getValue( NAME ) );
        modeController.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
        modeController.getActionFactory().endTransaction( (java.lang.String) getValue( NAME ) );
    }

    java.util.ListIterator reset( java.util.ListIterator iterator )
    {
        while (iterator.hasPrevious()) {
            iterator.previous();
        }
        return iterator;
    }

    private boolean getFoldingState( java.util.ListIterator iterator )
    {
        freemind.main.Tools.BooleanHolder state = null;
        boolean allNodeHaveSameFoldedStatus = true;
        for (java.util.ListIterator it = iterator; it.hasNext();) {
            freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) it.next();
            if (node.getChildCount() == 0) {
                continue;
            }
            if (state == null) {
                state = new freemind.main.Tools.BooleanHolder();
                state.setValue( node.isFolded() );
            } else {
                if (node.isFolded() != state.getValue()) {
                    allNodeHaveSameFoldedStatus = false;
                    break;
                }
            }
        }
        boolean fold = true;
        if (allNodeHaveSameFoldedStatus && state != null) {
            fold = !state.getValue();
        }
        return fold;
    }

    private freemind.controller.actions.generated.instance.CompoundAction createFoldAction( java.util.ListIterator iterator, boolean fold, boolean undo )
    {
        try {
            freemind.controller.actions.generated.instance.CompoundAction comp = modeController.getActionXmlFactory().createCompoundAction();
            freemind.modes.MindMapNode lastNode = null;
            for (java.util.ListIterator it = iterator; it.hasNext();) {
                freemind.modes.MindMapNode node = (freemind.modes.MindMapNode) it.next();
                freemind.controller.actions.generated.instance.FoldAction foldAction = createSingleFoldAction( fold, node, undo );
                if (foldAction != null) {
                    if (!undo) {
                        comp.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( foldAction );
                    } else {
                        comp.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( 0, foldAction );
                    }
                    lastNode = node;
                }
            }
            logger.finest( "Compound contains " + comp.getCompoundActionOrSelectNodeActionOrCutNodeAction().size() + " elements." );
            return comp;
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        return null;
    }

    private freemind.controller.actions.generated.instance.FoldAction createSingleFoldAction( boolean fold, freemind.modes.MindMapNode node, boolean undo )
    {
        freemind.controller.actions.generated.instance.FoldAction foldAction = null;
        try {
            if (undo && node.isFolded() == fold || !undo && node.isFolded() != fold) {
                if (node.hasChildren() || Tools.safeEquals( modeController.getFrame().getProperty( "enable_leaves_folding" ), "true" )) {
                    foldAction = modeController.getActionXmlFactory().createFoldAction();
                    foldAction.setFolded( fold );
                    foldAction.setNode( modeController.getNodeID( node ) );
                }
            }
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
        return foldAction;
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        if (action instanceof freemind.controller.actions.generated.instance.FoldAction) {
            freemind.controller.actions.generated.instance.FoldAction foldAction = (freemind.controller.actions.generated.instance.FoldAction) action;
            freemind.modes.MindMapNode node = modeController.getNodeFromID( foldAction.getNode() );
            boolean fold = foldAction.isFolded();
            _setFolded( node, fold );
        }
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.FoldAction.class;
    }

    public void setFolded( freemind.modes.MindMapNode node, boolean folded )
    {
        freemind.controller.actions.generated.instance.FoldAction doAction = createSingleFoldAction( folded, node, false );
        freemind.controller.actions.generated.instance.FoldAction undoAction = createSingleFoldAction( !folded, node, true );
        if (doAction == null || undoAction == null) {
            return;
        }
        modeController.getActionFactory().startTransaction( (java.lang.String) getValue( NAME ) );
        modeController.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, undoAction ) );
        modeController.getActionFactory().endTransaction( (java.lang.String) getValue( NAME ) );
    }

    private void _setFolded( freemind.modes.MindMapNode node, boolean folded )
    {
        if (node == null) {
            throw new java.lang.IllegalArgumentException( "setFolded was called with a null node." );
        }
        if (node.isRoot() && folded) {
            return;
        }
        if (node.isFolded() != folded) {
            node.setFolded( folded );
            modeController.nodeStructureChanged( node );
        }
    }

}
