// This is mutant program.
// Author : ysma

package freemind.modes.actions;


import java.awt.event.ActionEvent;
import java.util.Iterator;
import java.util.Vector;
import java.util.logging.Logger;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.xml.bind.JAXBException;
import freemind.controller.actions.AbstractXmlAction;
import freemind.controller.actions.ActionPair;
import freemind.controller.actions.ActorXml;
import freemind.controller.actions.generated.instance.CompoundAction;
import freemind.controller.actions.generated.instance.CompoundActionType;
import freemind.controller.actions.generated.instance.UndoXmlAction;
import freemind.controller.actions.generated.instance.XmlAction;
import freemind.modes.ControllerAdapter;
import freemind.modes.ModeController;


public class UndoAction extends freemind.controller.actions.AbstractXmlAction implements freemind.controller.actions.ActorXml
{

    private freemind.modes.ControllerAdapter controller;

    private boolean isUndoAction;

    protected java.util.Vector actionPairList = new java.util.Vector();

    private long timeOfLastAdd = 0;

    private static final long TIME_TO_BEGIN_NEW_ACTION = 100;

    protected static java.util.logging.Logger logger;

    public UndoAction( freemind.modes.ControllerAdapter controller )
    {
        this( controller, controller.getText( "undo" ), new javax.swing.ImageIcon( controller.getResource( "images/undo.png" ) ), controller );
        this.controller = controller;
        if (logger == null) {
            logger = controller.getFrame().getLogger( this.getClass().toString() );
        }
    }

    protected UndoAction( freemind.modes.ControllerAdapter adapter, java.lang.String text, javax.swing.Icon icon, freemind.modes.ModeController mode )
    {
        super( text, icon, mode );
        this.controller = adapter;
        addActor( this );
        setEnabled( false );
        isUndoAction = false;
    }

    public boolean isUndoAction()
    {
        return isUndoAction;
    }

    protected void xmlActionPerformed( java.awt.event.ActionEvent arg0 )
        throws javax.xml.bind.JAXBException
    {
        if (actionPairList.size() > 0) {
            freemind.controller.actions.ActionPair pair = (freemind.controller.actions.ActionPair) actionPairList.get( 0 );
            informUndoPartner( pair );
            actionPairList.remove( 0 );
            undoDoAction( pair );
            if (actionPairList.size() == 0) {
                this.setEnabled( false );
            }
        } else {
            setEnabled( false );
        }
    }

    protected void informUndoPartner( freemind.controller.actions.ActionPair pair )
    {
        this.controller.redo.add( pair.reverse() );
        this.controller.redo.setEnabled( true );
    }

    protected void undoDoAction( freemind.controller.actions.ActionPair pair )
        throws javax.xml.bind.JAXBException
    {
        java.lang.String doActionString = this.controller.marshall( pair.getDoAction() );
        java.lang.String redoActionString = this.controller.marshall( pair.getUndoAction() );
        freemind.controller.actions.generated.instance.UndoXmlAction undoAction = this.controller.getActionXmlFactory().createUndoXmlAction();
        undoAction.setDescription( redoActionString );
        undoAction.setRemedia( doActionString );
        freemind.controller.actions.generated.instance.UndoXmlAction redoAction = this.controller.getActionXmlFactory().createUndoXmlAction();
        redoAction.setDescription( doActionString );
        undoAction.setRemedia( redoActionString );
        isUndoAction = true;
        this.controller.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( undoAction, redoAction ) );
        isUndoAction = false;
    }

    public void act( freemind.controller.actions.generated.instance.XmlAction action )
    {
        freemind.controller.actions.generated.instance.UndoXmlAction undoAction = (freemind.controller.actions.generated.instance.UndoXmlAction) action;
        freemind.controller.actions.generated.instance.XmlAction doAction = this.controller.unMarshall( undoAction.getDescription() );
        freemind.controller.actions.generated.instance.XmlAction redoAction = this.controller.unMarshall( undoAction.getRemedia() );
        this.controller.getActionFactory().executeAction( new freemind.controller.actions.ActionPair( doAction, redoAction ) );
    }

    public java.lang.Class getDoActionClass()
    {
        return freemind.controller.actions.generated.instance.UndoXmlAction.class;
    }

    public void setEnabled( boolean arg0 )
    {
        if (arg0) {
            super.setEnabled( actionPairList.size() != 0 );
        } else {
            super.setEnabled( false );
        }
    }

    public void add( freemind.controller.actions.ActionPair pair )
    {
        try {
            long currentTime = System.currentTimeMillis();
            if (actionPairList.size() > 0 && currentTime - timeOfLastAdd < TIME_TO_BEGIN_NEW_ACTION) {
                freemind.controller.actions.ActionPair firstPair = (freemind.controller.actions.ActionPair) actionPairList.get( 0 );
                freemind.controller.actions.generated.instance.CompoundAction action;
                freemind.controller.actions.generated.instance.CompoundAction remedia;
                if (!(firstPair.getDoAction() instanceof freemind.controller.actions.generated.instance.CompoundActionType) || !(firstPair.getUndoAction() instanceof freemind.controller.actions.generated.instance.CompoundActionType)) {
                    action = controller.getActionXmlFactory().createCompoundAction();
                    action.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( firstPair.getDoAction() );
                    remedia = controller.getActionXmlFactory().createCompoundAction();
                    remedia.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( firstPair.getUndoAction() );
                    actionPairList.remove( 0 );
                    actionPairList.add( 0, new freemind.controller.actions.ActionPair( action, remedia ) );
                    firstPair = (freemind.controller.actions.ActionPair) actionPairList.get( 0 );
                } else {
                    action = (freemind.controller.actions.generated.instance.CompoundAction) firstPair.getDoAction();
                    remedia = (freemind.controller.actions.generated.instance.CompoundAction) firstPair.getUndoAction();
                }
                action.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( pair.getDoAction() );
                remedia.getCompoundActionOrSelectNodeActionOrCutNodeAction().add( 0, pair.getUndoAction() );
            } else {
                actionPairList.add( 0, pair );
                int maxEntries = 100;
                try {
                    maxEntries = (new java.lang.Integer( controller.getFrame().getProperty( "undo_levels" ) )).intValue();
                } catch ( java.lang.NumberFormatException e ) {
                    e.printStackTrace();
                }
                while (actionPairList.size() > maxEntries) {
                    actionPairList.remove( actionPairList.size() - 1 );
                }
            }
            timeOfLastAdd = currentTime;
        } catch ( javax.xml.bind.JAXBException e ) {
            e.printStackTrace();
        }
    }

    public void clear()
    {
        actionPairList.clear();
    }

    public void print()
    {
        logger.info( "Undo list:" );
        int j = 0;
        for (java.util.Iterator i = actionPairList.iterator(); i.hasNext();) {
            freemind.controller.actions.ActionPair pair = (freemind.controller.actions.ActionPair) i.next();
            logger.info( "line " + j++ + " = " + controller.marshall( pair.getDoAction() ) );
        }
    }

}
