// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import freemind.modes.MindMapArrowLink;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.geom.Point2D;
import java.awt.Rectangle;
import java.awt.geom.Rectangle2D;
import java.awt.geom.FlatteningPathIterator;
import java.awt.geom.PathIterator;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;
import freemind.view.mindmapview.ConvexHull;
import java.awt.Polygon;
import java.awt.Rectangle;
import java.awt.BasicStroke;
import java.awt.Stroke;
import java.awt.Shape;
import java.awt.geom.CubicCurve2D;
import java.awt.RenderingHints;


public class ArrowLinkView
{

    protected freemind.modes.MindMapArrowLink arrowLinkModel;

    protected freemind.view.mindmapview.NodeView source;

    protected freemind.view.mindmapview.NodeView target;

    protected int iterativeLevel;

    protected java.awt.geom.CubicCurve2D arrowLinkCurve;

    static final java.awt.Stroke DEF_STROKE = new java.awt.BasicStroke( 1 );

    protected ArrowLinkView( freemind.modes.MindMapArrowLink arrowLinkModel, freemind.view.mindmapview.NodeView source, freemind.view.mindmapview.NodeView target )
    {
        this.arrowLinkModel = arrowLinkModel;
        this.source = source;
        this.target = target;
    }

    public java.awt.Rectangle getBounds()
    {
        if (arrowLinkCurve == null) {
            return new java.awt.Rectangle();
        }
        return arrowLinkCurve.getBounds();
    }

    public void paint( java.awt.Graphics graphics )
    {
        java.awt.Point p1 = null;
        java.awt.Point p2 = null;
        java.awt.Point p3 = null;
        java.awt.Point p4 = null;
        boolean targetIsLeft = false;
        boolean sourceIsLeft = false;
        java.awt.Graphics2D g = (java.awt.Graphics2D) graphics.create();
        setRendering( g );
        g.setColor( getColor() );
        g.setStroke( getStroke() );
        if (source == null || target == null) {
            g.setStroke( new java.awt.BasicStroke( getWidth(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 0, new float[]{ 0, 3, 0, 3 }, 0 ) );
        }
        if (source != null) {
            p1 = source.getLinkPoint( arrowLinkModel.getStartInclination() );
            sourceIsLeft = source.isLeft();
        }
        if (target != null) {
            p2 = target.getLinkPoint( arrowLinkModel.getEndInclination() );
            targetIsLeft = target.isLeft();
        }
        if (arrowLinkModel.getEndInclination() == null || arrowLinkModel.getStartInclination() == null) {
            double dellength = source != null && target != null ? p1.distance( p2 ) / getZoom() : 30;
            if (source != null && arrowLinkModel.getStartInclination() == null) {
                java.awt.Point incl = calcInclination( source, dellength );
                arrowLinkModel.setStartInclination( incl );
                p1 = source.getLinkPoint( arrowLinkModel.getStartInclination() );
            }
            if (target != null && arrowLinkModel.getEndInclination() == null) {
                java.awt.Point incl = calcInclination( target, dellength );
                incl.y = -incl.y;
                arrowLinkModel.setEndInclination( incl );
                p2 = target.getLinkPoint( arrowLinkModel.getEndInclination() );
            }
        }
        arrowLinkCurve = new java.awt.geom.CubicCurve2D.Double();
        if (p1 != null) {
            p3 = new java.awt.Point( p1 );
            p3.translate( (sourceIsLeft ? -1 : 1) * getMap().getZoomed( arrowLinkModel.getStartInclination().x ), getMap().getZoomed( arrowLinkModel.getStartInclination().y ) );
            if (p2 == null) {
                arrowLinkCurve.setCurve( p1, p3, p1, p3 );
            }
        }
        if (p2 != null) {
            p4 = new java.awt.Point( p2 );
            p4.translate( (targetIsLeft ? -1 : 1) * getMap().getZoomed( arrowLinkModel.getEndInclination().x ), getMap().getZoomed( arrowLinkModel.getEndInclination().y ) );
            if (p1 == null) {
                arrowLinkCurve.setCurve( p2, p4, p2, p4 );
            }
        }
        if (p1 != null && p2 != null) {
            arrowLinkCurve.setCurve( p1, p3, p4, p2 );
            g.draw( arrowLinkCurve );
        }
        if (source != null && !arrowLinkModel.getStartArrow().equals( "None" )) {
            paintArrow( p1, p3, g );
        }
        if (target != null && !arrowLinkModel.getEndArrow().equals( "None" )) {
            paintArrow( p2, p4, g );
        }
        if (arrowLinkModel.getShowControlPointsFlag() || source == null || target == null) {
            g.setStroke( new java.awt.BasicStroke( getWidth(), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND, 0, new float[]{ 0, 3, 0, 3 }, 0 ) );
            if (p1 != null) {
                g.drawLine( p1.x, p1.y, p3.x, p3.y );
            }
            if (p2 != null) {
                g.drawLine( p2.x, p2.y, p4.x, p4.y );
            }
        }
    }

    private java.awt.Point calcInclination( freemind.view.mindmapview.NodeView node, double dellength )
    {
        return new java.awt.Point( (int) dellength, 0 );
    }

    private void paintArrow( java.awt.Point p1, java.awt.Point p3, java.awt.Graphics2D g )
    {
        double dx;
        double dy;
        double dxn;
        double dyn;
        dx = p3.x - p1.x;
        dy = p3.y - p1.y;
        double length = Math.sqrt( dx * dx + dy * dy ) / (getZoom() * 10);
        dxn = dx / length;
        dyn = dy / length;
        double width = .5f;
        java.awt.Polygon p = new java.awt.Polygon();
        p.addPoint( (int) p1.x, (int) p1.y );
        p.addPoint( (int) (p1.x + dxn + width * dyn), (int) (p1.y + dyn - width * dxn) );
        p.addPoint( (int) (p1.x + dxn - width * dyn), (int) (p1.y + dyn + width * dxn) );
        p.addPoint( (int) p1.x, (int) p1.y );
        g.fillPolygon( p );
    }

    private final int MAXIMAL_RECTANGLE_SIZE_FOR_COLLISION_DETECTION = 16;

    public boolean detectCollision( java.awt.Point p )
    {
        if (arrowLinkCurve == null) {
            return false;
        }
        java.awt.geom.Rectangle2D rec = getControlPoint( p );
        java.awt.geom.FlatteningPathIterator pi = new java.awt.geom.FlatteningPathIterator( arrowLinkCurve.getPathIterator( null ), MAXIMAL_RECTANGLE_SIZE_FOR_COLLISION_DETECTION / 4, 10 );
        double oldCoordinateX = 0;
        double oldCoordinateY = 0;
        while (pi.isDone() == false) {
            double[] coordinates = new double[6];
            int type = pi.currentSegment( coordinates );
            switch (type) {
            case PathIterator.SEG_LINETO :
                if (rec.intersectsLine( oldCoordinateX, oldCoordinateY, coordinates[0], coordinates[1] )) {
                    return true;
                }

            case PathIterator.SEG_MOVETO :
                oldCoordinateX = coordinates[0];
                oldCoordinateY = coordinates[1];
                break;

            case PathIterator.SEG_QUADTO :
            case PathIterator.SEG_CUBICTO :
            case PathIterator.SEG_CLOSE :
            default  :
                break;

            }
            pi.next();
        }
        return false;
    }

    protected java.awt.geom.Rectangle2D getControlPoint( java.awt.geom.Point2D p )
    {
        int side = MAXIMAL_RECTANGLE_SIZE_FOR_COLLISION_DETECTION;
        return new java.awt.geom.Rectangle2D.Double( p.getX() - side / 2, p.getY() - side / 2, side, side );
    }

    public java.awt.Color getColor()
    {
        return getModel().getColor();
    }

    public java.awt.Stroke getStroke()
    {
        java.awt.Stroke result = getModel().getStroke();
        if (result == null) {
            return DEF_STROKE;
        }
        return result;
    }

    public int getWidth()
    {
        return getModel().getWidth();
    }

    public int getRealWidth()
    {
        int width = getWidth();
        return width < 1 ? 1 : width;
    }

    protected freemind.view.mindmapview.MapView getMap()
    {
        return source == null ? target.getMap() : source.getMap();
    }

    public freemind.modes.MindMapArrowLink getModel()
    {
        return arrowLinkModel;
    }

    protected double getZoom()
    {
        return getMap().getZoom();
    }

    protected void setRendering( java.awt.Graphics2D g )
    {
        if (getMap().getController().getAntialiasEdges() || getMap().getController().getAntialiasAll()) {
            g.setRenderingHint( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
        }
    }

    public void changeInclination( int originX, int originY, int newX, int newY )
    {
    }

}
