// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import freemind.modes.MindMapNode;
import java.awt.*;


public class BubbleNodeView extends freemind.view.mindmapview.MoveableNodeView
{

    private static final java.awt.Stroke BOLD_STROKE = new java.awt.BasicStroke( 2.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, 1f, new float[]{ 2f, 2f }, 0f );

    private static final java.awt.Stroke DEF_STROKE = new java.awt.BasicStroke();

    public BubbleNodeView( freemind.modes.MindMapNode model, freemind.view.mindmapview.MapView map )
    {
        super( model, map );
    }

    protected int getExtendedWidth( int width )
    {
        int dW = getZoomedFoldingSymbolHalfWidth() * 2;
        if (getModel().isFolded()) {
            width += dW;
        }
        return width + dW;
    }

    public int getExtendedX()
    {
        int x = getX();
        if (getModel().isFolded() && isLeft()) {
            x -= getZoomedFoldingSymbolHalfWidth() * 2;
        }
        return x;
    }

    public void paintSelected( java.awt.Graphics2D graphics, java.awt.Dimension size )
    {
        super.paintSelected( graphics, size );
        if (this.isSelected()) {
            graphics.setColor( selectedColor );
            graphics.fillRoundRect( 0, 0, size.width - 1, size.height - 1, 10, 10 );
        }
    }

    public void paintFoldingMark( java.awt.Graphics2D g )
    {
        if (getModel().isFolded()) {
            int height = getSize().height / 2;
            final int MAX_HEIGHT = 50;
            if (height > MAX_HEIGHT) {
                height = MAX_HEIGHT;
            }
            java.awt.Point ovalStartPoint = getOutPoint();
            if (isLeft()) {
                ovalStartPoint.translate( -getZoomedFoldingSymbolHalfWidth() * 2, -getZoomedFoldingSymbolHalfWidth() );
            } else {
                ovalStartPoint.translate( 0, -getZoomedFoldingSymbolHalfWidth() );
            }
            g.drawOval( ovalStartPoint.x, ovalStartPoint.y, getZoomedFoldingSymbolHalfWidth() * 2, getZoomedFoldingSymbolHalfWidth() * 2 );
        }
    }

    public void paint( java.awt.Graphics graphics )
    {
        java.awt.Graphics2D g = (java.awt.Graphics2D) graphics;
        java.awt.Dimension size = getSize();
        if (this.getModel() == null) {
            return;
        }
        paintSelected( g, size );
        paintDragOver( g, size );
        setRendering( g );
        g.setColor( getEdge().getColor() );
        if (map.getController().getAntialiasEdges()) {
            g.setRenderingHint( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON );
        }
        g.drawRoundRect( 0, 0, size.width - 1, size.height - 1, 10, 10 );
        if (map.getController().getAntialiasEdges()) {
            g.setRenderingHint( RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_OFF );
        }
        g.setStroke( DEF_STROKE );
        super.paint( g );
    }

    java.awt.Point getOutPoint()
    {
        java.awt.Dimension size = getSize();
        if (isLeft()) {
            return new java.awt.Point( getLocation().x, getLocation().y + size.height / 2 );
        } else {
            return new java.awt.Point( getLocation().x + size.width, getLocation().y + size.height / 2 );
        }
    }

    java.awt.Point getInPoint()
    {
        java.awt.Dimension size = getSize();
        if (isLeft()) {
            return new java.awt.Point( getLocation().x + size.width, getLocation().y + size.height / 2 );
        } else {
            return new java.awt.Point( getLocation().x, getLocation().y + size.height / 2 );
        }
    }

    int getAlignment()
    {
        return ALIGN_CENTER;
    }

    protected void paintBackground( java.awt.Graphics2D graphics, java.awt.Dimension size, java.awt.Color color )
    {
        graphics.setColor( color );
        graphics.fillRoundRect( 0, 0, size.width - 1, size.height - 1, 10, 10 );
    }

    java.lang.String getStyle()
    {
        return MindMapNode.STYLE_BUBBLE;
    }

    public java.awt.Dimension getPreferredSize()
    {
        java.awt.Dimension prefSize = super.getPreferredSize();
        prefSize.width += 5;
        return prefSize;
    }

}
