// This is mutant program.
// Author : ysma

package freemind.view.mindmapview;


import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.KeyboardFocusManager;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DropTargetListener;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyEvent;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Map;
import java.util.TreeMap;
import java.util.Vector;
import javax.swing.JPanel;
import javax.swing.JViewport;
import javax.swing.event.TreeModelEvent;
import javax.swing.event.TreeModelListener;
import freemind.controller.Controller;
import freemind.controller.NodeKeyListener;
import freemind.controller.NodeMotionListener;
import freemind.controller.NodeMouseMotionListener;
import freemind.extensions.PermanentNodeHook;
import freemind.main.Tools;
import freemind.modes.MindMap;
import freemind.modes.MindMapArrowLink;
import freemind.modes.MindMapLink;
import freemind.modes.MindMapNode;


public class MapView extends JPanel implements java.awt.print.Printable
{

    private class Selected
    {

        private java.util.Vector mySelected = new java.util.Vector();

        public Selected()
        {
        }

        public void clear()
        {
            if (size() > 0) {
                removeSelectionForHooks( get( 0 ) );
            }
            mySelected.clear();
            logger.finest( "Cleared selected." );
        }

        public int size()
        {
            return mySelected.size();
        }

        public void remove( freemind.view.mindmapview.NodeView node )
        {
            if (mySelected.indexOf( node ) == 0) {
                removeSelectionForHooks( node );
            }
            mySelected.remove( node );
            logger.finest( "Removed selected " + node );
        }

        public void add( freemind.view.mindmapview.NodeView node )
        {
            if (size() > 0) {
                removeSelectionForHooks( get( 0 ) );
            }
            mySelected.add( 0, node );
            addSelectionForHooks( node );
            logger.finest( "Added selected " + node + "\nAll=" + mySelected );
        }

        private void removeSelectionForHooks( freemind.view.mindmapview.NodeView node )
        {
            if (node.getModel() == null) {
                return;
            }
            for (java.util.Iterator i = node.getModel().getActivatedHooks().iterator(); i.hasNext();) {
                freemind.extensions.PermanentNodeHook hook = (freemind.extensions.PermanentNodeHook) i.next();
                hook.onLooseFocusHook();
            }
        }

        private void addSelectionForHooks( freemind.view.mindmapview.NodeView node )
        {
            for (java.util.Iterator i = node.getModel().getActivatedHooks().iterator(); i.hasNext();) {
                freemind.extensions.PermanentNodeHook hook = (freemind.extensions.PermanentNodeHook) i.next();
                hook.onReceiveFocusHook();
            }
        }

        public freemind.view.mindmapview.NodeView get( int i )
        {
            return (freemind.view.mindmapview.NodeView) mySelected.get( i );
        }

        public boolean contains( freemind.view.mindmapview.NodeView node )
        {
            return mySelected.contains( node );
        }

        public void moveToFirst( freemind.view.mindmapview.NodeView newSelected )
        {
            if (contains( newSelected )) {
                int pos = mySelected.indexOf( newSelected );
                if (pos > 0) {
                    if (size() > 0) {
                        removeSelectionForHooks( get( 0 ) );
                    }
                    mySelected.remove( newSelected );
                    mySelected.add( 0, newSelected );
                }
            } else {
                add( newSelected );
            }
            addSelectionForHooks( newSelected );
            logger.finest( "MovedToFront selected " + newSelected + "\nAll=" + mySelected );
        }

    }

    private static java.util.logging.Logger logger;

    private class DelayedScroller extends java.awt.event.ComponentAdapter
    {

        public void componentMoved( java.awt.event.ComponentEvent e )
        {
            if (m_map != null) {
                m_map.scrollNodeToVisible( m_node, m_extraWidth );
            }
            m_map = null;
            m_node = null;
        }

        public void scrollNodeToVisible( freemind.view.mindmapview.MapView map, freemind.view.mindmapview.NodeView node, int extraWidth )
        {
            deactivate();
            m_map = map;
            m_node = node;
            m_extraWidth = extraWidth;
            node.addComponentListener( this );
        }

        public void deactivate()
        {
            if (m_node != null) {
                m_node.removeComponentListener( this );
            }
        }

        freemind.view.mindmapview.MapView m_map = null;

        freemind.view.mindmapview.NodeView m_node = null;

        int m_extraWidth = 0;

    }

    private freemind.view.mindmapview.MapView.DelayedScroller m_delayedScroller = new freemind.view.mindmapview.MapView.DelayedScroller();

    private freemind.modes.MindMap model;

    private freemind.view.mindmapview.NodeView rootView;

    private freemind.view.mindmapview.MapView.Selected selected = new freemind.view.mindmapview.MapView.Selected();

    private freemind.controller.Controller controller;

    private float zoom = 1F;

    private boolean disableMoveCursor = true;

    private int siblingMaxLevel;

    private boolean isPrinting = false;

    private freemind.view.mindmapview.NodeView shiftSelectionOrigin = null;

    private int maxNodeWidth = 0;

    private java.awt.Color background = null;

    private java.awt.Rectangle boundingRectangle = null;

    private boolean fitToPage = true;

    private boolean isPreparedForPrinting = false;

    private java.util.Vector ArrowLinkViews;

    public MapView( freemind.modes.MindMap model, freemind.controller.Controller controller )
    {
        super();
        this.model = model;
        this.controller = controller;
        if (logger == null) {
            logger = controller.getFrame().getLogger( this.getClass().getName() );
        }
        this.setAutoscrolls( true );
        getModel().addTreeModelListener( new freemind.view.mindmapview.MapView.MapModelHandler() );
        this.setLayout( new freemind.view.mindmapview.MindMapLayout( this ) );
        initRoot();
        setBackground( getModel().getBackgroundColor() );
        addMouseListener( controller.getMapMouseMotionListener() );
        addMouseMotionListener( controller.getMapMouseMotionListener() );
        addMouseWheelListener( controller.getMapMouseWheelListener() );
        setFocusTraversalKeys( KeyboardFocusManager.FORWARD_TRAVERSAL_KEYS, Collections.EMPTY_SET );
        setFocusTraversalKeys( KeyboardFocusManager.BACKWARD_TRAVERSAL_KEYS, Collections.EMPTY_SET );
        setFocusTraversalKeys( KeyboardFocusManager.UP_CYCLE_TRAVERSAL_KEYS, Collections.EMPTY_SET );
        disableMoveCursor = Tools.safeEquals( controller.getProperty( "disable_cursor_move_paper" ), "true" );
    }

    public void initRoot()
    {
        rootView = NodeView.newNodeView( (freemind.modes.MindMapNode) getModel().getRoot(), this );
        rootView.insert();
        getMindMapLayout().updateTreeHeightsAndRelativeYOfWholeMap();
        revalidate();
    }

    public int getMaxNodeWidth()
    {
        if (maxNodeWidth == 0) {
            try {
                maxNodeWidth = Integer.parseInt( controller.getProperty( "max_node_width" ) );
            } catch ( java.lang.NumberFormatException e ) {
                maxNodeWidth = Integer.parseInt( controller.getProperty( "el__max_default_window_width" ) );
            }
        }
        return maxNodeWidth;
    }

    public void centerNode( freemind.view.mindmapview.NodeView node )
    {
        javax.swing.JViewport viewPort = (javax.swing.JViewport) getParent();
        java.awt.Dimension d = viewPort.getExtentSize();
        if (!isValid()) {
            final java.awt.Rectangle r0 = new java.awt.Rectangle( 0, 0, d.width, d.height );
            scrollRectToVisible( r0 );
        }
        java.awt.Rectangle rect = new java.awt.Rectangle( node.getLocation().x + node.getPreferredSize().width / 2 - d.width / 2, node.getLocation().y + node.getPreferredSize().height / 2 - d.height / 2, d.width, d.height );
        scrollRectToVisible( rect );
    }

    public void scrollNodeToVisible( freemind.view.mindmapview.NodeView node )
    {
        scrollNodeToVisible( node, 0 );
    }

    public void scrollNodeToVisible( freemind.view.mindmapview.NodeView node, int extraWidth )
    {
        if (!node.isValid()) {
            m_delayedScroller.scrollNodeToVisible( this, node, extraWidth );
            return;
        }
        m_delayedScroller.deactivate();
        final int HORIZ_SPACE = 10;
        final int HORIZ_SPACE2 = 20;
        final int VERT_SPACE = 5;
        final int VERT_SPACE2 = 10;
        int x = node.getX();
        int width = node.getWidth();
        if (extraWidth < 0) {
            x += extraWidth;
            width -= extraWidth;
        } else {
            width += extraWidth;
        }
        int y = node.getY();
        int height = node.getHeight();
        if (node != null) {
            javax.swing.JViewport mapViewport = (javax.swing.JViewport) getParent();
            int viewPortScrollMode = mapViewport.getScrollMode();
            mapViewport.setScrollMode( JViewport.SIMPLE_SCROLL_MODE );
            scrollRectToVisible( new java.awt.Rectangle( x - HORIZ_SPACE, node.getLocation().y - VERT_SPACE, width + HORIZ_SPACE2, node.getSize().height + VERT_SPACE2 ) );
            mapViewport.setScrollMode( viewPortScrollMode );
        }
    }

    public java.awt.Dimension getViewportSize()
    {
        javax.swing.JViewport mapViewport = (javax.swing.JViewport) getParent();
        return mapViewport == null ? null : mapViewport.getExtentSize();
    }

    public void scrollBy( int x, int y, boolean repaint )
    {
        javax.swing.JViewport mapViewport = (javax.swing.JViewport) getParent();
        if (mapViewport != null) {
            java.awt.Point currentPoint = mapViewport.getViewPosition();
            currentPoint.translate( x, y );
            if (currentPoint.getX() < 0) {
                currentPoint.setLocation( 0, currentPoint.getY() );
            }
            if (currentPoint.getY() < 0) {
                currentPoint.setLocation( currentPoint.getX(), 0 );
            }
            double maxX = getSize().getWidth() - mapViewport.getExtentSize().getWidth();
            double maxY = getSize().getHeight() - mapViewport.getExtentSize().getHeight();
            if (currentPoint.getX() > maxX) {
                currentPoint.setLocation( maxX, currentPoint.getY() );
            }
            if (currentPoint.getY() > maxY) {
                currentPoint.setLocation( currentPoint.getX(), maxY );
            }
            int oldScrollMode = mapViewport.getScrollMode();
            if (repaint) {
                mapViewport.setScrollMode( JViewport.SIMPLE_SCROLL_MODE );
            }
            mapViewport.setViewPosition( currentPoint );
            if (repaint) {
                mapViewport.setScrollMode( oldScrollMode );
            }
        }
    }

    private freemind.view.mindmapview.NodeView getNeighbour( int directionCode )
    {
        freemind.view.mindmapview.NodeView oldSelected = getSelected();
        freemind.view.mindmapview.NodeView newSelected = null;
        switch (directionCode) {
        case KeyEvent.VK_LEFT :
            setSiblingMaxLevel( oldSelected.getModel().getNodeLevel() );
            if (oldSelected.isRoot()) {
                java.util.LinkedList left = ((freemind.view.mindmapview.RootNodeView) oldSelected).getLeft();
                if (left.size() == 0) {
                    return null;
                }
                newSelected = oldSelected.getModel().getPreferredChild().getViewer();
                if (!left.contains( newSelected )) {
                    newSelected = (freemind.view.mindmapview.NodeView) left.getFirst();
                }
            } else {
                if (!oldSelected.isLeft()) {
                    newSelected = oldSelected.getParentView();
                } else {
                    if (oldSelected.getModel().isFolded()) {
                        getController().getModeController().setFolded( oldSelected.getModel(), false );
                        return null;
                    }
                    if (oldSelected.getChildrenViews().size() == 0) {
                        return null;
                    }
                    newSelected = oldSelected.getModel().getPreferredChild().getViewer();
                }
            }
            setSiblingMaxLevel( newSelected.getModel().getNodeLevel() );
            break;

        case KeyEvent.VK_RIGHT :
            setSiblingMaxLevel( oldSelected.getModel().getNodeLevel() );
            if (oldSelected.isRoot()) {
                java.util.LinkedList right = ((freemind.view.mindmapview.RootNodeView) oldSelected).getRight();
                if (right.size() == 0) {
                    return null;
                }
                newSelected = oldSelected.getModel().getPreferredChild().getViewer();
                if (!right.contains( newSelected )) {
                    newSelected = (freemind.view.mindmapview.NodeView) right.getFirst();
                }
            } else {
                if (oldSelected.isLeft()) {
                    newSelected = oldSelected.getParentView();
                } else {
                    if (oldSelected.getModel().isFolded()) {
                        getController().getModeController().setFolded( oldSelected.getModel(), false );
                        return null;
                    }
                    if (oldSelected.getChildrenViews().size() == 0) {
                        return null;
                    }
                    newSelected = oldSelected.getModel().getPreferredChild().getViewer();
                }
            }
            setSiblingMaxLevel( newSelected.getModel().getNodeLevel() );
            break;

        case KeyEvent.VK_UP :
            newSelected = oldSelected.getPreviousSibling();
            break;

        case KeyEvent.VK_DOWN :
            newSelected = oldSelected.getNextSibling();
            break;

        case KeyEvent.VK_PAGE_UP :
            newSelected = oldSelected.getPreviousPage();
            break;

        case KeyEvent.VK_PAGE_DOWN :
            newSelected = oldSelected.getNextPage();
            break;

        }
        return newSelected;
    }

    public void move( java.awt.event.KeyEvent e )
    {
        freemind.view.mindmapview.NodeView newSelected = getNeighbour( e.getKeyCode() );
        if (newSelected != null) {
            extendSelectionWithKeyMove( newSelected, e );
            scrollNodeToVisible( newSelected );
            e.consume();
        }
    }

    private void extendSelectionWithKeyMove( freemind.view.mindmapview.NodeView newlySelectedNodeView, java.awt.event.KeyEvent e )
    {
        if (e.isShiftDown()) {
            if (e.getKeyCode() == KeyEvent.VK_LEFT || e.getKeyCode() == KeyEvent.VK_RIGHT) {
                shiftSelectionOrigin = null;
                freemind.view.mindmapview.NodeView toBeNewSelected = newlySelectedNodeView.isParentOf( getSelected() ) ? newlySelectedNodeView : getSelected();
                selectBranch( toBeNewSelected, false );
                makeTheSelected( toBeNewSelected );
                return;
            }
            if (shiftSelectionOrigin == null) {
                shiftSelectionOrigin = getSelected();
            }
            int deltaY = newlySelectedNodeView.getY() - shiftSelectionOrigin.getY();
            freemind.view.mindmapview.NodeView currentSelected = getSelected();
            if (e.getKeyCode() == KeyEvent.VK_PAGE_UP) {
                for (;;) {
                    if (currentSelected.getY() > shiftSelectionOrigin.getY()) {
                        deselect( currentSelected );
                    } else {
                        makeTheSelected( currentSelected );
                    }
                    if (currentSelected.getY() <= newlySelectedNodeView.getY()) {
                        break;
                    }
                    currentSelected = currentSelected.getPreviousSibling();
                }
                return;
            }
            if (e.getKeyCode() == KeyEvent.VK_PAGE_DOWN) {
                for (;;) {
                    if (currentSelected.getY() < shiftSelectionOrigin.getY()) {
                        deselect( currentSelected );
                    } else {
                        makeTheSelected( currentSelected );
                    }
                    if (currentSelected.getY() >= newlySelectedNodeView.getY()) {
                        break;
                    }
                    currentSelected = currentSelected.getNextSibling();
                }
                return;
            }
            boolean enlargingMove = deltaY > 0 && e.getKeyCode() == KeyEvent.VK_DOWN || deltaY < 0 && e.getKeyCode() == KeyEvent.VK_UP;
            if (enlargingMove) {
                toggleSelected( newlySelectedNodeView );
            } else {
                toggleSelected( getSelected() );
                makeTheSelected( newlySelectedNodeView );
            }
        } else {
            shiftSelectionOrigin = null;
            selectAsTheOnlyOneSelected( newlySelectedNodeView );
        }
    }

    public void moveToRoot()
    {
        selectAsTheOnlyOneSelected( getRoot() );
        centerNode( getRoot() );
    }

    public void selectAsTheOnlyOneSelected( freemind.view.mindmapview.NodeView newSelected )
    {
        java.util.LinkedList oldSelecteds = getSelecteds();
        this.selected.clear();
        this.selected.add( newSelected );
        newSelected.requestFocus();
        if (newSelected.getModel().getParentNode() != null) {
            newSelected.getModel().getParentNode().setPreferredChild( newSelected.getModel() );
        }
        scrollNodeToVisible( newSelected );
        newSelected.repaint();
        for (java.util.ListIterator e = oldSelecteds.listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView oldSelected = (freemind.view.mindmapview.NodeView) e.next();
            if (oldSelected != null) {
                oldSelected.repaint();
            }
        }
    }

    public void toggleSelected( freemind.view.mindmapview.NodeView newSelected )
    {
        freemind.view.mindmapview.NodeView oldSelected = getSelected();
        if (isSelected( newSelected )) {
            if (selected.size() > 1) {
                selected.remove( newSelected );
                oldSelected = newSelected;
            }
        } else {
            selected.add( newSelected );
        }
        getSelected().requestFocus();
        getSelected().repaint();
        if (oldSelected != null) {
            oldSelected.repaint();
        }
    }

    public void makeTheSelected( freemind.view.mindmapview.NodeView newSelected )
    {
        if (isSelected( newSelected )) {
            selected.moveToFirst( newSelected );
        } else {
            selected.add( newSelected );
        }
        getSelected().requestFocus();
        getSelected().repaint();
    }

    public void deselect( freemind.view.mindmapview.NodeView newSelected )
    {
        if (isSelected( newSelected )) {
            selected.remove( newSelected );
            newSelected.repaint();
        }
    }

    public void selectBranch( freemind.view.mindmapview.NodeView newlySelectedNodeView, boolean extend )
    {
        if (!extend) {
            selectAsTheOnlyOneSelected( newlySelectedNodeView );
        } else {
            if (!isSelected( newlySelectedNodeView )) {
                toggleSelected( newlySelectedNodeView );
            }
        }
        for (java.util.ListIterator e = newlySelectedNodeView.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            selectBranch( target, true );
        }
    }

    public boolean selectContinuous( freemind.view.mindmapview.NodeView newSelected )
    {
        freemind.view.mindmapview.NodeView oldSelected = null;
        java.util.LinkedList selList = getSelecteds();
        java.util.ListIterator j = selList.listIterator();
        while (j.hasNext()) {
            freemind.view.mindmapview.NodeView selectedNode = (freemind.view.mindmapview.NodeView) j.next();
            if (selectedNode != newSelected && newSelected.isSiblingOf( selectedNode )) {
                oldSelected = selectedNode;
                break;
            }
        }
        if (oldSelected == null) {
            if (!isSelected( newSelected )) {
                toggleSelected( newSelected );
                return true;
            }
            return false;
        }
        boolean oldPositionLeft = oldSelected.isLeft();
        boolean newPositionLeft = newSelected.isLeft();
        java.util.ListIterator i = newSelected.getSiblingViews().listIterator();
        while (i.hasNext()) {
            freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) i.next();
            if (nodeView == oldSelected) {
                break;
            }
        }
        java.util.ListIterator i_backup = i;
        while (i.hasNext()) {
            freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) i.next();
            if (nodeView.isLeft() == oldPositionLeft || nodeView.isLeft() == newPositionLeft) {
                if (isSelected( nodeView )) {
                    deselect( nodeView );
                } else {
                    break;
                }
            }
        }
        i = i_backup;
        if (i.hasPrevious()) {
            i.previous();
            while (i.hasPrevious()) {
                freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) i.previous();
                if (nodeView.isLeft() == oldPositionLeft || nodeView.isLeft() == newPositionLeft) {
                    if (isSelected( nodeView )) {
                        deselect( nodeView );
                    } else {
                        break;
                    }
                }
            }
        }
        i = newSelected.getSiblingViews().listIterator();
        i = newSelected.getSiblingViews().listIterator();
        while (i.hasNext()) {
            freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) i.next();
            if (nodeView == newSelected || nodeView == oldSelected) {
                if (!isSelected( nodeView )) {
                    toggleSelected( nodeView );
                }
                break;
            }
        }
        while (i.hasNext()) {
            freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) i.next();
            if ((nodeView.isLeft() == oldPositionLeft || nodeView.isLeft() == newPositionLeft) && !isSelected( nodeView )) {
                toggleSelected( nodeView );
            }
            if (nodeView == newSelected || nodeView == oldSelected) {
                break;
            }
        }
        toggleSelected( oldSelected );
        toggleSelected( oldSelected );
        return true;
    }

    public freemind.modes.MindMap getModel()
    {
        return model;
    }

    public void setMoveCursor( boolean isHand )
    {
        int requiredCursor = isHand && !disableMoveCursor ? Cursor.MOVE_CURSOR : Cursor.DEFAULT_CURSOR;
        if (getCursor().getType() != requiredCursor) {
            setCursor( new java.awt.Cursor( requiredCursor ) );
        }
    }

    freemind.controller.NodeMouseMotionListener getNodeMouseMotionListener()
    {
        return getController().getNodeMouseMotionListener();
    }

    freemind.controller.NodeMotionListener getNodeMotionListener()
    {
        return getController().getNodeMotionListener();
    }

    freemind.controller.NodeKeyListener getNodeKeyListener()
    {
        return getController().getNodeKeyListener();
    }

    java.awt.dnd.DragGestureListener getNodeDragListener()
    {
        return getController().getNodeDragListener();
    }

    java.awt.dnd.DropTargetListener getNodeDropListener()
    {
        return getController().getNodeDropListener();
    }

    public freemind.view.mindmapview.NodeView getSelected()
    {
        if (selected.size() > 0) {
            return (freemind.view.mindmapview.NodeView) selected.get( 0 );
        } else {
            return null;
        }
    }

    private freemind.view.mindmapview.NodeView getSelected( int i )
    {
        return (freemind.view.mindmapview.NodeView) selected.get( i );
    }

    public java.util.LinkedList getSelecteds()
    {
        java.util.LinkedList result = new java.util.LinkedList();
        for (int i = 0; i < selected.size(); i++) {
            result.add( getSelected( i ) );
        }
        return result;
    }

    public java.util.ArrayList getSelectedsSortedByY()
    {
        java.util.TreeMap sortedNodes = new java.util.TreeMap();
        for (int i = 0; i < selected.size(); i++) {
            sortedNodes.put( new java.lang.Integer( getSelected( i ).getY() ), getSelected( i ) );
        }
        java.util.ArrayList selectedNodes = new java.util.ArrayList();
        for (java.util.Iterator it = sortedNodes.entrySet().iterator(); it.hasNext();) {
            selectedNodes.add( ((java.util.Map.Entry) it.next()).getValue() );
        }
        return selectedNodes;
    }

    public java.util.ArrayList getSelectedNodesSortedByY()
    {
        java.util.TreeMap sortedNodes = new java.util.TreeMap();
        for (int i = 0; i < selected.size(); i++) {
            sortedNodes.put( new java.lang.Integer( getSelected( i ).getY() ), getSelected( i ).getModel() );
        }
        java.util.ArrayList selectedNodes = new java.util.ArrayList();
        for (java.util.Iterator it = sortedNodes.entrySet().iterator(); it.hasNext();) {
            selectedNodes.add( ((java.util.Map.Entry) it.next()).getValue() );
        }
        return selectedNodes;
    }

    public boolean isSelected( freemind.view.mindmapview.NodeView n )
    {
        if (isPrinting) {
            return false;
        }
        return selected.contains( n );
    }

    public float getZoom()
    {
        return zoom;
    }

    public int getZoomed( int number )
    {
        return (int) (number * zoom);
    }

    public void setZoom( float zoom )
    {
        this.zoom = zoom;
        getRoot().updateAll();
        getMindMapLayout().updateTreeHeightsAndRelativeYOfWholeMap();
        getMindMapLayout().layout( true );
        repaint();
    }

    public void paintChildren( java.awt.Graphics graphics )
    {
        paintClouds( rootView, graphics );
        java.util.HashMap labels = new java.util.HashMap();
        ArrowLinkViews = new java.util.Vector();
        collectLabels( rootView, labels );
        paintLinks( rootView, (java.awt.Graphics2D) graphics, labels, null );
        super.paintChildren( graphics );
        paintEdges( rootView, (java.awt.Graphics2D) graphics );
    }

    protected void paintClouds( freemind.view.mindmapview.NodeView source, java.awt.Graphics graphics )
    {
        for (java.util.ListIterator e = source.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            if (target.getModel().getCloud() != null) {
                freemind.view.mindmapview.CloudView cloud = new freemind.view.mindmapview.CloudView( target.getModel().getCloud(), target );
                cloud.paint( graphics );
            }
            paintClouds( target, graphics );
        }
    }

    protected void collectLabels( freemind.view.mindmapview.NodeView source, java.util.HashMap labels )
    {
        if (getModel().getLinkRegistry() == null) {
            return;
        }
        java.lang.String label = getModel().getLinkRegistry().getLabel( source.getModel() );
        if (label != null) {
            labels.put( label, source );
        }
        for (java.util.ListIterator e = source.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            collectLabels( target, labels );
        }
    }

    protected void paintLinks( freemind.view.mindmapview.NodeView source, java.awt.Graphics2D graphics, java.util.HashMap labels, java.util.HashSet LinkAlreadyVisited )
    {
        if (getModel().getLinkRegistry() == null) {
            return;
        }
        if (LinkAlreadyVisited == null) {
            LinkAlreadyVisited = new java.util.HashSet();
        }
        java.util.Vector vec = getModel().getLinkRegistry().getAllLinks( source.getModel() );
        for (int i = 0; i < vec.size(); ++i) {
            freemind.modes.MindMapLink ref = (freemind.modes.MindMapLink) vec.get( i );
            if (LinkAlreadyVisited.add( ref )) {
                if (ref instanceof freemind.modes.MindMapArrowLink) {
                    freemind.view.mindmapview.ArrowLinkView arrowLink = new freemind.view.mindmapview.ArrowLinkView( (freemind.modes.MindMapArrowLink) ref, ref.getSource().getViewer(), ref.getTarget().getViewer() );
                    arrowLink.paint( graphics );
                    ArrowLinkViews.add( arrowLink );
                    java.awt.Rectangle rec = arrowLink.getBounds();
                }
            }
        }
        for (java.util.ListIterator e = source.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            paintLinks( target, graphics, labels, LinkAlreadyVisited );
        }
    }

    public freemind.modes.MindMapArrowLink detectCollision( java.awt.Point p )
    {
        if (ArrowLinkViews == null) {
            return null;
        }
        for (int i = 0; i < ArrowLinkViews.size(); ++i) {
            freemind.view.mindmapview.ArrowLinkView arrowView = (freemind.view.mindmapview.ArrowLinkView) ArrowLinkViews.get( i );
            if (arrowView.detectCollision( p )) {
                return arrowView.getModel();
            }
        }
        return null;
    }

    public void preparePrinting()
    {
        _preparePrinting();
        isPreparedForPrinting = true;
    }

    private void _preparePrinting()
    {
        if (isPreparedForPrinting == false) {
            isPrinting = true;
            setZoom( getZoom() );
            background = getBackground();
            boundingRectangle = getInnerBounds( rootView );
        }
    }

    public void endPrinting()
    {
        isPreparedForPrinting = false;
        _endPrinting();
    }

    private void _endPrinting()
    {
        if (isPreparedForPrinting == false) {
            setBackground( background );
            isPrinting = false;
            setZoom( getZoom() );
            fitToPage = Tools.safeEquals( controller.getProperty( "fit_to_page" ), "true" );
        }
    }

    public int print( java.awt.Graphics graphics, java.awt.print.PageFormat pageFormat, int pageIndex )
    {
        double userZoomFactor = 1;
        try {
            userZoomFactor = Double.parseDouble( controller.getProperty( "user_zoom" ) );
        } catch ( java.lang.Exception e ) {
        }
        userZoomFactor = Math.max( 0, userZoomFactor );
        userZoomFactor = Math.min( 2, userZoomFactor );
        if (fitToPage && pageIndex > 0) {
            return Printable.NO_SUCH_PAGE;
        }
        java.awt.Graphics2D graphics2D = (java.awt.Graphics2D) graphics;
        _preparePrinting();
        double zoomFactor = 1;
        if (fitToPage) {
            double zoomFactorX = pageFormat.getImageableWidth() / boundingRectangle.getWidth();
            double zoomFactorY = pageFormat.getImageableHeight() / boundingRectangle.getHeight();
            zoomFactor = Math.min( zoomFactorX, zoomFactorY );
        } else {
            zoomFactor = userZoomFactor;
            int nrPagesInWidth = (int) Math.ceil( zoomFactor * boundingRectangle.getWidth() / pageFormat.getImageableWidth() );
            int nrPagesInHeight = (int) Math.ceil( zoomFactor * boundingRectangle.getHeight() / pageFormat.getImageableHeight() );
            if (pageIndex >= nrPagesInWidth * nrPagesInHeight) {
                return Printable.NO_SUCH_PAGE;
            }
            int yPageCoord = (int) Math.floor( pageIndex / nrPagesInWidth );
            int xPageCoord = pageIndex - yPageCoord * nrPagesInWidth;
            graphics2D.translate( -pageFormat.getImageableWidth() * xPageCoord, -pageFormat.getImageableHeight() * yPageCoord );
        }
        graphics2D.translate( pageFormat.getImageableX(), pageFormat.getImageableY() );
        graphics2D.scale( zoomFactor, zoomFactor );
        graphics2D.translate( -boundingRectangle.getX(), -boundingRectangle.getY() );
        print( graphics2D );
        _endPrinting();
        return Printable.PAGE_EXISTS;
    }

    public boolean isCurrentlyPrinting()
    {
        return isPrinting;
    }

    public java.awt.Dimension getPreferredSize()
    {
        return getLayout().preferredLayoutSize( this );
    }

    public java.awt.Rectangle getInnerBounds( freemind.view.mindmapview.NodeView source )
    {
        java.awt.Rectangle innerBounds = source.getBounds();
        for (java.util.ListIterator e = source.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            innerBounds.add( getInnerBounds( target ) );
        }
        int additionalCloudHeigth = (source.getAdditionalCloudHeigth() + 1) / 2;
        if (additionalCloudHeigth != 0) {
            innerBounds.grow( additionalCloudHeigth, additionalCloudHeigth );
        }
        if (source.getModel().isRoot()) {
            for (int i = 0; i < ArrowLinkViews.size(); ++i) {
                freemind.view.mindmapview.ArrowLinkView arrowView = (freemind.view.mindmapview.ArrowLinkView) ArrowLinkViews.get( i );
                java.awt.Rectangle arrowViewBigBounds = arrowView.arrowLinkCurve.getBounds();
                if (!innerBounds.contains( arrowViewBigBounds )) {
                    java.awt.Rectangle arrowViewBounds = PathBBox.getBBox( arrowView.arrowLinkCurve ).getBounds();
                    innerBounds.add( arrowViewBounds );
                }
            }
        }
        return innerBounds;
    }

    private void paintEdges( freemind.view.mindmapview.NodeView source, java.awt.Graphics2D g )
    {
        for (java.util.ListIterator e = source.getChildrenViews().listIterator(); e.hasNext();) {
            freemind.view.mindmapview.NodeView target = (freemind.view.mindmapview.NodeView) e.next();
            target.getEdge().paint( g );
            paintEdges( target, g );
        }
    }

    protected freemind.view.mindmapview.NodeView getRoot()
    {
        return rootView;
    }

    private freemind.view.mindmapview.MindMapLayout getMindMapLayout()
    {
        return (freemind.view.mindmapview.MindMapLayout) getLayout();
    }

    private freemind.view.mindmapview.MapView getMap()
    {
        return this;
    }

    public freemind.controller.Controller getController()
    {
        return controller;
    }

    private class MapModelHandler implements javax.swing.event.TreeModelListener
    {

        public void treeNodesChanged( javax.swing.event.TreeModelEvent e )
        {
            setBackground( getModel().getBackgroundColor() );
            freemind.view.mindmapview.NodeView nodeView;
            try {
                nodeView = ((freemind.modes.MindMapNode) e.getChildren()[0]).getViewer();
            } catch ( java.lang.Exception ex ) {
                nodeView = ((freemind.modes.MindMapNode) e.getTreePath().getLastPathComponent()).getViewer();
            }
            if (nodeView != null) {
                logger.finest( "The update node is " + nodeView + " with treemodelevent=" + e );
                nodeView.update();
                getMindMapLayout().updateTreeHeightsAndRelativeYOfDescendantsAndAncestors( nodeView );
                getMindMapLayout().layout( true );
                repaint();
            }
        }

        public void treeNodesInserted( javax.swing.event.TreeModelEvent e )
        {
            freemind.modes.MindMapNode parent = (freemind.modes.MindMapNode) e.getTreePath().getLastPathComponent();
            freemind.view.mindmapview.NodeView parentView = parent.getViewer();
            freemind.modes.MindMapNode child = (freemind.modes.MindMapNode) e.getChildren()[0];
            if (child != null) {
                parentView.insert( child );
                getMindMapLayout().updateTreeGeometry( child.getViewer() );
            }
            getMindMapLayout().updateTreeHeightsAndRelativeYOfAncestors( parentView );
            getMindMapLayout().layout( false );
            child.getViewer().requestFocus();
            repaint();
        }

        public void treeNodesRemoved( javax.swing.event.TreeModelEvent e )
        {
            freemind.view.mindmapview.NodeView node = ((freemind.modes.MindMapNode) e.getChildren()[0]).getViewer();
            freemind.view.mindmapview.NodeView parent = ((freemind.modes.MindMapNode) e.getTreePath().getLastPathComponent()).getViewer();
            if (node == null) {
                System.err.println( "MapView.treeNodesRemoved tried to delete null as node." );
                return;
            }
            node.remove();
            freemind.modes.MindMapNode preferred = parent.getModel().getPreferredChild();
            if (preferred != null) {
                selectAsTheOnlyOneSelected( preferred.getViewer() );
            } else {
                selectAsTheOnlyOneSelected( parent );
            }
            getMindMapLayout().updateTreeHeightsAndRelativeYOfAncestors( parent );
            getMindMapLayout().layout( false );
            getSelected().requestFocus();
            repaint();
        }

        public void treeStructureChanged( javax.swing.event.TreeModelEvent e )
        {
            java.util.ArrayList selectedNodes = new java.util.ArrayList();
            for (java.util.ListIterator it = getSelecteds().listIterator(); it.hasNext();) {
                freemind.view.mindmapview.NodeView nodeView = (freemind.view.mindmapview.NodeView) it.next();
                if (nodeView != null) {
                    selectedNodes.add( nodeView.getModel() );
                }
            }
            freemind.modes.MindMapNode focussedNode = null;
            if (getSelected() != null) {
                focussedNode = getSelected().getModel();
            }
            freemind.modes.MindMapNode subtreeRoot = (freemind.modes.MindMapNode) e.getTreePath().getLastPathComponent();
            if (subtreeRoot == null || subtreeRoot.getViewer() == null) {
            } else {
                boolean nodeIsLeft = subtreeRoot.getViewer().isLeft();
                freemind.view.mindmapview.NodeView oldNodeView = subtreeRoot.getViewer();
                int x = oldNodeView.getX();
                int y = oldNodeView.getY();
                subtreeRoot.getViewer().remove();
                freemind.view.mindmapview.NodeView nodeView = null;
                if (subtreeRoot.isRoot()) {
                    nodeView = NodeView.newNodeView( getRoot().getModel(), getMap() );
                    rootView = nodeView;
                } else {
                    nodeView = NodeView.newNodeView( subtreeRoot, getMap() );
                }
                nodeView.setLocation( x, y );
                nodeView.setLeft( nodeIsLeft );
                nodeView.insert();
                getMindMapLayout().updateTreeHeightsAndRelativeYOfDescendantsAndAncestors( subtreeRoot.getViewer() );
            }
            selected.clear();
            for (java.util.ListIterator it = selectedNodes.listIterator(); it.hasNext();) {
                freemind.modes.MindMapNode mindMapNode = (freemind.modes.MindMapNode) it.next();
                if (mindMapNode.getViewer() != null) {
                    selected.add( mindMapNode.getViewer() );
                }
            }
            if (focussedNode == null) {
                focussedNode = getRoot().getModel();
            }
            while (focussedNode.getParentNode() != null && focussedNode.getViewer() == null) {
                focussedNode = focussedNode.getParentNode();
            }
            if (focussedNode.getParentNode() == null) {
                if (!focussedNode.equals( getRoot().getModel() )) {
                    focussedNode = getRoot().getModel();
                }
            }
            focussedNode.getViewer().requestFocus();
            repaint();
        }

    }

    public int getSiblingMaxLevel()
    {
        return this.siblingMaxLevel;
    }

    public void setSiblingMaxLevel( int level )
    {
        this.siblingMaxLevel = level;
    }

    private int FOLDING_SYMBOL_WIDTH = -1;

    public int getZoomedFoldingSymbolHalfWidth()
    {
        if (FOLDING_SYMBOL_WIDTH == -1) {
            FOLDING_SYMBOL_WIDTH = getController().getIntProperty( "foldingsymbolwidth", 8 );
        }
        return (int) (FOLDING_SYMBOL_WIDTH * getZoom() / 2);
    }

}
